var Collections;
(function (Collections) {
    var List = /** @class */ (function () {
        function List() {
            // Mark these as public, so when we want to iterate we don't have to call the index function everytime.
            // (for performance reasons)
            this.array = [];
            this.object = {};
        }
        List.prototype.item = function (index) {
            return this.array[index];
        };
        List.prototype.key = function (key) {
            return this.object[key];
        };
        Object.defineProperty(List.prototype, "length", {
            get: function () {
                return this.array.length;
            },
            enumerable: true,
            configurable: true
        });
        List.prototype.add = function (key, value) {
            this.array.push(value);
            this.object[key] = value;
        };
        List.prototype.forEach = function (callback) {
            this.array.forEach(callback);
        };
        return List;
    }());
    Collections.List = List;
})(Collections || (Collections = {}));
