/// <reference path="index.ts" />
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var AppConfig = /** @class */ (function () {
    function AppConfig() {
    }
    AppConfig.getMetaSource = function () {
        return __awaiter(this, void 0, void 0, function () {
            var metasource;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.getItem("metasource")];
                    case 1:
                        metasource = _a.sent();
                        if (metasource) {
                            return [2 /*return*/, Promise.resolve(metasource.toLowerCase())];
                        }
                        return [2 /*return*/, Promise.resolve(AppConfig.getDefaultConfigValue("metasource", "iam"))];
                }
            });
        });
    };
    AppConfig.setMetaSource = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.setItem("metasource", value)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AppConfig.getMetaServiceURL = function () {
        return __awaiter(this, void 0, void 0, function () {
            var server;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!AppConfig.hideConfiguration) return [3 /*break*/, 2];
                        return [4 /*yield*/, Utils.Preferences.getItem("server")];
                    case 1:
                        server = _a.sent();
                        if (server) {
                            return [2 /*return*/, Promise.resolve(server)];
                        }
                        _a.label = 2;
                    case 2: 
                    //If configuration is hidden, we'll always use the customConfig server value. TCP 53302.
                    return [2 /*return*/, Promise.resolve(AppConfig.getDefaultConfigValue("server", ""))];
                }
            });
        });
    };
    AppConfig.setMetaServiceURL = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.setItem("server", value)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(AppConfig, "appName", {
        get: function () {
            return AppConfig.getDefaultConfigValue("name", "");
        },
        enumerable: true,
        configurable: true
    });
    AppConfig.getProject = function () {
        return __awaiter(this, void 0, void 0, function () {
            var proj;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.getItem("project")];
                    case 1:
                        proj = _a.sent();
                        if (proj) {
                            return [2 /*return*/, Promise.resolve(proj)];
                        }
                        return [2 /*return*/, Promise.resolve(AppConfig.getDefaultConfigValue("project", ""))];
                }
            });
        });
    };
    AppConfig.setProject = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.setItem("project", value)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AppConfig.getProjectVrs = function () {
        return __awaiter(this, void 0, void 0, function () {
            var projVrs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.getItem("projectVrs")];
                    case 1:
                        projVrs = _a.sent();
                        if (projVrs) {
                            return [2 /*return*/, Promise.resolve(projVrs)];
                        }
                        return [2 /*return*/, Promise.resolve(AppConfig.getDefaultConfigValue("projectVrs", ""))];
                }
            });
        });
    };
    AppConfig.setProjectVrs = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.setItem("projectVrs", value)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AppConfig.getConfiguration = function () {
        return __awaiter(this, void 0, void 0, function () {
            var conf;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.getItem("configuration")];
                    case 1:
                        conf = _a.sent();
                        if (conf) {
                            return [2 /*return*/, Promise.resolve(conf)];
                        }
                        return [2 /*return*/, Promise.resolve(AppConfig.getDefaultConfigValue("configuration", null))];
                }
            });
        });
    };
    AppConfig.setConfiguration = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.setItem("configuration", value)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AppConfig.getDownloadFiles = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _b = (_a = Promise).resolve;
                        _d = (_c = Utils).convertToBoolean;
                        return [4 /*yield*/, Utils.Preferences.getItem("downloadFiles")];
                    case 1: return [2 /*return*/, _b.apply(_a, [_d.apply(_c, [_e.sent(), AppConfig.getDefaultConfigValue("downloadFiles", false)])])];
                }
            });
        });
    };
    AppConfig.setDownloadFiles = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.setItem("downloadFiles", value.toString())];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(AppConfig, "showOfflineIndicator", {
        get: function () {
            return AppConfig.getDefaultConfigValue("showOfflineIndicator", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "defaultAuthenticationTimeout", {
        get: function () {
            return AppConfig.getDefaultConfigValue("defaultAuthenticationTimeout", 20000);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "defaultRequestTimeout", {
        get: function () {
            return AppConfig.getDefaultConfigValue("defaultRequestTimeout", 20000);
        },
        enumerable: true,
        configurable: true
    });
    AppConfig.getForceOfflineLogic = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _b = (_a = Promise).resolve;
                        _d = (_c = Utils).convertToBoolean;
                        return [4 /*yield*/, Utils.Preferences.getItem("forceOfflineLogic")];
                    case 1: return [2 /*return*/, _b.apply(_a, [_d.apply(_c, [_e.sent(), AppConfig.getDefaultConfigValue("forceOfflineLogic", false)])])];
                }
            });
        });
    };
    AppConfig.setForceOfflineLogic = function (value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.setItem("forceOfflineLogic", value.toString())];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(AppConfig, "pageSize", {
        get: function () {
            return AppConfig.getDefaultConfigValue("pageSize", 100);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "defaultLanguage", {
        get: function () {
            return AppConfig.getDefaultConfigValue("defaultLanguage", "NL");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "showClearbuttons", {
        get: function () {
            return AppConfig.getDefaultConfigValue("showclearbuttons", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "foregroundSyncByLogin", {
        get: function () {
            return AppConfig.getDefaultConfigValue("foregroundSyncByLogin", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "sendUsernameCapitalized", {
        get: function () {
            return AppConfig.getDefaultConfigValue("sendUsernameCapitalized", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "compressImages", {
        get: function () {
            return AppConfig.getDefaultConfigValue("compressImages", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "enableResetPassword", {
        get: function () {
            return AppConfig.getDefaultConfigValue("enableResetPassword", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "enableChangePassword", {
        get: function () {
            return AppConfig.getDefaultConfigValue("enableChangePassword", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "language", {
        get: function () {
            if (!AppConfig.defaultTranslations) {
                AppConfig.defaultTranslations = new Model.Language(AppConfig.defaultLanguage);
            }
            return AppConfig.defaultTranslations;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "online", {
        get: function () {
            return AppConfig._online;
        },
        set: function (value) {
            var throwEvent = (AppConfig._online != value);
            AppConfig._online = value;
            if (throwEvent) {
                jQuery(document).trigger("tsfOnline");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "allowStaySignedIn", {
        get: function () {
            return AppConfig.getDefaultConfigValue("allowStaySignedIn", true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "allowStaySignedCheckDeviceSecurity", {
        get: function () {
            return AppConfig.getDefaultConfigValue("allowStaySignedCheckDeviceSecurity", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "hideConfiguration", {
        get: function () {
            return AppConfig.getDefaultConfigValue("hideConfiguration", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "inactivityTimeout", {
        get: function () {
            return AppConfig.getDefaultConfigValue("inactivityTimeout", 0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "staySignedInDisablesInactivityTimeout", {
        get: function () {
            return AppConfig.getDefaultConfigValue("staySignedInDisablesInactivityTimeout", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "enableSecurity", {
        get: function () {
            return AppConfig.getDefaultConfigValue("enableSecurity", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "fixesForHandscanners", {
        get: function () {
            return AppConfig.getDefaultConfigValue("fixesForHandscanners", false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfig, "domainPrefix", {
        get: function () {
            //Put the backslash at the end of the prefix if the domainPrefix is configured.
            var domainPrefix = AppConfig.getDefaultConfigValue("domainPrefix", null);
            return domainPrefix !== null ? domainPrefix + "\\" : domainPrefix;
        },
        enumerable: true,
        configurable: true
    });
    AppConfig.initializeCustomCode = function () {
        var codeIndex = typeof customCodeIndex !== "undefined" ? customCodeIndex : null;
        if (codeIndex && codeIndex["js"]) {
            var jsCode = codeIndex["js"];
            for (var i = 0; i < jsCode.length; i++) {
                var script = document.createElement("script");
                script.src = jsCode[i].file;
                document.head.appendChild(script);
            }
        }
    };
    AppConfig.getDefaultConfigValue = function (key, defaultValue) {
        var config = window.customerConfig;
        if (config) {
            var value = config[key];
            if (value !== undefined) {
                return value;
            }
        }
        return defaultValue;
    };
    AppConfig.invalidGuiVersion = "invalid_gui_version";
    AppConfig.sync_error = "sync_error";
    AppConfig.skip_stale_sync = "skip_stale_sync";
    // Fall back to online when the navigator was actually undefined
    // Because this is static cordova might not have shimmed it yet
    AppConfig._online = navigator.onLine !== undefined ? navigator.onLine : true;
    return AppConfig;
}());
jQuery(document).on("pagebeforecreate", "#config", function (evt) {
    var language = AppConfig.language;
    $("label[for='metasource']").text(language.transl(Model.TranslKeys.metasource) + ":");
    $("label[for='metaserver']").text(language.transl(Model.TranslKeys.metaserverUrl) + ":");
    $("label[for='server']").text(language.transl(Model.TranslKeys.serverUrl) + ":");
    $("label[for='project']").text(language.transl(Model.TranslKeys.project) + ":");
    $("label[for='projectVrs']").text(language.transl(Model.TranslKeys.projectVrs) + ":");
    $("label[for='configuration']").text(language.transl(Model.TranslKeys.configuration) + ":");
    $("label[for='downloadFiles']").text(language.transl(Model.TranslKeys.downloadFiles) + ":");
    $("label[for='forceofflinelogic']").text(language.transl(Model.TranslKeys.forceOfflineLogic) + ":");
    $("legend.syncLegend").text(language.transl(Model.TranslKeys.synchronize) + ":");
    $("button.clearCache").text(language.transl(Model.TranslKeys.clearCache));
    var versionNumber = window.tsfVersionNumber;
    if (versionNumber) {
        $("p.versionNumber").text(versionNumber);
    }
});
jQuery(document).on('pageinit', '#config', function () {
    var $this = jQuery(this);
    new ConfigScreen($this);
    if (AppConfig.hideConfiguration) {
        $this.find(".ui-field-contain").css('display', 'none');
    }
    $this.on("focus", "input", function (e) {
        jQuery(this).parent().siblings('label').addClass("label_control_focused");
    }).on("focusout", "input", function (e) {
        jQuery(this).parent().siblings('label').removeClass("label_control_focused");
    });
});
var ConfigScreen = /** @class */ (function () {
    function ConfigScreen(page) {
        var _this = this;
        this.page = page;
        this.metasourceSlider = page.find("#metasource");
        this.metaServerTextBox = page.find("#metaserver");
        this.projectTextBox = page.find("#project");
        this.projectVrsTextbox = page.find("#projectVrs");
        this.configurationTextbox = page.find("#configuration");
        this.downloadFilesSlider = page.find("#downloadFiles");
        this.forceOfflineLogicSlider = page.find("#forceofflinelogic");
        this.setValuesFromStorage();
        var header = page.children("div[data-role='header']");
        var footer = page.children("div[data-role='footer']");
        header.find("h1").text(AppConfig.language.transl(Model.TranslKeys.settings));
        // Set black or white icon for the back button.
        var backButton = jQuery(header).find('a.back-button');
        Utils.SetIconBlackOrWhite(backButton, Utils.Color.hexToColor(jQuery(backButton).css("color")));
        page.on("pagebeforehide", function () { return __awaiter(_this, void 0, void 0, function () {
            var oldUrl, hasManager;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                    case 1:
                        oldUrl = _a.sent();
                        return [4 /*yield*/, AppConfig.setMetaSource(this.metasourceSlider.val())];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, AppConfig.setMetaServiceURL(this.metaServerTextBox.val())];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, AppConfig.setProject(this.projectTextBox.val())];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, AppConfig.setProjectVrs(this.projectVrsTextbox.val())];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, AppConfig.setConfiguration(this.configurationTextbox.val())];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, AppConfig.setDownloadFiles(this.downloadFilesSlider.prop("checked"))];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, AppConfig.setForceOfflineLogic(this.forceOfflineLogicSlider.prop("checked"))];
                    case 8:
                        _a.sent();
                        hasManager = Model.TSFApplicationManager.hasApplicationManager;
                        if (hasManager) {
                            Model.TSFApplicationManager.Current.dispose(true);
                        }
                        if (oldUrl !== this.metaServerTextBox.val()) {
                            //If navigator.onLine is false then we're offline. Otherwise we assume we're initially online.
                            //If we'd check for navigator.onLine === true then we wouldn't handle browsers without support for navigator.onLine.
                            switchOnlineMode(navigator.onLine !== false);
                            StyleSheetGenerator.resetLayout();
                        }
                        return [2 /*return*/];
                }
            });
        }); });
        // Make sure that the height of the main div is set. Otherwise scrolling on iOS doesn't work.
        if (!Utils.isAndroidTwo()) {
            page.one("pageshow", function () {
                var height = window.innerHeight;
                height -= header.outerHeight() + footer.outerHeight();
                page.find(".content-panel").css('height', height + 'px');
            });
        }
        jQuery(".clearCache").click(function () {
            var language = AppConfig.language;
            var promise = ConfirmationPopup.CreateYesNoPopup().initialize(language.transl(Model.TranslKeys.clearCache), language.transl(Model.TranslKeys.clearCache) + "?");
            promise.done(function (option) { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                var tmp, loadedAppls, resolveList, appl;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(option === Enum.ConfirmationOption.Yes)) return [3 /*break*/, 2];
                            StyleSheetGenerator.resetLayout();
                            return [4 /*yield*/, Utils.Preferences.getItem(BaseModelReader.savedObjectModelsKey)];
                        case 1:
                            tmp = _a.sent();
                            loadedAppls = tmp ? Utils.deserializeJSON(tmp) : {};
                            resolveList = [];
                            for (appl in loadedAppls) {
                                resolveList.push(IndexedDb.deleteDatabasePromise(appl));
                            }
                            resolveList.push(IndexedDb.deleteDatabasePromise(TSFCache.cacheDatabase));
                            jQuery.when.apply(undefined, resolveList).then(function () { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, Utils.PasswordEncryption.removePassword()];
                                        case 1:
                                            _a.sent();
                                            return [4 /*yield*/, Utils.Preferences.clear()];
                                        case 2:
                                            _a.sent();
                                            // Because this is async, we might already have been moven away from the page.
                                            // Make sure the page is still a "mobile-page"
                                            if (this.page.data("mobile-page")) {
                                                this.setValuesFromStorage();
                                            }
                                            return [2 /*return*/];
                                    }
                                });
                            }); });
                            jQuery("#username, #password").val("");
                            Logger.log(Model.TranslKeys.clearCache, LogType.LOG);
                            Raven.captureBreadcrumb({
                                message: Model.TranslKeys.clearCache,
                                category: "action"
                            });
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            }); });
        });
        this.metasourceSlider.change(function () {
            _this.hideOrShowServer(_this.metasourceSlider.val());
        });
    }
    ConfigScreen.prototype.setValuesFromStorage = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
            return __generator(this, function (_t) {
                switch (_t.label) {
                    case 0:
                        _b = (_a = this.metasourceSlider).val;
                        return [4 /*yield*/, AppConfig.getMetaSource()];
                    case 1:
                        _b.apply(_a, [_t.sent()]).flipswitch("refresh");
                        _d = (_c = this.metaServerTextBox).val;
                        return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                    case 2:
                        _d.apply(_c, [_t.sent()]);
                        _e = this.hideOrShowServer;
                        return [4 /*yield*/, AppConfig.getMetaSource()];
                    case 3:
                        _e.apply(this, [_t.sent()]);
                        _g = (_f = this.projectTextBox).val;
                        return [4 /*yield*/, AppConfig.getProject()];
                    case 4:
                        _g.apply(_f, [_t.sent()]);
                        _j = (_h = this.projectVrsTextbox).val;
                        return [4 /*yield*/, AppConfig.getProjectVrs()];
                    case 5:
                        _j.apply(_h, [_t.sent()]);
                        _l = (_k = this.configurationTextbox).val;
                        return [4 /*yield*/, AppConfig.getConfiguration()];
                    case 6:
                        _l.apply(_k, [_t.sent()]);
                        _o = (_m = this.downloadFilesSlider).prop;
                        _p = ["checked"];
                        return [4 /*yield*/, AppConfig.getDownloadFiles()];
                    case 7:
                        _o.apply(_m, _p.concat([_t.sent()])).flipswitch("refresh");
                        _r = (_q = this.forceOfflineLogicSlider).prop;
                        _s = ["checked"];
                        return [4 /*yield*/, AppConfig.getForceOfflineLogic()];
                    case 8:
                        _r.apply(_q, _s.concat([_t.sent()])).flipswitch("refresh");
                        return [2 /*return*/];
                }
            });
        });
    };
    ConfigScreen.prototype.hideOrShowServer = function (metaSource) {
        if (metaSource === "sf") {
            this.projectTextBox.closest(".ui-field-contain").show();
            this.projectVrsTextbox.closest(".ui-field-contain").show();
            this.configurationTextbox.closest(".ui-field-contain").show();
        }
        else {
            this.projectTextBox.closest(".ui-field-contain").hide();
            this.projectVrsTextbox.closest(".ui-field-contain").hide();
            this.configurationTextbox.closest(".ui-field-contain").hide();
        }
    };
    return ConfigScreen;
}());
