// To use this, just include debug.js from your index.html
(function () {
    function spyOn(prototype, methodName, log, errorLog) {
        if (!prototype[methodName]) {
            console.log("Method does not exist");
        }
        if (!log) {
            log = function (fullname, duration, async) {
                console.log("Call to " + fullname + " took " + duration + " milliseconds " + (async ? "(ASYNC)" : ""));
            };
        }
        if (!errorLog) {
            errorLog = function (fullname, instance, args, error) {
                Logger.log("Error detected from spyOn function: Calling " + fullname + " " + error.stack, LogType.ERROR);
            };
        }
        var timeMethod;
        if (window.performance && window.performance.now) {
            timeMethod = function () { return window.performance.now(); };
        }
        else {
            timeMethod = function () { return new Date().getTime(); };
        }
        var original = prototype[methodName];
        var constructorName = /function (\w*)/g.exec(prototype.constructor.toString())[1];
        var fullName = [constructorName, methodName].join(".");
        prototype[methodName] = function () {
            var instance = this;
            var args = arguments;
            var start = timeMethod();
            var returnValue;
            try {
                returnValue = original.apply(instance, arguments);
            }
            catch (error) {
                errorLog(fullName, instance, args, error);
                throw error;
            }
            if (returnValue && returnValue.promise && returnValue.always) {
                returnValue.always(function () {
                    var end = timeMethod();
                    log(fullName, (end - start), true, instance, args);
                });
            }
            else {
                var end = timeMethod();
                log(fullName, (end - start), false, instance, args);
            }
            return returnValue;
        };
        return {
            reset: function () {
                prototype[methodName] = original;
            }
        };
    }
    spyOn(TSFController.prototype, "initialize");
    spyOn(TSFController.prototype, "executeLayouts", function (fullname, duration, async, instance, args) {
        Logger.log("Call to " + fullname + " took " + duration + " milliseconds; " + instance.obj.objId, LogType.LOG);
    });
    spyOn(TSFController.prototype, "executeDefaults", function (fullname, duration, async, instance, args) {
        Logger.log("Call to " + fullname + " took " + duration + " milliseconds; " + instance.obj.objId, LogType.LOG);
    });
    spyOn(TSFController.prototype, "executeContexts", function (fullname, duration, async, instance, args) {
        Logger.log("Call to " + fullname + " took " + duration + " milliseconds; " + instance.obj.objId, LogType.LOG);
    });
    spyOn(TSFForm.prototype, "build");
    spyOn(ListView.prototype, "appendGridData");
    spyOn(IndexedDb.IndexedDbWrapper.prototype, "executeQuery", function (fullname, duration, async, instance, args) {
        console.log("Query " + args[0].serviceId + ":" + duration);
    });
})();
