var RequestBuilderFactory;
(function (RequestBuilderFactory) {
    function createRequestBuilder(application, objView) {
        if (AppConfig.online && !objView.offlineAvailable) {
            return RequestBuilderFactory.createOnlineRequestBuilder(application, objView);
        }
        else {
            return new IndexedDb.RequestBuilder(application, objView);
        }
    }
    RequestBuilderFactory.createRequestBuilder = createRequestBuilder;
    function createOnlineRequestBuilder(application, objView) {
        return new OData.RequestBuilder(application, objView.objId);
    }
    RequestBuilderFactory.createOnlineRequestBuilder = createOnlineRequestBuilder;
    function createOnlineRequestBuilderFromQuery(application, query) {
        return OData.RequestBuilder.fromTSFQuery(application, query);
    }
    RequestBuilderFactory.createOnlineRequestBuilderFromQuery = createOnlineRequestBuilderFromQuery;
})(RequestBuilderFactory || (RequestBuilderFactory = {}));
var OnlineClientFactory;
(function (OnlineClientFactory) {
    function createClient(url, username, password) {
        return new OData.ODataClient(url, username, password);
    }
    OnlineClientFactory.createClient = createClient;
})(OnlineClientFactory || (OnlineClientFactory = {}));
