var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
window.onerror = function (msg, uri, lineno, columno, error) {
    var path = jQuery.mobile.path.parseUrl(uri);
    if (path) {
        uri = path["filename"];
    }
    var application = Model.TSFApplicationManager.Current.activeAppl;
    var language = application != null ? application.language : AppConfig.language;
    var confirmPopup = ConfirmationPopup.CreateOkPopup();
    // Do not show the Raven message when the user is offline, because the message tells the user 'the team has been notified'
    // which isn't the case
    if (typeof Raven !== "undefined" && AppConfig.online) {
        confirmPopup.initialize(language.transl(Model.TranslKeys.errorDialogTitle), language.transl(Model.TranslKeys.errorDialogMessage) + Raven.lastEventId());
    }
    else {
        confirmPopup.initialize(language.transl(Model.TranslKeys.errorDialogTitle), msg + " " + uri + " " + lineno + ":" + columno);
    }
    Utils.tryRavenCaptureException(error, msg, uri, lineno, columno);
    return false;
};
var switchOnlineMode;
(function () {
    // variable to make sure the promise event is only added once per change.
    var eventAdded = false;
    // variable to remember the last status. We want to fire the event with the last status, not the value when the
    // function is attached to the promise.
    var newOnlineStatus = true;
    switchOnlineMode = function (online) {
        return __awaiter(this, void 0, void 0, function () {
            var request, _a, _b, _c, appl_1, promise;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!Utils.isElectron()) return [3 /*break*/, 2];
                        request = new XMLHttpRequest();
                        _b = (_a = request).open;
                        _c = ['GET'];
                        return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                    case 1:
                        _b.apply(_a, _c.concat([_d.sent(), true]));
                        request.onload = function () {
                            AppConfig.online = true; //No matter what the status code is, we know it is reachable;
                        };
                        request.onerror = function (err) {
                            AppConfig.online = false;
                        };
                        request.send();
                        return [3 /*break*/, 3];
                    case 2:
                        // Always update this variable; if we go from offline to online, back to offline the status didn't actually change
                        // But the event was added so this new status needs to be uptodate
                        newOnlineStatus = online;
                        if (AppConfig.online != online) {
                            appl_1 = Model.TSFApplicationManager.Current.activeAppl;
                            if (appl_1) {
                                if (!online) {
                                    // localsync might not exists when the client database isn't initialized yet.
                                    if (appl_1.localSync) {
                                        appl_1.localSync.stopLocalSyncInterval();
                                    }
                                    AppConfig.online = online;
                                }
                                eventAdded = true;
                                promise = appl_1.waitForEditmode();
                                promise.done(function () {
                                    // we can't use the online property here, because multiple online/offline events might have fired.
                                    // Also, we only want to switch once!
                                    if (eventAdded) {
                                        eventAdded = false;
                                        AppConfig.online = newOnlineStatus;
                                        appl_1.doOnlineSwitch(newOnlineStatus).done(function () {
                                            // localsync might not exists when the client database isn't initialized yet.
                                            if (appl_1.localSync) {
                                                appl_1.localSync.startLocalSyncInterval();
                                            }
                                        });
                                    }
                                });
                            }
                            else {
                                AppConfig.online = online;
                            }
                        }
                        _d.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
})();
function setLastLoadedLayout() {
    var deferred = jQuery.Deferred();
    StyleSheetGenerator.loadLastLoadedLayout()
        .then(function (style) {
        if (style) {
            var page = jQuery("#login");
            Utils.addFooterPicture(style, page.find(".content-panel"));
            var footer = page.children("div[data-role='footer']");
            var configButton = footer.find("a.config");
            // Correct color after last loaded layout;
            // should be similar with the pageshow for the #login
            Utils.SetIconBlackOrWhite(footer, Utils.Color.hexToColor(configButton.css("color")));
        }
        deferred.resolve();
    }).catch(deferred.reject);
    return deferred.promise();
}
document.addEventListener("deviceready", function () {
    var headerHeight = jQuery.mobile.activePage.children(".ui-header").outerHeight();
    var footerHeight = jQuery.mobile.activePage.children(".ui-footer").innerHeight();
    // Note: We could use navigator.device.version but we don't have phonegap device plugin.
    // Also, sniffing is really bad, but currently there is no other way to fix the header on iOS7
    var iOSVersion = Utils.getiOSVersion();
    if (iOSVersion !== null) {
        if (typeof window["cordova"] !== undefined) {
            // We are on iOS with a storage quota around 50MB, so we upgrade it with a plugin to 250MB
            try {
                var updateQuotaPlugin = window["cordova"].require("com.thinkwisesoftware.update-quota.updateQuota");
                updateQuotaPlugin.updateStorageQuota(250 * 1024 * 1024);
            }
            catch (error) { }
            try {
                if (AppConfig.enableSecurity) {
                    var blurScreenshot = window.cordova.require("com.thinkwisesoftware.blur-screenshot.blurScreenshot");
                    blurScreenshot.enableSecurity();
                }
            }
            catch (error) { }
            try {
                // TCP 34082 - This plugin fixes a issue on some screens from vdi where clicking the statusbar would break the gui
                // We haven't really figured out why it is the case - it has something to do with -webkit-overflow-scrolling: touch;
                // without it, it doesn't seem to crash anymore
                // The plugin doesn't completely fix it though but makes it a lot harder
                var fixWebview = window["cordova"].require("com.thinkwisesoftware.fix-webview.fixWebview");
                fixWebview.fixWebview();
            }
            catch (error) {
            }
        }
        if (iOSVersion >= 7) {
            jQuery(document.body).addClass("ios7");
            // Recalculate headerHeight because the ios7 css does something with the header for the time/battery icons
            headerHeight = jQuery.mobile.activePage.children(".ui-header").outerHeight();
        }
        if (iOSVersion >= 7.1 && typeof Keyboard !== "undefined") {
            var windowHeight_1 = window.innerHeight;
            Keyboard.onhiding = function () {
                var footer = jQuery.mobile.activePage.children(".ui-footer");
                footer.css('top', (windowHeight_1 - footerHeight) + "px");
            };
            Keyboard.onhide = Keyboard.onshow = function () {
                var page = jQuery.mobile.activePage;
                var newHeight = window.innerHeight;
                var data = { handled: false, headerHeight: headerHeight, height: newHeight, footerHeight: footerHeight };
                page.trigger("updatePanelsHeight", data);
                if (!data.handled) {
                    newHeight -= headerHeight;
                    if (jQuery.mobile.activePage.children(".ui-footer").length > 0) {
                        newHeight -= footerHeight;
                    }
                    // Scroll fix for iOS, simular to the one in form.js
                    var contentPanel_1 = jQuery.mobile.activePage.find(".content-panel");
                    var oldHeight = contentPanel_1.height();
                    var childHeight_1 = 0;
                    contentPanel_1.children().each(function () {
                        childHeight_1 += jQuery(this).outerHeight();
                    });
                    contentPanel_1.css('height', newHeight + 'px');
                    if (!oldHeight || (newHeight < childHeight_1 && childHeight_1 < oldHeight)) {
                        contentPanel_1.css('overflow', 'hidden');
                        window.setTimeout(function () {
                            contentPanel_1.css('overflow', 'auto');
                        }, 0);
                    }
                }
                // Use top instead of bottom, because bottom isn't always right on iOS.
                // We need to set the height or it will become higher due to the css-bottom: -1
                // Change to position absolute, because safari now sometimes doesn't show the footer
                // if you change the top position by moving it slightly higher (4px) than it is visible again
                // but now you have the 4px whitespace :/
                page.children(".ui-footer").css({
                    position: "absolute",
                    top: (window.innerHeight - footerHeight) + "px",
                    height: footerHeight + "px"
                });
            };
            jQuery(document).on('pageshow', '#login', function () {
                // I know this is lame but when you login with the keyboard open (or press options on the login page) the footer needs a reset
                jQuery(this).children(".ui-footer").css({
                    "top": "",
                    "position": ""
                });
            });
        }
    }
    setLastLoadedLayout().always(function () {
        navigator.splashscreen.hide();
    });
    var pressBackButton = function (page) {
        var popup = jQuery(":jqmData(role='popup')");
        if (popup.length > 0) {
            popup.popup("close");
        }
        else {
            // Press the backbutton if there is one on the page and isnt disabled or hidden.
            page.find(".back-button:not(.ui-state-disabled, .ui-screen-hidden)").click();
        }
    };
    // Register backbutton event, so we can exit the application from the login screen
    // this is needed when the user presses the logout button and then presses the backbutton.
    document.addEventListener("backbutton", function (evt) {
        var page = jQuery.mobile.activePage;
        // Don't allow the use of the back button when the loader is showing
        if (jQuery(".ui-loader").is(":visible")) {
            return false;
        }
        if (page.is("#login")) {
            var nav = window.navigator;
            // Check if methods exists
            if (typeof nav.app !== "undefined" && typeof nav.app.exitApp !== "undefined") {
                evt.preventDefault();
                nav.app.exitApp();
            }
        }
        else {
            pressBackButton(page);
        }
    }, false);
}, false);
jQuery(document).ready(function () {
    window.addEventListener("online", function () { return switchOnlineMode(true); });
    window.addEventListener("offline", function () { return switchOnlineMode(false); });
    if (Utils.isElectron()) {
        var ipcRenderer_1 = require("electron").ipcRenderer;
        //Open devtools on F12 press
        document.addEventListener("keydown", function (e) {
            if (e.which === 123) {
                ipcRenderer_1.send("open-devtools");
            }
        });
        ipcRenderer_1.on("is-in-debug-mode", function () {
            Model.TSFApplicationManager.isDebug = true;
        });
        ipcRenderer_1.on("set-custom-config", function (event, config) {
            customerConfig = config;
            switchOnlineMode(null);
        });
        Mousetrap.bind("ctrl+f5", function () {
            if (Model.TSFApplicationManager.isDebug) {
                Model.TSFApplicationManager.Current.refreshObjectModelFromAnywhere();
            }
        });
        switchOnlineMode(null);
    }
    if (TSFScroll.useNativeScroll()) {
        TSFScroll.setNativeScrollingCSS();
    }
    var iOSVersion = Utils.getiOSVersion();
    // Trigger updatePanelsHeight on the page after a throttledresize on the window.
    jQuery(window).on("throttledresize.screen", function () {
        // Disable resize or it might close the keyboard on android 2.3 if it falls
        // under the keyboard. Listview/Form fix this for themselves so we enable it for abstractscreen
        if (Utils.isAndroidTwo() && !jQuery.mobile.activePage.is("#abstractscreen")) {
            return;
        }
        // Don't cache the headerHeight, we make it higher for iOS7 for the battery in the deviceready event
        var headerHeight = jQuery.mobile.activePage.children(".ui-header").outerHeight();
        var newHeight = window.innerHeight;
        var footerHeight = jQuery.mobile.activePage.children(".ui-footer").outerHeight();
        var data = { handled: false, headerHeight: headerHeight, height: newHeight, footerHeight: footerHeight };
        jQuery.mobile.activePage.trigger("updatePanelsHeight", data);
        if (!data.handled) {
            newHeight -= headerHeight;
            if (jQuery.mobile.activePage.children(".ui-footer").length > 0) {
                newHeight -= footerHeight;
            }
            // Scroll fix for iOS, simular to the one in form.js
            var contentPanel_2 = jQuery.mobile.activePage.find(".content-panel");
            if (iOSVersion != null && iOSVersion >= 7.1) {
                var oldHeight = contentPanel_2.height();
                var childHeight_2 = 0;
                contentPanel_2.children().each(function () {
                    childHeight_2 += jQuery(this).outerHeight();
                });
                contentPanel_2.css('height', newHeight + 'px');
                if (!oldHeight || (newHeight < childHeight_2 && childHeight_2 < oldHeight)) {
                    contentPanel_2.css('overflow', 'hidden');
                    window.setTimeout(function () {
                        contentPanel_2.css('overflow', 'auto');
                    }, 0);
                }
            }
            else {
                contentPanel_2.css('height', newHeight + 'px');
            }
        }
        // Reset the footer since the top is based on the previous size.
        if (iOSVersion != null && iOSVersion >= 7.1) {
            jQuery.mobile.activePage.children(".ui-footer").css({
                position: "absolute",
                top: (window.innerHeight - footerHeight) + "px",
                height: footerHeight + "px"
            });
        }
    });
});
jQuery(document).on("pagebeforeshow", "#login", function () {
    return __awaiter(this, void 0, void 0, function () {
        var staySignedIn, $staySignedIn_1, footer, configButton, multiPanelScreen, $usernameInput, domainPrefix;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!AppConfig.allowStaySignedIn) return [3 /*break*/, 3];
                    $staySignedIn_1 = jQuery("#stay-signed-in");
                    if (!Utils.isElectron()) return [3 /*break*/, 2];
                    return [4 /*yield*/, Utils.Preferences.getItem("stay-signed-in")];
                case 1:
                    staySignedIn = _a.sent();
                    $staySignedIn_1.prop("checked", staySignedIn).checkboxradio("refresh");
                    return [3 /*break*/, 3];
                case 2:
                    document.addEventListener("deviceready", function () {
                        return __awaiter(this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, Utils.Preferences.getItem("stay-signed-in")];
                                    case 1:
                                        staySignedIn = _a.sent();
                                        if (!AppConfig.allowStaySignedCheckDeviceSecurity) {
                                            $staySignedIn_1.prop("checked", staySignedIn).checkboxradio("refresh");
                                        }
                                        else {
                                            if (window["cordova"] && window["cordova"].plugins.PinCheck) {
                                                window["cordova"].plugins.PinCheck.isPinSetup(function () {
                                                    $staySignedIn_1.prop("checked", staySignedIn).checkboxradio("refresh");
                                                }, function () {
                                                    return __awaiter(this, void 0, void 0, function () {
                                                        var $notAllowedToStaySignedIn;
                                                        return __generator(this, function (_a) {
                                                            switch (_a.label) {
                                                                case 0:
                                                                    $notAllowedToStaySignedIn = jQuery("#not-allowed-to-stay-signed-in");
                                                                    $notAllowedToStaySignedIn.text(AppConfig.language.transl(Model.TranslKeys.staySignedInNotAllowed));
                                                                    $notAllowedToStaySignedIn.show();
                                                                    return [4 /*yield*/, Utils.Preferences.setItem("stay-signed-in", "false")];
                                                                case 1:
                                                                    _a.sent();
                                                                    $staySignedIn_1.prop("checked", false).checkboxradio("disable").checkboxradio("refresh");
                                                                    return [2 /*return*/];
                                                            }
                                                        });
                                                    });
                                                });
                                            }
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        });
                    });
                    _a.label = 3;
                case 3:
                    footer = jQuery("div[data-role='footer']");
                    configButton = footer.find("a.config"), multiPanelScreen = window.matchMedia("(min-width: 800px)").matches;
                    if (multiPanelScreen) {
                        configButton.text(AppConfig.language.transl(Model.TranslKeys.settings));
                        configButton.removeClass("ui-btn-icon-notext").addClass("ui-btn-icon-left");
                    }
                    else {
                        configButton.removeClass("ui-btn-icon-left").addClass("ui-btn-icon-notext");
                    }
                    // Make config icon black or white first time mobile gui starts.
                    Utils.SetIconBlackOrWhite(footer, Utils.Color.hexToColor(configButton.css("color")));
                    $usernameInput = jQuery("#login #username");
                    if (!staySignedIn) {
                        domainPrefix = AppConfig.domainPrefix;
                        if (domainPrefix !== null && $usernameInput.val() === "") {
                            $usernameInput.val(domainPrefix);
                        }
                    }
                    return [2 /*return*/];
            }
        });
    });
});
jQuery(window).on("orientationchange", function (event) {
    var controlGroup = jQuery("div[data-role='footer'], div[data-role='header']").find(":jqmData(role='controlgroup')");
    if (event.orientation === "portrait") {
        controlGroup.find("a, button").removeClass("ui-btn-icon-left").addClass("ui-btn-icon-notext");
    }
    else {
        controlGroup.find("a, button").removeClass("ui-btn-icon-notext").addClass("ui-btn-icon-left");
    }
});
jQuery(document).on("pagebeforecreate", function () {
    var controlGroup = jQuery("div[data-role='footer'], div[data-role='header']").find(":jqmData(role='controlgroup')");
    var multiPanelScreen = window.matchMedia("(min-width: 800px)").matches;
    if (multiPanelScreen) {
        controlGroup.find("a, button").removeClass("ui-btn-icon-notext");
    }
    else {
        controlGroup.find("a, button").removeClass("ui-btn-icon-left");
    }
});
jQuery(document).on("pagecreate", "#maintenance, #synchronize, #config, #synclog, #parameterPage, #twoFactorValidation", function () {
    var appl = Model.TSFApplicationManager.Current.activeAppl, language = appl ? appl.language : AppConfig.language;
    var controlGroup = jQuery(this).children("div[data-role='header']").find(":jqmData(role='controlgroup')");
    controlGroup.find("a.back-button").text(language.transl(Model.TranslKeys.back));
});
jQuery(document).on('pagebeforeshow', function (e) {
    var page = jQuery.mobile.activePage;
    var isSyncing = false;
    var appl = Model.TSFApplicationManager.Current.activeAppl;
    if (appl && appl.localSync) {
        isSyncing = appl.localSync.IsSyncing();
    }
    Utils.editSyncImage(page, isSyncing);
    // First remove the event, to make sure it is only added once.
    Utils.editOnlineImage(page);
    jQuery(document).off("tsfOnline").on("tsfOnline", function (e) {
        Utils.editOnlineImage(page);
    });
    jQuery(document).off("tsfSync").on("tsfSync", function (evt, syncing) {
        Utils.editSyncImage(page, syncing);
    });
});
jQuery(document).on('pagebeforeshow', "#abstractscreen, #maintenance, #synchronize, #menu, #parameterPage, #synclog", function (e) {
    var page = jQuery.mobile.activePage;
    var application = Model.TSFApplicationManager.Current.activeAppl;
    if (!application || !application.model) {
        Logger.log("Application model is corrupted", LogType.ERROR);
        return;
    }
    var infoPanel = page.children(".info-panel");
    createInfoPanel(infoPanel, application);
    // TODO: e shouldn't be any but strong typed.
    page.on("swiperight", function (e) {
        if (e.swipestart.coords[0] < 50) {
            infoPanel.panel("open");
        }
    });
    infoPanel.on("panelbeforeopen", function (e) {
        var onlineText = infoPanel.find(".onlineText");
        // Display online in green and offline in red.
        if (AppConfig.online) {
            onlineText.text("Online");
            onlineText.removeClass("offline").addClass("online");
        }
        else {
            onlineText.text("Offline");
            onlineText.removeClass("online").addClass("offline");
        }
        // Display the unsynced queue.
        application.serverSync.getUnsyncedAmount().done(function (unsyncedAmount) {
            infoPanel.find(".pending-changes").text(unsyncedAmount);
        });
        var versionInfo = infoPanel.find(".version-info");
        // When this menu is already opened this info is already there
        if (versionInfo.children().length == 0) {
            var fragment = document.createDocumentFragment();
            var versionSpan = document.createElement("p");
            versionSpan.innerText = application.language.transl(Model.TranslKeys.version) + ": " + window.tsfVersionNumber;
            fragment.appendChild(versionSpan);
            var applHeader = document.createElement("p");
            applHeader.className = "applications";
            applHeader.innerText = application.language.transl(Model.TranslKeys.applications);
            fragment.appendChild(applHeader);
            var appls = Model.TSFApplicationManager.Current.appls;
            for (var i = 0; i < appls.length; i++) {
                var applSpan = document.createElement("p");
                applSpan.innerText = appls[i].projectName + " - " + appls[i].projectVersion;
                fragment.appendChild(applSpan);
            }
            versionInfo.append(fragment);
        }
    });
    // Set all icons in the footer black or white.
    var footer = jQuery('[data-role="footer"]');
    var color = Utils.Color.hexToColor(footer.find("a").first().css("color"));
    Utils.SetIconBlackOrWhite(footer, color);
});
function createInfoPanel($infoPanel, application) {
    return __awaiter(this, void 0, void 0, function () {
        var infoPanelInner, dlElem, dlInnerElements, versionInfoElem, refreshObjectModelBtn;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    infoPanelInner = document.createElement("div");
                    infoPanelInner.className = "ui-panel-inner";
                    dlElem = document.createElement("dl");
                    dlInnerElements = [{
                            labelText: application.language.transl(Model.TranslKeys.connection),
                            className: "onlineText"
                        }, {
                            labelText: application.language.transl(Model.TranslKeys.offlineQueue),
                            className: "pending-changes"
                        }];
                    dlInnerElements.forEach(function (dlInnerElem) {
                        var infoLabel = document.createElement("dt");
                        infoLabel.textContent = dlInnerElem.labelText + ":";
                        var infoElem = document.createElement("dd");
                        infoElem.className = dlInnerElem.className;
                        dlElem.appendChild(infoLabel);
                        dlElem.appendChild(infoElem);
                    });
                    versionInfoElem = document.createElement("div");
                    versionInfoElem.className = "version-info";
                    infoPanelInner.appendChild(dlElem);
                    infoPanelInner.appendChild(versionInfoElem);
                    return [4 /*yield*/, AppConfig.getMetaSource()];
                case 1:
                    if ((_a.sent()) === "sf" || Model.TSFApplicationManager.isDebug) {
                        refreshObjectModelBtn = document.createElement("a");
                        refreshObjectModelBtn.textContent = application.language.transl(Model.TranslKeys.refreshObjectModel);
                        refreshObjectModelBtn.href = "#";
                        refreshObjectModelBtn.className = "ui-btn";
                        refreshObjectModelBtn.setAttribute("data-role", "button");
                        refreshObjectModelBtn.onclick = function () {
                            Model.TSFApplicationManager.Current.refreshObjectModelFromAnywhere();
                        };
                        infoPanelInner.appendChild(refreshObjectModelBtn);
                    }
                    $infoPanel.append(infoPanelInner);
                    return [2 /*return*/];
            }
        });
    });
}
if (typeof window["cordova"] === "undefined") {
    // Prevent backspace only for the viewer
    // Wrap block in a closure, so we don't polute the global namespace but still have the ability to cache the regex.
    (function () {
        var re = /input|textarea|select/;
        document.addEventListener("keydown", function (evt) {
            if (evt.keyCode == 8) {
                var target = evt.target, tagName = target.tagName.toLowerCase();
                // Check for readonly/disabled props, because backspace on a readonly input navigates backward.
                // Don't preventDefault for enabled inputs, (you can't remove characters if you do).
                if ((!target.isContentEditable && !re.test(tagName)) || target["readOnly"] || target["disabled"]) {
                    evt.preventDefault();
                }
            }
        }, false);
    })();
}
jQuery(document).on('pageinit', '#login', function () {
    if (typeof window["cordova"] === "undefined") {
        setLastLoadedLayout();
    }
    if (!AppConfig.allowStaySignedIn) {
        var element = document.getElementById("stay-signed-in");
        if (element) {
            element.parentElement.style.display = "none";
        }
    }
    var login = new Login(this);
    // Wait for pageshow event, or the submit handler isn't bound yet.
    login.page.on("pageshow", function () {
        Utils.PasswordEncryption.initialize().always(function () {
            login.initialize();
        });
    });
    var $forgotPassword = jQuery(".forgot-password");
    if (AppConfig.enableResetPassword) {
        $forgotPassword.css("display", "inline-block").text(AppConfig.language.transl(Model.TranslKeys.forgotPassword));
        $forgotPassword.click(function () {
            NavigationManager.navigate("changePassword.html", {
                data: {
                    action: "resetPassword"
                }
            });
            return false;
        });
    }
});
var Login = /** @class */ (function () {
    function Login(element) {
        this.page = jQuery(element);
        this.language = AppConfig.language;
        this.usernameInput = jQuery("#username", element);
        this.passwordInput = jQuery("#password", element);
        this.staySignedInInput = jQuery("#stay-signed-in", element);
    }
    Login.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var that, form, handleSubmit, _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        that = this, form = that.page.find("form");
                        form.find(".username-label").text(that.language.transl(Model.TranslKeys.user) + ":");
                        form.find(".password-label").text(that.language.transl(Model.TranslKeys.password) + ":");
                        form.find(".login-button").text(that.language.transl(Model.TranslKeys.login));
                        form.find(".ui-checkbox label").text(that.language.transl(Model.TranslKeys.staySignedIn));
                        Utils.fixResizeOnFocus(form);
                        handleSubmit = function () {
                            form.off('submit.login');
                            if (document.activeElement && document.activeElement.blur) {
                                document.activeElement.blur();
                            }
                            that.submitLogin().then(function () { return __awaiter(_this, void 0, void 0, function () {
                                var _a, _b, _c;
                                return __generator(this, function (_d) {
                                    switch (_d.label) {
                                        case 0:
                                            Utils.hideLoader();
                                            return [4 /*yield*/, AppConfig.getMetaSource()];
                                        case 1:
                                            // Log session after login.
                                            if ((_d.sent()) === "iam") {
                                                Model.TSFApplicationManager.Current.setGuiStartUseLogSession();
                                            }
                                            //Re-enable the form handler and config button
                                            form.on("submit.login", handleSubmit);
                                            this.page.find("a.config").removeClass("ui-state-disabled");
                                            jQuery.mobile.pageContainer.pagecontainer("change", "menu.html");
                                            _a = InactivityLogout;
                                            _c = (_b = Utils).convertToBoolean;
                                            return [4 /*yield*/, Utils.Preferences.getItem("stay-signed-in")];
                                        case 2:
                                            _a.staySignedIn = _c.apply(_b, [_d.sent(), false]);
                                            InactivityLogout.StartInactivityLogoutTimer();
                                            return [2 /*return*/];
                                    }
                                });
                            }); }).catch(function (err) {
                                //Re-enable the form handler and config button
                                form.on("submit.login", handleSubmit);
                                _this.page.find("a.config").removeClass("ui-state-disabled");
                                if (!err) {
                                    return;
                                }
                                var isErrorArray = err instanceof Array;
                                var message = isErrorArray ? err[0] : err;
                                var reason = isErrorArray ? err[1] : null;
                                var messageReplacements = isErrorArray ? err[2] : null;
                                var appl = Model.TSFApplicationManager.Current.activeAppl;
                                var lang = appl ? appl.language : AppConfig.language;
                                //We need to check if it's a networkError before disposing the application because else we won't
                                //know in which language the networkError was.
                                var isNetworkError = lang.transl(Model.TranslKeys.networkError) === message[0];
                                // Don't dispose the application manager when a sync error occured
                                // We need to switch to the synchronize page so we can't remove the application
                                if (message !== AppConfig.sync_error) {
                                    Model.TSFApplicationManager.Current.dispose(false);
                                }
                                Utils.hideLoader();
                                var errorPopup = ConfirmationPopup.CreateOkPopup();
                                var transl;
                                if (message === AppConfig.invalidGuiVersion) {
                                    transl = _this.language.transl(Model.TranslKeys.gui_version_invalid);
                                }
                                else if (message === AppConfig.sync_error) {
                                    transl = _this.language.transl(Model.TranslKeys.syncErrorDuringSynchronization);
                                }
                                else if (message === AppConfig.skip_stale_sync) {
                                    // This is a bit ugly and we could have choosen message == null; but we seen quit a few issues where we
                                    // didn't propagate the error causing us to show a empty message; So I would prefer to keep it this way
                                    // for now. If we find we don't get the empty errors anymore we can always remove the skip_stayle_sync error
                                    // and replace it with a simple null check
                                    // No message to show, don't do anything
                                    return;
                                }
                                else {
                                    //Prevent sending to Sentry if it's a built-in error.
                                    if (Utils.isBuiltInError(message)) {
                                        //Replace all the variables in the error message if they're given
                                        if (messageReplacements) {
                                            transl = Utils.replaceInErrorMessage(_this.language.transl(message), messageReplacements);
                                        }
                                        else {
                                            transl = _this.language.transl(message);
                                        }
                                        //Network errors can't be refactored easily, hence we check them separately.
                                    }
                                    else if (isNetworkError) {
                                        transl = message;
                                    }
                                    else if (message instanceof DOMException) {
                                        if (message.message.contains("database or disk is full")
                                            || message.name === "QuotaExceededError") {
                                            transl = _this.language.transl(Model.TranslKeys.DBDiskFullError) + "\r\n\r\nError code: " + Raven.lastEventId();
                                        }
                                        else {
                                            Utils.tryRavenCaptureException(message);
                                        }
                                    }
                                    else {
                                        Utils.tryRavenCaptureException(message);
                                        transl = _this.language.transl(Model.TranslKeys.loginError) + "\r\n\r\nError code: " + Raven.lastEventId();
                                    }
                                }
                                var errorPromise = errorPopup.initialize(_this.language.transl(Model.TranslKeys.login), transl, message == AppConfig.invalidGuiVersion ? ConfirmationPopup.invalidGuiVersionButtonGenerator : null);
                                if (message === AppConfig.sync_error) {
                                    errorPromise.always(function () {
                                        jQuery.mobile.pageContainer.pagecontainer("change", "synchronize.html");
                                    });
                                }
                            });
                        };
                        form.off('submit.login').on("submit.login", handleSubmit);
                        form.off('submit.prevent').on("submit.prevent", function (evt) {
                            evt.preventDefault();
                            evt.stopPropagation();
                        });
                        _b = (_a = Utils).convertToBoolean;
                        return [4 /*yield*/, Utils.Preferences.getItem("stay-signed-in")];
                    case 1:
                        if (!_b.apply(_a, [_e.sent(), false])) return [3 /*break*/, 3];
                        _d = (_c = that.usernameInput).val;
                        return [4 /*yield*/, Utils.Preferences.getItem(BaseModelReader.latestSignedInUsernameKey)];
                    case 2:
                        _d.apply(_c, [_e.sent()]);
                        Utils.PasswordEncryption.getLatestPassword().then(function (password) {
                            if (password !== null) {
                                _this.passwordInput.val(password);
                                //Prevent auto logging in after logging out
                                if (!Login.autoLoggedIn) {
                                    Login.autoLoggedIn = true;
                                    form.trigger("submit");
                                }
                            }
                        });
                        _e.label = 3;
                    case 3:
                        AppConfig.initializeCustomCode();
                        // Make sure that the height of the main div is set. Otherwise scrolling on iOS doesn't work.
                        Utils.fixScrolling(that.page);
                        form.on("focus", "input, textarea, select", function (e) {
                            jQuery(this).parent().siblings('label').addClass("label_control_focused");
                        }).on("focusout", "input, textarea, select", function (e) {
                            jQuery(this).parent().siblings('label').removeClass("label_control_focused");
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    Login.prototype.submitLogin = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var applicationManager, disposePromise, metaServiceURL, that, user, password, metaClient;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // Show the loader with the loading application text.
                        Utils.showLoader(AppConfig.language.transl(Model.TranslKeys.loadingApplication));
                        applicationManager = Model.TSFApplicationManager.Current;
                        disposePromise = applicationManager.dispose(false);
                        if (AppConfig.sendUsernameCapitalized) {
                            this.usernameInput.val(this.usernameInput.val().toUpperCase());
                        }
                        return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                    case 1:
                        metaServiceURL = _a.sent();
                        that = this, user = that.usernameInput.val().trim(), password = that.passwordInput.val(), metaClient = OnlineClientFactory.createClient(metaServiceURL, user, password);
                        if (user == null || (typeof user === "string" && user.trim() === "")) {
                            return [2 /*return*/, Promise.reject([Model.TranslKeys.noUser])];
                        }
                        if (metaServiceURL === null || metaServiceURL.trim() === "") {
                            return [2 /*return*/, Promise.reject([
                                    Model.TranslKeys.emptyMandatoryField,
                                    null,
                                    [["[objProp]", this.language.transl(Model.TranslKeys.metaserverUrl)]]
                                ])];
                        }
                        if (AppConfig.online) {
                            return [2 /*return*/, new Promise(function (resolve, reject) {
                                    return disposePromise.then(function () {
                                        var deferred = jQuery.Deferred();
                                        metaClient.authenticate().then(function () {
                                            deferred.resolve();
                                        }).fail(function (err, reason, messageReplacements) {
                                            if (reason === RequestStatus.TWO_FACTOR_AUTH_REQUESTED_REASON) {
                                                var twoFactor = new TwoFactorValidation(user, password, err);
                                                jQuery.mobile.pageContainer.pagecontainer("change", "twoFactorValidation.html", { twoFactorResponse: err });
                                                return twoFactor.deferred.then(function () {
                                                    return _this.loadApplication(metaClient, applicationManager, user, password)
                                                        .then(function () { return __awaiter(_this, void 0, void 0, function () {
                                                        return __generator(this, function (_a) {
                                                            switch (_a.label) {
                                                                case 0:
                                                                    Utils.hideLoader();
                                                                    return [4 /*yield*/, AppConfig.getMetaSource()];
                                                                case 1:
                                                                    // Log session after login.
                                                                    if ((_a.sent()) === "iam") {
                                                                        Model.TSFApplicationManager.Current.setGuiStartUseLogSession();
                                                                    }
                                                                    return [2 /*return*/];
                                                            }
                                                        });
                                                    }); })
                                                        .then(resolve)
                                                        .catch(reject);
                                                });
                                            }
                                            deferred.reject(err, reason, messageReplacements);
                                        });
                                        return deferred.promise();
                                    }).then(function () {
                                        return _this.prepare(metaClient);
                                    }).fail(reject).then(function () {
                                        return _this.loadApplication(metaClient, applicationManager, user, password)
                                            .then(resolve)
                                            .catch(reject);
                                    }).fail(reject);
                                })];
                        }
                        else {
                            if (!AppConfig.allowStaySignedIn) {
                                return [2 /*return*/, Promise.reject([Model.TranslKeys.deviceOffline])];
                            }
                            return [2 /*return*/, this.localCredentialsMatch(user, password).then(function (localCredentialsMatch) {
                                    if (!localCredentialsMatch) {
                                        return Promise.reject([Model.TranslKeys.loginFail]);
                                    }
                                    return _this.loadApplication(metaClient, applicationManager, user, password);
                                })];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Login.prototype.localCredentialsMatch = function (username, password) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var latestUsername;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, Utils.Preferences.getItem(BaseModelReader.latestSignedInUsernameKey)];
                                case 1:
                                    latestUsername = _a.sent();
                                    Utils.PasswordEncryption.getLatestPassword().then(function (latestPassword) {
                                        var credentialsMatch = Utils.caseInsenstiveStringCompare(username, latestUsername) && password === latestPassword;
                                        resolve(credentialsMatch);
                                    }).catch(reject);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    Login.prototype.prepare = function (metaClient) {
        var deferred = jQuery.Deferred();
        metaClient.invoke(OData.WARMUP, 'GET', null, function (reader, requestStatus) {
            if (requestStatus.requestSuccess) {
                deferred.resolve();
            }
            else {
                deferred.reject(requestStatus.messages);
            }
        });
        return deferred.promise();
    };
    Login.prototype.saveUserCredentials = function (user, password) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.setItem(BaseModelReader.latestSignedInUsernameKey, user)];
                    case 1:
                        _a.sent();
                        if (AppConfig.allowStaySignedIn) {
                            // only save the password when allowStaySignedIn is true;
                            // We still save the user because that allows us to use the cache
                            // This does mean we save it to localstorage but username shouldn't be that important
                            Utils.PasswordEncryption.setLatestPassword(password);
                        }
                        if (!(this.staySignedInInput.prop('checked') === true)) return [3 /*break*/, 3];
                        return [4 /*yield*/, Utils.Preferences.setItem("stay-signed-in", true + "")];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, Utils.Preferences.removeItem("stay-signed-in")];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    Login.prototype.loadApplication = function (metaClient, applicationManager, user, password) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (Raven !== undefined) {
                    Raven.setUserContext({
                        username: user.toLowerCase()
                    });
                }
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        applicationManager.loadApplications(metaClient, user, password).then(function () { return __awaiter(_this, void 0, void 0, function () {
                            var activeAppl, _a, _b, _c, _d, _e, _f;
                            return __generator(this, function (_g) {
                                switch (_g.label) {
                                    case 0:
                                        // Save the user credentials after the application is loaded because the ObjectModel checks the logged in user.
                                        this.saveUserCredentials(user, password);
                                        activeAppl = applicationManager.activeAppl;
                                        if (!(Raven !== undefined)) return [3 /*break*/, 7];
                                        _b = (_a = Raven).setTagsContext;
                                        _c = {
                                            project: activeAppl.projectName,
                                            projectVersion: activeAppl.projectVersion,
                                            guiApplId: activeAppl.guiApplId,
                                            language: activeAppl.language.code
                                        };
                                        return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                                    case 1:
                                        _c.metaServiceURL = _g.sent();
                                        _e = (_d = Utils).generateSFUrl;
                                        return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                                    case 2:
                                        _f = [_g.sent()];
                                        return [4 /*yield*/, AppConfig.getProject()];
                                    case 3:
                                        _f = _f.concat([_g.sent()]);
                                        return [4 /*yield*/, AppConfig.getProjectVrs()];
                                    case 4:
                                        _f = _f.concat([_g.sent()]);
                                        return [4 /*yield*/, AppConfig.getConfiguration()];
                                    case 5:
                                        _c.eindproductServiceURL = _e.apply(_d, _f.concat([_g.sent()]));
                                        return [4 /*yield*/, AppConfig.getMetaSource()];
                                    case 6:
                                        _b.apply(_a, [(_c.metaSource = _g.sent(),
                                                _c)]);
                                        _g.label = 7;
                                    case 7:
                                        StyleSheetGenerator.generateFullStyle(activeAppl);
                                        // Try to add the footer picture when there isn't any.
                                        if (this.page.find(".pictureFooter").length === 0) {
                                            Utils.addFooterPicture(activeAppl.style, this.page.find(".content-panel"));
                                        }
                                        Model.Language.initializeStaticTranslations(activeAppl.language);
                                        // Start a timer which checks for inactive applications every 5 minutes.
                                        applicationManager.startInactiveApplicationTimer();
                                        return [2 /*return*/];
                                }
                            });
                        }); }).done(function () {
                            applicationManager.activeAppl.localSync.startLocalSyncInterval();
                            resolve();
                        }).fail(reject);
                    })];
            });
        });
    };
    Login.autoLoggedIn = false;
    return Login;
}());
