var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
///<reference path="jquery/jquery.d.ts" />
///<reference path="jquery/jquerymobile.d.ts" />
var Menu = /** @class */ (function () {
    function Menu(page) {
        var _this = this;
        this.page = page;
        this.menuImpl = null;
        this.switchApplication = function (newApplication) {
            var activeAppl = _this.manager.activeAppl;
            if (activeAppl == newApplication) {
                return;
            }
            // TODO: Add a Changing Application text to the loader.
            Utils.showLoader();
            var func = function () {
                // Stop synchronizing the old application, it isn't visible anymore. Syncing will start
                // again after opening the application
                activeAppl.localSync.stopLocalSyncInterval();
                if (_this.menuImpl) {
                    badgeHelper.clearSubscribers(_this.menuImpl.badgeInfo);
                }
                var header = _this.page.children("div[data-role='header']");
                header.empty();
                _this.panel.empty();
                _this.createMenu(newApplication);
                _this.initializeApplicationMenu(header);
                _this.panel.enhanceWithin();
                if (_this.menuImpl) {
                    _this.menuImpl.bindMenuEvents();
                }
                header.children('h1').text(newApplication.transl);
                Utils.hideLoader();
                StyleSheetGenerator.generateFullStyle(newApplication);
                // Application might have a new style so we need to correct the footer icons
                var footer = _this.page.children('[data-role="footer"]');
                var color = Utils.Color.hexToColor(footer.find("a").first().css("color"));
                Utils.SetIconBlackOrWhite(footer, color);
                var syncGroupsToSync = [];
                // Gather the SyncGroups which have not been synced before. This will be synced right away, in a blocking fashion.
                newApplication.syncGroups.forEach(function (syncGroup) {
                    if (newApplication.localSync.getSyncGroupLastSuccessfulSync(syncGroup.syncGroupId) == undefined) {
                        syncGroupsToSync.push(syncGroup);
                    }
                });
                // Sync the SyncGroups, if any, and start the local sync interval. The local sync interval will also sync
                // the SyncGroups for which the maximum age of the data has been reached right away.
                if (syncGroupsToSync.length > 0) {
                    newApplication.localSync.fullSynchronize(true, syncGroupsToSync).always(function () {
                        newApplication.localSync.startLocalSyncInterval();
                    });
                }
                else {
                    newApplication.localSync.startLocalSyncInterval();
                }
            };
            _this.manager.changeApplication(newApplication)
                .then(func)
                .fail(function (message) {
                Utils.hideLoader();
                var errorPopup = ConfirmationPopup.CreateOkPopup();
                errorPopup.initialize(_this.activeAppl.language.transl(Model.TranslKeys.login), message);
            });
        };
        this.manager = Model.TSFApplicationManager.Current;
    }
    Menu.prototype.initialize = function (application) {
        var _this = this;
        var page = this.page;
        this.activeAppl = application;
        this.container = page.children("div[data-role='main']");
        this.panel = this.container.children(".content-panel");
        var header = page.children("div[data-role='header']");
        var footer = page.children("div[data-role='footer']");
        this.initializeApplicationMenu(header);
        // Remove illegal characters.
        var vrs = application.projectVersion.replace(/\./g, ""), projectName = application.projectName + vrs;
        if (window[projectName] && window[projectName].CustomMenu) {
            window[projectName].CustomMenu(this.panel[0]);
        }
        else {
            this.createMenu(application);
        }
        // Make sure that the height of the main div is set. Otherwise scrolling on iOS doesn't work.
        page.one("pageshow", function () {
            // Don't set the size for android 2.3 devices because scroll wont work
            if (!Utils.isAndroidTwo()) {
                var height = window.innerHeight;
                height -= header.outerHeight() + footer.height();
                // We need a -1 for the header because it has a top: -1px
                _this.panel.css('height', (height - 1) + 'px');
            }
            // Bind events after this form is shown, or the expand/collapse events are fired on opening the page
            if (_this.menuImpl !== null) {
                _this.menuImpl.bindMenuEvents();
            }
            var color = Utils.Color.hexToColor(footer.find("a").first().css("color"));
            Utils.SetIconBlackOrWhite(footer, color);
        });
        // Clear badge timer when moving away from the page
        jQuery(document).one('pagebeforecreate', function () {
            if (_this.menuImpl !== null) {
                badgeHelper.clearSubscribers(_this.menuImpl.badgeInfo);
            }
        });
        var that = this;
        var controlGroup = footer.find(":jqmData(role='controlgroup')");
        controlGroup.on("click", "a", function (event) {
            return __awaiter(this, void 0, void 0, function () {
                var $button, _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            $button = jQuery(this);
                            if (!$button.hasClass("logout")) return [3 /*break*/, 2];
                            that.dispose();
                            Model.TSFApplicationManager.Current.dispose(true);
                            PopupManager.resetQueue();
                            // parameter is a jQuery page object for the login page and not index.html so pageinit isn't called again
                            // and the user isn't automatically loggedin again when the checkbox for stay signed in is checked
                            // This is needed for chrome desktop, not an issue on cordova or the viewer
                            jQuery.mobile.pageContainer.pagecontainer("change", jQuery("#login"), { reverse: true });
                            _b = (_a = Utils).convertToBoolean;
                            return [4 /*yield*/, Utils.Preferences.getItem("stay-signed-in")];
                        case 1:
                            // Reset username and password when the stay signed in checkbox is inactive
                            if (!_b.apply(_a, [_c.sent(), false])) {
                                jQuery("#username, #password").val("");
                            }
                            return [3 /*break*/, 3];
                        case 2:
                            if ($button.hasClass("maintenance")) {
                                jQuery.mobile.pageContainer.pagecontainer("change", "maintenance.html");
                            }
                            _c.label = 3;
                        case 3: return [2 /*return*/];
                    }
                });
            });
        });
        Menu.openTaskPopup(jQuery.mobile.path.parseUrl(page.data("url")).search);
    };
    Menu.prototype.initializeApplicationMenu = function ($header) {
        if (this.manager.appls.length === 0) {
            return;
        }
        this.applicationMenu = new ApplicationMenu();
        this.applicationMenu.initialize(this.switchApplication);
        $header.append(this.applicationMenu.element);
    };
    Menu.prototype.dispose = function () {
        if (this.menuImpl) {
            badgeHelper.clearTimers(this.menuImpl.badgeInfo);
            badgeHelper.clearSubscribers(this.menuImpl.badgeInfo);
        }
    };
    Menu.prototype.createMenu = function (application) {
        this.activeAppl = application;
        //Prevent errors when the GUI is loaded with a cached objectModel that hasn't got 'defaultMenu' yet.
        if (!application.model.defaultMenu) {
            if (!application.model.hasOwnProperty("listbarGroups")) {
                return;
            }
            this.menuImpl = new ListbarMenu(application, this.container, application.model["listbarGroups"]);
        }
        else if (application.model.defaultMenu instanceof Model.TilesMenu) {
            this.menuImpl = new TilesMenu(application, this.container);
        }
        else {
            this.menuImpl = new ListbarMenu(application, this.container);
        }
        Utils.addFooterPicture(this.activeAppl.style, this.panel);
        this.menuImpl.initialize();
    };
    Menu.openTaskPopup = function (url) {
        var urlParamsObj = Utils.parseUrlVars(url).indexed;
        if (urlParamsObj.hasOwnProperty("task")) {
            var taskId = urlParamsObj["task"];
            var taskConfig_1 = null;
            if (urlParamsObj.hasOwnProperty("taskConfig")) {
                taskConfig_1 = urlParamsObj["taskConfig"];
            }
            var task_1 = Model.TSFApplicationManager.Current.activeAppl.model.tasks.key(taskId);
            var showTaskPopup = function () { return taskHelper.showPageOrPopup((taskConfig_1 ? task_1.taskViews.key(taskConfig_1) : task_1.defaultTaskView), null); };
            //If the page is navigating or loading we wait for pagechange.
            if (!NavigationManager.isNotNavigating || jQuery("html.ui-loading").length > 0) {
                jQuery(document).one("pagechange", showTaskPopup);
                return;
            }
            setTimeout(showTaskPopup, 1);
        }
    };
    return Menu;
}());
jQuery(document).on("pagecreate", "#menu", function () {
    var appl = Model.TSFApplicationManager.Current.activeAppl, language = appl.language;
    var controlGroup = jQuery(this).children("div[data-role='footer']").find(":jqmData(role='controlgroup')");
    controlGroup.find(".maintenance").text(language.transl(Model.TranslKeys.maintenance));
    controlGroup.find(".logout").text(language.transl(Model.TranslKeys.logout));
    //For both menus, if there's just 1 item, open it.
    if (appl.model.defaultMenu &&
        appl.model.defaultMenu.groups.length === 1 &&
        appl.model.defaultMenu.groups.item(0).items.length === 1 &&
        history.state.url.indexOf("index.html") !== -1) {
        if (appl.model.defaultMenu instanceof Model.ListbarMenu) {
            jQuery(".ui-listview .ui-first-child a").trigger('click');
        }
        if (appl.model.defaultMenu instanceof Model.TilesMenu) {
            jQuery(".tiles-menu .tile").first().trigger("click");
        }
    }
});
jQuery(document).on('pagebeforecreate', '#menu', function () {
    var $this = jQuery(this);
    var manager = Model.TSFApplicationManager.Current;
    var menu = new Menu($this);
    menu.initialize(manager.activeAppl);
});
