var ConditionalLayoutConsumer = /** @class */ (function () {
    function ConditionalLayoutConsumer() {
    }
    ConditionalLayoutConsumer.prototype.evaluateConditions = function (conditionalLayout, row) {
        for (var i = 0; i < conditionalLayout.conditions.length; i++) {
            var condition = conditionalLayout.conditions[i];
            var columnValue = row.getValueForObjProp(condition.objProp);
            var filterValue = this.getValueFromCondition(condition.value, condition.filterField, row);
            var filterUntilValue = this.getValueFromCondition(condition.valueUntil, condition.filterFieldUntil, row);
            if (!this.evaluateCondition(condition.condition, columnValue, filterValue, filterUntilValue))
                return false;
        }
        return true;
    };
    ConditionalLayoutConsumer.prototype.getValueFromCondition = function (constantValue, field, row) {
        if (!Utils.isEmpty(constantValue)) {
            return constantValue;
        }
        else if (field) {
            return row.getValueForObjProp(field);
        }
        return null;
    };
    ConditionalLayoutConsumer.prototype.evaluateCondition = function (condition, value, filterValue, filterUntilValue) {
        if (value != undefined && filterValue != undefined) {
            switch (condition) {
                case Enum.FilterCondition.EqualTo:
                    return (value == filterValue);
                case Enum.FilterCondition.NotEqualTo:
                    return (value != filterValue);
                case Enum.FilterCondition.SmallerThanOrEqualTo:
                    return (value <= filterValue);
                case Enum.FilterCondition.SmallerThan:
                    return (value < filterValue);
                case Enum.FilterCondition.GreaterThanOrEqualTo:
                    return (value >= filterValue);
                case Enum.FilterCondition.GreaterThan:
                    return (value > filterValue);
                case Enum.FilterCondition.Between:
                    return (value >= filterValue && value <= filterUntilValue);
                case Enum.FilterCondition.NotBetween:
                    return value < filterValue || value > filterUntilValue;
                default:
                    break;
            }
        }
        switch (condition) {
            case Enum.FilterCondition.IsNull:
                return value == undefined;
            case Enum.FilterCondition.IsNotNull:
                return value != undefined;
            default:
                break;
        }
        return false;
    };
    return ConditionalLayoutConsumer;
}());
