var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var MasterControllerContext = /** @class */ (function () {
    function MasterControllerContext(objView) {
        this.objView = objView;
    }
    MasterControllerContext.prototype.dataContextOption = function () {
        return 0 /* Master */;
    };
    MasterControllerContext.prototype.getPrefilterState = function () {
        return this.objView.getPrefilterState(this.dataContextOption());
    };
    MasterControllerContext.prototype.startEmptyWithFilter = function () {
        return this.objView.startEmptyWithFilter;
    };
    MasterControllerContext.prototype.getScreenType = function () {
        return this.objView.mainScreenType;
    };
    MasterControllerContext.prototype.subjectTransl = function () {
        return this.objView.objTransl.translPlural;
    };
    MasterControllerContext.prototype.isInherited = function () {
        return false;
    };
    return MasterControllerContext;
}());
var DetailControllerContext = /** @class */ (function () {
    function DetailControllerContext(objLinkDetailView) {
        this.objLinkDetailView = objLinkDetailView;
    }
    DetailControllerContext.prototype.dataContextOption = function () {
        return 1 /* Detail */;
    };
    DetailControllerContext.prototype.getPrefilterState = function () {
        return this.objLinkDetailView.getPrefilterState();
    };
    DetailControllerContext.prototype.startEmptyWithFilter = function () {
        return this.objLinkDetailView.objView.startEmptyWithFilter;
    };
    DetailControllerContext.prototype.getScreenType = function () {
        return this.objLinkDetailView.objView.defaultDetailSceenType;
    };
    DetailControllerContext.prototype.subjectTransl = function () {
        if (this.objLinkDetailView.objLink.inheritance)
            return this.objLinkDetailView.objView.objTransl.transl;
        return this.objLinkDetailView.objView.objTransl.translPlural;
    };
    DetailControllerContext.prototype.isInherited = function () {
        return this.objLinkDetailView.objLink.inheritance;
    };
    return DetailControllerContext;
}());
var LookupControllerContext = /** @class */ (function () {
    function LookupControllerContext(parentController, objLinkLookupView, lookupProp, dataValue, translationValue) {
        this.parentController = parentController;
        this.objLinkLookupView = objLinkLookupView;
        this.lookupProp = lookupProp;
        this.dataValue = dataValue;
        this.translationValue = translationValue;
        this.currentHistoryIndex = jQuery.mobile.navigate.history.activeIndex;
    }
    LookupControllerContext.prototype.dataContextOption = function () {
        return 2 /* Lookup */;
    };
    LookupControllerContext.prototype.getPrefilterState = function () {
        return this.objLinkLookupView.getPrefilterState();
    };
    LookupControllerContext.prototype.startEmptyWithFilter = function () {
        return false;
    };
    LookupControllerContext.prototype.getScreenType = function () {
        return this.objLinkLookupView.objView.defaultDetailSceenType;
    };
    LookupControllerContext.prototype.subjectTransl = function () {
        if (this.objLinkLookupView.objLink.inheritance)
            return this.objLinkLookupView.objView.objTransl.transl;
        return this.objLinkLookupView.objView.objTransl.translPlural;
    };
    LookupControllerContext.prototype.isInherited = function () {
        return this.objLinkLookupView.objLink.inheritance;
    };
    return LookupControllerContext;
}());
var TaskControllerContext = /** @class */ (function (_super) {
    __extends(TaskControllerContext, _super);
    function TaskControllerContext(objView, taskView) {
        var _this = _super.call(this, objView) || this;
        _this.taskView = taskView;
        _this.taskRow = {};
        return _this;
    }
    TaskControllerContext.prototype.applyTaskContext = function (contextController) {
        var row = this.taskRow;
        var currentRow = contextController.currentRow;
        var taskLink = contextController.obj.tasks.object[this.taskView.task.taskId];
        var taskLinkProps = taskLink.props.array;
        if (currentRow != null) {
            var objProps = contextController.obj.objProps;
            for (var g = 0; g < taskLinkProps.length; g++) {
                var taskProp = taskLinkProps[g];
                row[taskProp.taskParmtrId] = currentRow.getValueForObjProp(objProps.object[taskProp.propId]);
            }
        }
        else {
            var contextFilters = contextController.queryForTasks.whereClause.contextFilters;
            for (var i = 0; i < taskLinkProps.length; i++) {
                var taskProp = taskLinkProps[i];
                // Get the context filters of the currentRow.
                for (var g = 0; g < contextFilters.length; g++) {
                    var contextFilter = contextFilters[g];
                    if (contextFilter.targetPropId == taskProp.propId) {
                        row[taskProp.taskParmtrId] = contextFilter.filterValue;
                    }
                }
            }
        }
    };
    return TaskControllerContext;
}(MasterControllerContext));
