var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var TSFController = /** @class */ (function () {
    function TSFController(application, objView) {
        var _this = this;
        this.application = application;
        this.objView = objView;
        this.childControllers = [];
        this.lookupContainers = {};
        this.events = new ControllerEvents();
        this.initialized = false;
        this.badgeInfo = {};
        this.rowModifiedCallbacks = [];
        this.isDataDirty = false;
        this.pageIndex = 0;
        this.rowIndexInternal = -1;
        // Holds a promise with the state of the last UpdateStatus action.
        this.updateStatusAction = jQuery.Deferred().resolve();
        // Holds a promise with the state of the last action performed by the User.
        this._currentAction = jQuery.Deferred().resolve();
        // Gets or sets if the loader should be hidden when the action completes.
        this.cancelHideLoader = false;
        this.loaderPromise = jQuery.Deferred().resolve().promise();
        this.forceOfflineLayouts = function () {
            var result = _this.searchNullableOfflineLogic(function (logic) {
                return !!logic.executeLayout;
            });
            _this.forceOfflineLayouts = function () { return result; };
            return result;
        };
        this.forceOfflineContexts = function () {
            var result = _this.searchNullableOfflineLogic(function (logic) {
                return !!logic.executeContext;
            });
            _this.forceOfflineContexts = function () { return result; };
            return result;
        };
        this.forceOfflineDefaults = function () {
            var result = _this.searchNullableOfflineLogic(function (logic) {
                return !!logic.executeDefault;
            });
            _this.forceOfflineDefaults = function () { return result; };
            return result;
        };
        this.editmodeLeavedCallback = [];
        this.obj = objView.obj;
        this.layoutState = new LayoutState(objView);
        this.contextState = new ContextState(this.obj);
    }
    Object.defineProperty(TSFController.prototype, "masterController", {
        get: function () {
            var controller = this;
            while (controller.parentController) {
                controller = controller.parentController;
            }
            return controller;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "deleteRowAccessType", {
        get: function () {
            // Disable delete when there aren't any rows - there is nothing to delete
            // Also disable it when creating a new row, this way you can still remove a row when default editable form (or form autosave) is active
            if (this.currentRow == null || (this.currentEditor != null && this.currentEditor.isCreatingNewRow())) {
                return Math.max(this.layoutState.deleteRowAccessType, Enum.AccessType.ReadOnly);
            }
            return this.layoutState.deleteRowAccessType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "editRowAccessType", {
        get: function () {
            if (this.currentRow == null || this.currentEditor) {
                return Math.max(this.layoutState.editRowAccessType, Enum.AccessType.ReadOnly);
            }
            return this.layoutState.editRowAccessType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "copyRowAccessType", {
        get: function () {
            if (this.currentRow == null) {
                return Math.max(this.layoutState.copyRowAccessType, Enum.AccessType.ReadOnly);
            }
            return this.layoutState.copyRowAccessType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "addRowAccessType", {
        get: function () {
            if (this.currentEditor == null) {
                var data = this.recordSet.getData();
                if (this.controllerContext.isInherited() && data && data.length > 0) {
                    return Enum.AccessType.ReadOnly;
                }
            }
            else {
                if (this.controllerContext.isInherited()) {
                    return Enum.AccessType.ReadOnly;
                }
            }
            return this.layoutState.addRowAccessType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "cancelRowAccessType", {
        get: function () {
            if (this.layoutState.cancelRowAccessType == Enum.AccessType.Regular && !this.currentEditor)
                return Enum.AccessType.ReadOnly;
            return this.layoutState.cancelRowAccessType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "saveRowAccessType", {
        get: function () {
            return this.layoutState.saveRowAccessType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "query", {
        get: function () {
            return this.recordSet.query;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "pageSize", {
        get: function () {
            return this.recordSet.query.pageSize;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "queryForTasks", {
        // TODO: Remove this hack
        get: function () {
            return this.recordSet.query;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "isStartEmptyWithFilterActive", {
        get: function () {
            return this.recordSet.query.whereClause.startEmptyWithFilterActive;
        },
        enumerable: true,
        configurable: true
    });
    TSFController.prototype.resetCombinedFilterConditions = function () {
        this.recordSet.query.whereClause.combinedFilterConditions = [];
    };
    Object.defineProperty(TSFController.prototype, "isMarkedDirty", {
        get: function () { return this.isDataDirty; },
        enumerable: true,
        configurable: true
    });
    TSFController.prototype.getRowIndex = function () {
        return this.rowIndexInternal;
    };
    Object.defineProperty(TSFController.prototype, "interfaceAvailable", {
        // Gets if the UI is available, this depends on the status of the current action and on the navigation status.
        get: function () {
            return this._currentAction.state() != "pending" && NavigationManager.isNotNavigating;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TSFController.prototype, "currentAction", {
        get: function () {
            return this._currentAction;
        },
        set: function (action) {
            var _this = this;
            // Save the new action in the currentAction promise.
            this._currentAction = action;
            // Show a loader with 500ms delay.
            var timer = Utils.showLoaderWithDelay(500);
            // We need to chain the loaders because for example: on a phone and the grid is visible.
            // setRowIndex moves to the form, but getData() is faster so the _currentActions are different and the loader isn't hidden
            this.loaderPromise = Utils.chainPromise(this.loaderPromise, function () { return action; });
            this.loaderPromise.always(function () {
                // Always clear the timeout since the action is finished and the loader doesn't have to be displayed anymore.
                clearTimeout(timer);
                // Note that it may occur that an error message is prompted.
                // A message will also hide the loader but thats okay.
                // Compare the global action with the local action.
                // We know that there hasn't been a newer currentAction when they are equal.
                // And therefore we can hide the loader.
                // Also make sure that the hide is not canceled by a child controller.
                if (_this._currentAction == action && !_this.cancelHideLoader) {
                    Utils.hideLoader();
                }
                // Always reset the cancelation.
                _this.cancelHideLoader = false;
            });
        },
        enumerable: true,
        configurable: true
    });
    TSFController.prototype.setCurrentActionWithoutLoader = function (action) {
        var _this = this;
        this._currentAction = action;
        // The setter for currentAction might not hide the loader anymore because the this_currentAction == action might be false
        // This code just chains the loaderPromise and hides it when it is the last action but it doesn't show the loader!
        // Note I didn't add the check for cancelHideLoader because that seems weird and we should remove that
        this.loaderPromise = Utils.chainPromise(this.loaderPromise, function () { return action; });
        this.loaderPromise.always(function () {
            if (_this._currentAction == action) {
                Utils.hideLoader();
            }
        });
    };
    TSFController.prototype.setRowIndex = function (newRowIndex) {
        var _this = this;
        var deferred = jQuery.Deferred();
        if ((this.currentEditor && !this.currentEditor.allowActions()) ||
            (this.rowIndexInternal == newRowIndex && (this.currentRowBookmark && this.currentRowBookmark.matchRowWithBookmark(this.currentRow)))) {
            // Block row change in editmode or when the newRowIndex is the same as the old one.
            deferred.reject();
        }
        else {
            // Default editable form - when we don't require saving - we need to go to the else
            // make sure to only save when there are changes or this won't stop and will be called again and again (it won't stackoverflow due to async code)
            // We do need to make sure the validate the editors first as there might be changes not yet committed - for example the user chagned a text field and clicked
            // on a new listview row
            var validator = this.currentEditor && this.currentEditor.validateEditors() || jQuery.Deferred().resolve().promise();
            validator.then(function () {
                _this.setRowIndexInternal(newRowIndex).always(function () { return deferred.resolve(); });
            }, function () { return deferred.reject(); });
        }
        return deferred.promise();
    };
    TSFController.prototype.setRowIndexInternal = function (newRowIndex) {
        var _this = this;
        this.rowIndexInternal = newRowIndex;
        if (newRowIndex == -1) {
            this.currentRowBookmark = null;
        }
        else {
            this.currentRowBookmark = TSFRowBookmark.fromReader(this.obj, this.currentRow);
        }
        for (var container in this.lookupContainers) {
            var lookupContainer = this.lookupContainers[container];
            lookupContainer.updateContextRow(this.currentRow);
            this.updateLookupContainer(lookupContainer);
        }
        this.events.emitRowIndexChanged();
        // Update the editor when there is one (default editable form) - this updates the row info required when updating
        if (this.currentEditor && this.currentRow != null && this.currentEditor.isDefaultEditable()) {
            this.currentEditor.createEditRow();
        }
        else if (this.currentEditor) {
            this.clearControllerEditor();
        }
        return this.updateStatus(2 /* Layouts */ | 4 /* Contexts */, null)
            .always(function () {
            _this.validateChildContextFilters();
        });
    };
    Object.defineProperty(TSFController.prototype, "currentRow", {
        get: function () {
            return this.getRowByIndex(this.rowIndexInternal);
        },
        enumerable: true,
        configurable: true
    });
    TSFController.prototype.getRowByIndex = function (index) {
        var data = null;
        // Check on data length because the refresh method can return an empty reader.
        // The GUI will crash when reader.item(x) is called on an empty reader.
        // Checking index bounds is not necessary because the readers will return null when the given index is outside their bounds.
        if (index != -1 && (data = this.recordSet.getData()) != null && data.length > 0) {
            return data.item(index);
        }
        return null;
    };
    Object.defineProperty(TSFController.prototype, "isInEditMode", {
        get: function () {
            return this.currentEditor != null;
        },
        enumerable: true,
        configurable: true
    });
    TSFController.prototype.blockEditMode = function () {
        this._blockEditMode = true;
    };
    TSFController.prototype.tryBlockEditMode = function () {
        var block = this._blockEditMode;
        this._blockEditMode = false;
        return block;
    };
    TSFController.prototype.initializeInternal = function (controllerContext, viewState) {
        var _this = this;
        this.controllerContext = controllerContext;
        var recordSet = this.recordSet = new TSFRecordSet(this.application, this.objView);
        var query = recordSet.query = new TSFQuery(this.obj.objId);
        if (viewState) {
            query.whereClause = viewState.whereClause;
        }
        else {
            query.whereClause.prefilterState = controllerContext.getPrefilterState();
        }
        // Check if this is a cube controller and that there actually is a cube on the screen
        var screenType = controllerContext.getScreenType();
        // Same check can be found in AbstractScreen.buildScreenTree; keep them in sync
        var isCubeController = this.objView.objViewCube && this.objView.objViewCube.cubeViews.length > 0 &&
            screenType && screenType.actualScreenComponents.length === 1 && screenType.getActualScreenComponent("Cube");
        if (isCubeController) {
            query.cubeViewId = this.objView.objViewCube.defaultCubeView.cubeViewId;
        }
        else {
            query.pageSize = this.application.extendedProperties.pageSize;
            query.pageIndex = 0;
        }
        query.currentSorting = (this.objView.sorting ? this.objView.sorting.toWebserviceContract(!this.objView.offlineAvailable) : null);
        query.usePagination = true;
        var viewProps = this.objView.objViewProps.array;
        for (var i = 0; i < viewProps.length; i++) {
            var viewProp = viewProps[i];
            if (viewProp.hasLookup()) {
                var container = this.lookupContainers[viewProp.objPropId] = new TSFDataLookupContainer(this.application, this.obj, viewProp);
                container.addFiltersForSelectionSet();
            }
        }
        var _loop_1 = function (childObj) {
            if (childObj.objView.showBadge) {
                var badgeInfo_1 = this_1.badgeInfo[childObj.objLink.refId] = new badgeHelper.BadgeInfo(function () {
                    var contract = _this.getBadgeContractForObjLink(childObj.objLink);
                    return badgeHelper.executeBadge(_this.application, badgeInfo_1, contract);
                }, childObj.objView);
            }
        };
        var this_1 = this;
        // const initialize badge map
        for (var _i = 0, _a = this.objView.objLinkDetailViews.array; _i < _a.length; _i++) {
            var childObj = _a[_i];
            _loop_1(childObj);
        }
        var _loop_2 = function (task) {
            var badgeInfo = this_2.badgeInfo[task.taskView.task.taskId] = new badgeHelper.BadgeInfo(function () {
                var contract = _this.getBadgeContractForTask(task.taskLink);
                return badgeHelper.executeBadge(_this.application, badgeInfo, contract);
            }, task.taskView.paramObjView);
        };
        var this_2 = this;
        for (var _b = 0, _c = this.objView.taskLinkViews; _b < _c.length; _b++) {
            var task = _c[_b];
            _loop_2(task);
        }
    };
    TSFController.prototype.whenInitialized = function (func) {
        if (this.initialized) {
            func();
        }
        else {
            if (!this.initializationDeferred)
                this.initializationDeferred = jQuery.Deferred();
            this.initializationDeferred.always(function () { return func(); });
        }
    };
    TSFController.prototype.initialize = function (useStartEmptyWithFilter) {
        var _this = this;
        var deferred = this.initializationDeferred = this.initializationDeferred || jQuery.Deferred();
        deferred.always(function () {
            _this.initialized = true;
            _this.events.emitControllerInitialized(null);
            _this.initializationDeferred = null;
        });
        // Just return a resolved promise when this controller represents a task.
        // Task controllers shouldn't manage a dataset.
        if (this.obj.isTask) {
            return deferred.resolve().promise();
        }
        if (!this.parentController && this.objView.sorting) {
            this.query.preferredIndex = this.objView.sortIndex.indexName;
        }
        // Set the context of the parent. We can't do this in the initializeInternal because the parent might still be refreshing.
        this.setParentContextFiltersAsync().always(function () {
            // startEmptyWithFilter is only enabled for screen types with a listview.
            // because that is the only place you can filter
            _this.recordSet.query.whereClause.startEmptyWithFilterActive = useStartEmptyWithFilter && _this.controllerContext.startEmptyWithFilter();
            _this.initializeControllerData(deferred, true);
        });
        return deferred.promise();
    };
    TSFController.prototype.initializeControllerData = function (deferred, retryWithFilter) {
        var _this = this;
        this.refresh()
            .then(function (reader, status) {
            var promise;
            if (_this.rowIndexInternal == -1 && reader.length > 0) {
                // Select the first row when the refresh returned data.
                // The setRowIndex call also performs an updateStatus.
                var index = -1;
                if (_this.controllerContext.dataContextOption() == 2 /* Lookup */) {
                    var lookupContext = _this.controllerContext;
                    var dataValue = lookupContext.dataValue;
                    if (dataValue != null) {
                        var lookupProp = lookupContext.lookupProp;
                        var dataProp = lookupProp.lookup.dataProp;
                        for (var i = 0; i < reader.length; i++) {
                            if (reader.item(i).getString(dataProp.objPropId) == dataValue) {
                                index = i;
                                break;
                            }
                        }
                        // Retry with a filter on the translation, so when opening a lookup the value is always found
                        // even when it was on a second page
                        if (index == -1 && retryWithFilter && lookupProp.isTranslatedLookup() && lookupContext.translationValue != null) {
                            var listProp = lookupProp.lookup.listProp;
                            _this.recordSet.query.whereClause.combinedFilterConditions.push(new FilterContractCondition(listProp.objProp, Enum.FilterCondition.Contains, lookupContext.translationValue));
                            _this.initializeControllerData(deferred, false);
                            return;
                        }
                    }
                }
                // there are always rows here, but we start with -1 so we can detect when the datavalue for lookups wasn't found in the reader
                if (index == -1) {
                    index = 0;
                }
                promise = _this.setRowIndex(index);
            }
            else {
                // Execute layouts and contexts with an empty row.
                promise = _this.updateStatus(2 /* Layouts */ | 4 /* Contexts */, null);
            }
            promise.always(function () {
                _this.events.emitDatasetChanged(new DataSetEventArgs(reader));
                deferred.resolve();
            });
        }, function (status) {
            // Also execute layouts and contexts with an empty row when the refresh failed.
            _this.updateStatus(2 /* Layouts */ | 4 /* Contexts */, null)
                .always(function () {
                deferred.reject();
            });
        });
    };
    TSFController.prototype.getLookupSet = function (viewProp) {
        return this.lookupContainers[viewProp.objPropId];
    };
    TSFController.prototype.getData = function () {
        // Invalidated or no data and no request currently running.
        if (this.isDataDirty || (this.recordSet.getData() == null && !this.recordSet.isCurrentlyLoading())) {
            return this.refreshData(false);
        }
        // This doesn't actually performs a request, it just fetches the existing data in the recordset.
        // And therefore its not necessary to check if the promise fails and then throw a message.
        return this.recordSet.fetchDataAsync();
    };
    TSFController.prototype.updateStatus = function (status, prop) {
        var _this = this;
        var layoutMode = this.currentEditor == null ? Enum.LayoutMode.Navigate :
            (this.currentEditor.updateRow == null ? Enum.LayoutMode.Add : Enum.LayoutMode.Update);
        // Start with a resolved deferred and chain defaults, layouts and contexts.
        var chain = jQuery.Deferred().resolve();
        if ((status & 1 /* Defaults */) !== 0) {
            chain = Utils.chainPromise(chain, function () { return _this.executeDefaults(layoutMode, prop); });
        }
        if ((status & 2 /* Layouts */) !== 0) {
            chain = Utils.chainPromise(chain, function () { return _this.executeLayouts(layoutMode, prop); });
        }
        if ((status & 4 /* Contexts */) !== 0) {
            chain = Utils.chainPromise(chain, function () { return _this.executeContexts(); });
        }
        // Store the chained promise in a global variable so that we can wait for the update status to complete.
        this.updateStatusAction = chain;
        return chain;
    };
    TSFController.prototype.hasNextPage = function () {
        // Its assumable that there is no more data when the data doesn't reach the maximum ammount of rows for the current page index.
        var data = this.recordSet.getData();
        return data && data.length == ((this.pageIndex + 1) * this.recordSet.query.pageSize);
    };
    TSFController.prototype.getCubeViewId = function () {
        return this.query.cubeViewId;
    };
    TSFController.prototype.switchCubeView = function (cubeViewId) {
        this.query.cubeViewId = cubeViewId;
        return this.refreshData();
    };
    TSFController.prototype.nextPage = function () {
        var _this = this;
        var deferred = jQuery.Deferred();
        if (this.hasNextPage()) {
            Utils.showLoader();
            var newPageIndex = this.pageIndex + 1;
            this.recordSet.query.pageIndex = newPageIndex;
            this.recordSet.fetchNewPage().done(function (reader, status, newData) {
                if (newData.length == 0) {
                    _this.recordSet.query.pageIndex--;
                    deferred.reject();
                }
                else {
                    var args = new DataSetEventArgs(newData);
                    _this.pageIndex = args.pageIndex = newPageIndex;
                    _this.events.emitDatasetChanged(args);
                    deferred.resolve(newData);
                }
                Utils.hideLoader();
            }).fail(function (status) {
                Utils.hideLoader();
                deferred.reject();
            });
        }
        else {
            deferred.reject();
        }
        return deferred.promise();
    };
    TSFController.prototype.refreshData = function (invalidateLookups, refreshActiveRowToTop, bookmark) {
        var _this = this;
        if (invalidateLookups === void 0) { invalidateLookups = false; }
        if (refreshActiveRowToTop === void 0) { refreshActiveRowToTop = false; }
        if (bookmark === void 0) { bookmark = this.currentRowBookmark; }
        var deferred = jQuery.Deferred();
        if (this.obj.isTask) {
            return deferred.resolve().promise();
        }
        // Reset the page index of the query
        var query = this.query;
        query.pageIndex = this.pageIndex = 0;
        this.validateContext()
            .then(function () { return _this.setParentContextFiltersAsync(refreshActiveRowToTop); })
            .always(function () {
            _this.isDataDirty = false;
            _this.refresh().done(function (reader, status) {
                var rowIndex = _this.getRowIndex();
                // Response is rejected
                if (!reader) {
                    return deferred.reject(null, status).promise();
                }
                // Same row - invalidateLookups
                if (reader.length > 0 && rowIndex > -1 && bookmark && bookmark.matchRowWithBookmark(reader.item(rowIndex))) {
                    // This is an insert or update but the rowIndex is the same which isn't weird for the update but either way
                    // the bookmark needs to reflect the new values
                    if (_this.currentRowBookmark !== bookmark) {
                        _this.currentRowBookmark = TSFRowBookmark.fromReader(_this.obj, reader.item(rowIndex));
                    }
                    if (invalidateLookups) {
                        _this.invalidateLookups();
                    }
                    // Check context filters of children the the active row is not changed after a data refresh.
                    _this.validateChildContextFilters();
                    _this.events.emitDatasetChanged(new DataSetEventArgs(reader));
                    // Stay on current row and execute layouts for new data in the row.
                    _this.updateStatus(2 /* Layouts */ | 4 /* Contexts */, null).always(function () {
                        deferred.resolve(reader, status);
                    });
                }
                else {
                    var newRowIndex = void 0;
                    if (reader.length > 0) {
                        // Find same row - invalidateLookups
                        if (bookmark) {
                            for (var i = 0; i < reader.length; i++) {
                                if (i != rowIndex || rowIndex == -1) {
                                    if (bookmark.matchRowWithBookmark(reader.item(i))) {
                                        newRowIndex = i;
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    var forceLayout_1;
                    if (newRowIndex == undefined) {
                        // Else use the first row
                        newRowIndex = reader.length == 0 ? -1 : 0;
                        // Force a layout, rowIndex didn't change but the row wasn't found.
                        forceLayout_1 = rowIndex == newRowIndex;
                    }
                    if (invalidateLookups) {
                        _this.invalidateLookups();
                    }
                    _this.events.emitDatasetChanged(new DataSetEventArgs(reader));
                    _this.setRowIndexInternal(newRowIndex).always(function () {
                        // New data so recreate the edit row to make sure it is uptodate
                        if (_this.currentEditor && _this.currentEditor.allowActions()) {
                            _this.currentEditor.createEditRow();
                        }
                        if (forceLayout_1) {
                            _this.updateStatus(2 /* Layouts */ | 4 /* Contexts */, null).always(function () {
                                deferred.resolve(reader, status);
                            });
                        }
                        else {
                            deferred.resolve(reader, status);
                        }
                    });
                }
            }).fail(function (status) {
                deferred.reject();
            });
        });
        return deferred.promise();
    };
    TSFController.prototype.setParentContextFiltersAsync = function (refreshActiveRowToTop) {
        var _this = this;
        if (refreshActiveRowToTop === void 0) { refreshActiveRowToTop = false; }
        var deferred = jQuery.Deferred();
        if (this.parentController) {
            // Check if the parent controller got a reader.
            // There is an important difference between an empty reader and no reader.
            // No reader means that the recordset got invalidated, and therefore a request must be ongoing.
            if (this.parentController.recordSet.getData() == null) {
                this.parentController.getData().always(function () {
                    _this.parentController.validateContext(refreshActiveRowToTop)
                        .always(function () {
                        _this.setParentContextFilters();
                        deferred.resolve();
                    });
                });
            }
            else {
                this.parentController.validateContext(refreshActiveRowToTop)
                    .always(function () {
                    _this.setParentContextFilters();
                    deferred.resolve();
                });
            }
        }
        else {
            deferred.resolve();
        }
        return deferred.promise();
    };
    TSFController.prototype.setParentContextFilters = function () {
        var objLink = this.controllerContext.objLinkDetailView.objLink;
        var contextFilters = this.parentController.getContextFilters(objLink);
        if (this.query.preferredIndex === undefined) {
            // look for the index name
            var indexProps = [];
            contextFilters.conditions.forEach(function (val) {
                var props = objLink.childObj.objProps.array;
                for (var i = 0; i < props.length; i++) {
                    if (props[i].objPropId == val.targetPropId) {
                        indexProps.push(props[i]);
                    }
                }
            });
            var indexName = IndexedDb.IndexedDbWrapper.olPrefix + indexProps.map(function (objProp) { return objProp.objPropId; }).join("");
            if (this.obj.objLinkIndexes[indexName]) {
                this.query.preferredIndex = indexName;
            }
            else {
                this.query.preferredIndex = null;
            }
        }
        if (this.query.preferredIndex) {
            var contextFilterValues = contextFilters.conditions.map(function (con) { return con.dbFilterValue; });
            this.query.keyRange = IndexedDb.createKeyRangeFromValues(this.obj, contextFilterValues);
        }
        this.query.whereClause.contextFilters = contextFilters.conditions;
        this.query.whereClause.containsFalseCondtion = contextFilters.falseCondtion;
    };
    TSFController.prototype.refresh = function () {
        this.recordSet.invalidate();
        return this.recordSet.fetchDataAsync();
    };
    TSFController.prototype.refreshCurrentRow = function () {
        var _this = this;
        var deferred = jQuery.Deferred();
        // Only refresh the current row if there is a current row and when the controller is dirty.
        if (this.currentRowBookmark) {
            // resolving the identies is only required for offline data
            // the resolveIdentitiesInRow checks if the value starts with the IdentityReplacer.prefix and if not does nothing
            // so with online data or it doesn't start with tsf_unique the code does nothing
            var storageContainer = this.application.getStorageContainer();
            storageContainer.resolveIdentitiesInRow(this.objView, this.currentRowBookmark).done(function (resolvedBookmark) {
                var currentRowRecordSet = new TSFRecordSet(_this.application, _this.objView);
                // Create a custom recordset because we don't want to edit the controllers data set.
                var query = currentRowRecordSet.query = new TSFQuery(_this.obj.objId);
                for (var _i = 0, _a = _this.obj.pkProps; _i < _a.length; _i++) {
                    var pkProp = _a[_i];
                    var filterConditionEnum = pkProp.xmlDttp == "date" ? Enum.FilterCondition.DateEqualTo : Enum.FilterCondition.EqualTo;
                    var condition = new FilterContractCondition(pkProp, filterConditionEnum, resolvedBookmark.conditions[pkProp.objPropId].value);
                    query.whereClause.contextFilters.push(condition);
                }
                // Copy the pk values of the resolvedBookmark into the where clause.
                query.preferredIndex = IndexedDb.IndexedDbWrapper.pkIndexName;
                query.keyRange = IndexedDb.createPKKeyRangeFromBookmark(_this.obj, resolvedBookmark);
                // Copy the new refreshed row into the currentRowBookmark.
                // Don't edit the row index because we don't want the layout and context to be executed.
                currentRowRecordSet.fetchDataAsync().done(function (reader, status) {
                    if (reader && reader.length == 1) {
                        _this.currentRowBookmark = TSFRowBookmark.fromReader(_this.obj, reader.item(0));
                        deferred.resolve();
                    }
                    else {
                        deferred.reject();
                    }
                }).fail(function (status) {
                    deferred.reject();
                });
            });
        }
        else {
            deferred.resolve();
        }
        return deferred.promise();
    };
    TSFController.prototype.invalidateLookups = function () {
        for (var container in this.lookupContainers) {
            var lookupContainer = this.lookupContainers[container];
            lookupContainer.invalidateSelectionSet();
            this.events.emitLookupsetChanged(new LookupsetChangedEventArgs(lookupContainer));
        }
    };
    TSFController.prototype.waitForEditmodeFinished = function () {
        var deferred = jQuery.Deferred();
        var results = [];
        function buildControllerMap(controller) {
            results.push(controller);
            for (var i = 0; i < controller.childControllers.length; i++) {
                buildControllerMap(controller.childControllers[i]);
            }
        }
        buildControllerMap(this);
        for (var i = 0; i < results.length; i++) {
            var controller = results[i];
            if (controller.isInEditMode) {
                if (controller.currentEditor &&
                    controller.currentEditor.isDefaultEditable()) {
                    //If the row is modified in default editable, save it and then say edit mode is finished.
                    if (controller.currentEditor.currentRowModified) {
                        return controller.currentEditor.saveRow();
                    }
                    //If the row isn't modified in default editable, we can just say edit mode is finished.
                    return deferred.resolve().promise();
                }
                controller.editmodeLeavedCallback.push(function () {
                    deferred.resolve();
                });
                return deferred.promise();
            }
        }
        return deferred.resolve().promise();
    };
    TSFController.prototype.doOnlineSwitch = function () {
        if (!this.objView.offlineAvailable) {
            // Reset layoutstate for editbuttons and form fields when we go offline.
            this.resetState();
            this.invalidateData();
        }
        for (var i = 0; i < this.childControllers.length; i++) {
            var childController = this.childControllers[i];
            childController.doOnlineSwitch();
        }
    };
    TSFController.prototype.markDirtyBySync = function () {
        this.isDataDirty = true;
        this.events.emitBecameDirtyBySync(null);
        for (var i = 0; i < this.childControllers.length; i++) {
            this.childControllers[i].markDirtyBySync();
        }
    };
    TSFController.prototype.markDirty = function () {
        this.isDataDirty = true;
        for (var i = 0; i < this.childControllers.length; i++) {
            this.childControllers[i].markDirty();
        }
    };
    TSFController.prototype.invalidateData = function () {
        if (!this.objView.offlineAvailable) {
            this.recordSet.invalidate();
            this.isDataDirty = true;
            // The event can be thrown before the children are invalidated.
            // The abstractscreen calls a validate data and that only refreshes the parents.
            this.events.emitDatasetInvalidated(null);
        }
    };
    TSFController.prototype.validateData = function () {
        var _this = this;
        var deferred = jQuery.Deferred();
        if (this.parentController) {
            // Validate the parent and refresh the current controller if it has an online context or when its parent refreshed.
            this.parentController.validateData().always(function (refreshed) {
                if (!_this.objView.offlineAvailable || refreshed) {
                    _this.refreshData().always(function () {
                        deferred.resolve(true);
                    });
                }
                else {
                    deferred.resolve(false);
                }
            });
        }
        else {
            if (!this.objView.offlineAvailable) {
                this.refreshData().always(function () {
                    deferred.resolve(true);
                });
            }
            else {
                deferred.resolve(false);
            }
        }
        return deferred.promise();
    };
    TSFController.prototype.getContextFilters = function (objLink) {
        var conditions = [];
        // Note that a refresh invalidates all data and therefore nulls the currentRow.
        // Therefore its important that a refresh action is finished before the contextFilters are assembled.
        if (!objLink || !this.currentRow) {
            return {
                conditions: conditions,
                falseCondtion: true
            };
        }
        // Use the currentRowBookmark because the currentRow might be refreshed by LocalSync.
        var row = this.currentRowBookmark;
        var falseCondtion = false;
        for (var i = 0; i < objLink.props.length; i++) {
            var linkProp = objLink.props[i];
            var objProp = this.obj.objProps.object[linkProp.sourceProp.objPropId];
            var condition = row.conditions[objProp.objPropId];
            if (!condition.value) {
                falseCondtion = true;
            }
            else {
                conditions.push(new FilterContractCondition(linkProp.targetProp, objProp.xmlDttp !== "date" ? Enum.FilterCondition.EqualTo : Enum.FilterCondition.DateEqualTo, condition.value));
            }
        }
        return {
            conditions: conditions,
            falseCondtion: falseCondtion
        };
    };
    TSFController.prototype.getBadgeContractForObjLink = function (objLink) {
        var row = this.currentRowBookmark;
        if (!objLink || !row) {
            return null;
        }
        var dataRow = {};
        for (var _i = 0, _a = objLink.props; _i < _a.length; _i++) {
            var linkProp = _a[_i];
            var condition = row.conditions[linkProp.sourceProp.objPropId];
            if (!condition || condition.value == null) {
                return null;
            }
            dataRow[linkProp.targetProp.objPropId] = condition.value;
        }
        return dataRow;
    };
    TSFController.prototype.getBadgeContractForTask = function (taskLink) {
        var row = this.currentRowBookmark;
        if (!taskLink || !row) {
            return null;
        }
        var dataRow = {};
        for (var _i = 0, _a = taskLink.props.array; _i < _a.length; _i++) {
            var taskProp = _a[_i];
            var condition = row.conditions[taskProp.propId];
            if (!condition || condition.value == null) {
                return null;
            }
            dataRow[taskProp.taskParmtrId] = condition.value;
        }
        return dataRow;
    };
    TSFController.prototype.validateChildContextFilters = function () {
        for (var i = 0; i < this.childControllers.length; i++) {
            var child = this.childControllers[i];
            var objLink = child.controllerContext.objLinkDetailView.objLink;
            if (child.isDataDirty) {
                continue; // Already invalidated
            }
            var newContextFilters = this.getContextFilters(objLink).conditions;
            // When there are no or different context filters always invalidate.
            if (objLink.props.length == 0 || newContextFilters.length != child.query.whereClause.contextFilters.length) {
                child.markDirty();
                continue;
            }
            for (var j = 0; j < child.query.whereClause.contextFilters.length; j++) {
                var currentFilterPart = child.query.whereClause.contextFilters[j];
                // make sure one of the sides is a string; comparision on dates won't work otherwise
                if (!Utils.valuesEqual(currentFilterPart.dbFilterValue, newContextFilters[j].dbFilterValue)) {
                    child.markDirty();
                    break;
                }
            }
        }
    };
    TSFController.prototype.validateParentContextFilters = function () {
        if (this.parentController && this.parentController.isDataDirty) {
            // Resolve the identities in the currentRowBookmark, this always resolves and never rejects.
            return this.parentController.validateContext(true);
        }
        return jQuery.Deferred().resolve().promise();
    };
    TSFController.prototype.validateContext = function (refreshActiveRowToTop) {
        var _this = this;
        if (refreshActiveRowToTop === void 0) { refreshActiveRowToTop = false; }
        // We are in an empty detail, so nothing to check
        if (!this.currentRowBookmark) {
            return jQuery.Deferred().resolve().promise();
        }
        var storageContainer = this.application.getStorageContainer();
        return storageContainer.resolveIdentitiesInRow(this.objView, this.currentRowBookmark).then(function (resolvedBookmark) {
            // Set the resolvedBookmark as currentRowBookmark.
            // Don't edit the row index or whatsoever because we don't want the layout and context to be executed.
            _this.currentRowBookmark = resolvedBookmark;
            if (refreshActiveRowToTop) {
                var deferred_1 = jQuery.Deferred();
                _this.refreshCurrentRow().then(function () {
                    // Copy the new values to the reader
                    var bookmark = _this.currentRowBookmark;
                    var currentRow = _this.currentRow;
                    if (!bookmark || !currentRow) {
                        deferred_1.resolve();
                        return;
                    }
                    for (var _i = 0, _a = _this.obj.objProps.array; _i < _a.length; _i++) {
                        var objProp = _a[_i];
                        var condition = bookmark.conditions[objProp.objPropId];
                        if (condition) {
                            if (objProp.isFileColumn) {
                                currentRow.setFile(objProp.objPropId, condition.value);
                            }
                            else {
                                currentRow.setValue(objProp.objPropId, condition.value);
                            }
                        }
                        else {
                            currentRow.setValue(objProp.objPropId, null);
                        }
                    }
                    deferred_1.resolve();
                }, function () {
                    deferred_1.reject();
                });
                return deferred_1.resolve();
            }
        });
    };
    TSFController.prototype.getCombinedFilterSearchTerm = function () {
        var combinedFilterConditions = this.query.whereClause.combinedFilterConditions;
        if (combinedFilterConditions.length > 0) {
            return combinedFilterConditions[0].dbFilterValue;
        }
        return "";
    };
    TSFController.prototype.performCombinedFilter = function (value, presentationsCols) {
        var viewProps = this.objView.objViewProps.array;
        var conditions = this.query.whereClause.combinedFilterConditions;
        var oldValue = this.getCombinedFilterSearchTerm();
        var startEmptyWithFilterWasActive = this.recordSet.query.whereClause.startEmptyWithFilterActive;
        this.recordSet.query.whereClause.startEmptyWithFilterActive = false;
        value = value && value.trim();
        if (value !== oldValue) {
            this.recordSet.query.whereClause.containsFalseCondtion = false;
            conditions.splice(0, conditions.length);
            if (value) {
                for (var i = 0; i < viewProps.length; i++) {
                    var viewProp = viewProps[i];
                    var prop = viewProp.objProp;
                    if (viewProp.includeInGlobalFilter || (presentationsCols && presentationsCols.indexOf(prop.objPropId) != -1)) {
                        // Service layer doesn't know the translations so do a contains here and create an equalto condition
                        if (prop.domain != null) {
                            var elements = prop.domain.elements.array;
                            for (var j = 0; j < elements.length; j++) {
                                var elementTransl = elements[j].elementTransl.transl.toLowerCase();
                                if (elementTransl.indexOf(value.toLowerCase()) > -1) {
                                    conditions.push(new FilterContractCondition(prop, Enum.FilterCondition.EqualTo, elements[j].value));
                                }
                            }
                        }
                        else {
                            if (viewProp.isTranslatedLookup()) {
                                var listProp = viewProp.lookup.getTranslListProp().objProp;
                                var c = new FilterLookupContractCondition(viewProp.objLinkLookupView.objLink.refId, listProp, prop, Enum.FilterCondition.Contains, value);
                                // Don't push the condition if the value could not be converted to the type of the column.
                                if (c.filterValue !== undefined) {
                                    conditions.push(c);
                                }
                                continue;
                            }
                            // check if the values are valid for this type of columns
                            // For example, you can't put text in a numeric column because the C# service would fail to deserialize the value
                            var dttpIsDecimal = prop.xmlDttp === "double" || prop.xmlDttp === "decimal";
                            var dttpIsNumber = prop.xmlDttp === "int" || prop.xmlDttp === "short" || prop.xmlDttp === "long";
                            if (dttpIsDecimal || dttpIsNumber) {
                                var numberValue = value.replace(",", ".");
                                var floatParsedValue = parseFloat(numberValue);
                                if (isNaN(floatParsedValue) || numberValue != floatParsedValue) {
                                    continue;
                                }
                                //Skip the value if it's a decimal on a decimal forbidding xmlDttp because it causes errors for the C# service tier
                                if (dttpIsNumber) {
                                    if (parseInt(numberValue, 10) !== floatParsedValue) {
                                        continue;
                                    }
                                    //A separate check is needed for decimal separator as last character because
                                    //it gets stripped by both parseFloat and parseInt
                                    var lastCharacter = numberValue[numberValue.length - 1];
                                    if (lastCharacter === ".") {
                                        continue;
                                    }
                                }
                                conditions.push(new FilterContractCondition(prop, Enum.FilterCondition.Contains, numberValue));
                                continue;
                            }
                            if (prop.xmlDttp === "boolean") {
                                // Exclude boolean fields because it can't really work with booleans
                                // What should the user type (true, 1, false, 0)
                                continue;
                            }
                            if (prop.xmlDttp === "date") {
                                // EqualTo for dates, because a contains doesn't really work
                                var c = new FilterContractCondition(prop, Enum.FilterCondition.EqualTo, value);
                                // Don't push the condition if the value could not be converted to the type of the column.
                                if (c.filterValue !== undefined) {
                                    conditions.push(c);
                                }
                            }
                            else {
                                var c = new FilterContractCondition(prop, Enum.FilterCondition.Contains, value);
                                // Don't push the condition if the value could not be converted to the type of the column.
                                if (c.filterValue !== undefined) {
                                    conditions.push(c);
                                }
                            }
                        }
                    }
                }
            }
            //Abort a pending request before starting a new one
            if (this.recordSet.isCurrentlyLoading()) {
                this.recordSet.abortRequest();
            }
            this._currentAction = this.refreshData();
        }
    };
    TSFController.prototype.resetState = function () {
        this.layoutState.translateLayoutStateFromModel();
        this.contextState.translateContextStateFromModel();
        this.events.emitLayoutChanged(new LayoutEventArgs(this.layoutState));
        this.events.emitContextChanged(new ContextEventArgs(this.contextState));
    };
    TSFController.prototype.createOfflineLogicBuilder = function (func) {
        if (func()) {
            return new IndexedDb.RequestBuilder(this.application, this.objView);
        }
        else if (AppConfig.online) {
            return RequestBuilderFactory.createOnlineRequestBuilder(this.application, this.objView);
        }
        else {
            return new IndexedDb.RequestBuilder(this.application, this.objView);
        }
    };
    TSFController.prototype.searchNullableOfflineLogic = function (predicate) {
        var offlineLogic = (this.application.extendedProperties.forceOfflineLogic && Utils.getOfflineLogicObject(this.application, this.obj)) || {};
        return predicate(offlineLogic);
    };
    TSFController.prototype.removeIdenityFromObject = function (rowObject) {
        var viewProps = this.objView.objViewProps.array;
        for (var i = 0; i < viewProps.length; i++) {
            var viewProp = viewProps[i];
            if ((viewProp.objProp.identity || viewProp.hasLookup() && viewProp.lookup.dataProp.objProp.identity)
                && (rowObject[viewProp.objPropId] + "").indexOf(IdentityReplacer.prefix) == 0) {
                delete rowObject[viewProp.objPropId];
            }
        }
    };
    TSFController.supportsLayoutAndDefaultTrigger = function (controlId) {
        return controlId != Enum.ControlType.SIGNATURE;
    };
    TSFController.prototype.executeLayouts = function (layoutmode, source) {
        var _this = this;
        /* Call for:
            - edit, copy, add, field edited
            - cancel
            - refresh data for childs
            - refresh row
        */
        var deferred = jQuery.Deferred();
        if (this.obj.useLayouts && (source == null || (source.useLayouts && TSFController.supportsLayoutAndDefaultTrigger(source.controlId)))) {
            var rowObject = void 0;
            if (this.currentEditor) {
                rowObject = this.currentEditor.toWebserviceObject(true);
            }
            else {
                if (this.currentRow) {
                    rowObject = Utils.normalizeRow(this.currentRow, this.obj.objProps.array);
                }
                else {
                    rowObject = {};
                    // Add parent context to the row. Because the layout might be fired on an empty set.
                    this.addParentContextToRow(rowObject);
                }
            }
            var filter = function (objProp) {
                return objProp.useLayouts;
            };
            Utils.sanitizeRow(rowObject, this.obj.objProps.array, filter);
            // TODO: Check if this is still the case. Comment references C# service tier and Soap client
            // Remove tsf_unique's because it will crash the C# service tier when we are using a Soap client, we need to do this with layouts to because it might be a new offline row
            var builder = this.createOfflineLogicBuilder(this.forceOfflineLayouts);
            if (!builder.allowCustomIdentitiesInContracts()) {
                this.removeIdenityFromObject(rowObject);
            }
            builder.setCallbackMethod(function (reader, status) {
                if (!reader || !status.success) {
                    // layout failed, go back to the default model values
                    // The other gui's are also doing this.
                    _this.layoutState.translateLayoutStateFromModel();
                    _this.events.emitLayoutChanged(new LayoutEventArgs(_this.layoutState));
                    deferred.reject();
                }
                else {
                    var item = reader.item(0);
                    _this.layoutState.translateLayoutState(item);
                    _this.events.emitLayoutChanged(new LayoutEventArgs(_this.layoutState));
                    deferred.resolve();
                }
            }).executeLayout(rowObject, layoutmode, Enum.ImportMode.Regular);
        }
        else if (this.currentEditor == null) {
            // if layouts are disabled we need to force the refresh for the layout
            // or the add button might not be enabled in inherited situations
            // So we shouldn't do this while in editmode because the state wouldn't change - only after a save/delete
            this.events.emitLayoutChanged(new LayoutEventArgs(this.layoutState));
            deferred.resolve();
        }
        else {
            deferred.resolve();
        }
        return deferred.promise();
    };
    TSFController.prototype.executeDefaults = function (layoutmode, source) {
        var _this = this;
        var deferred = jQuery.Deferred();
        if (this.currentEditor && this.obj.useDefaults && (source == null || (source.useDefaults && TSFController.supportsLayoutAndDefaultTrigger(source.controlId)))) {
            var builder = this.createOfflineLogicBuilder(this.forceOfflineDefaults);
            // Ignore the file data for OData request, we copy them back later
            // We don't want to blow up the request
            var rowObject = this.currentEditor.toWebserviceObject(builder instanceof OData.RequestBuilder);
            var filter = function (objProp) {
                return objProp.useDefaults;
            };
            Utils.sanitizeRow(rowObject, this.obj.objProps.array, filter);
            // TODO: Check if this is still the case. Comment references C# service tier and Soap client
            // Remove tsf_unique's because it will crash the C# service tier when we are using a Soap client
            var builder = this.createOfflineLogicBuilder(this.forceOfflineDefaults);
            if (!builder.allowCustomIdentitiesInContracts()) {
                this.removeIdenityFromObject(rowObject);
            }
            builder.setCallbackMethod(function (reader, status) {
                // Check for editor, if editmode was canceled while the default was still busy, don't crash
                if (reader && status.success && _this.currentEditor) {
                    var item = reader.item(0) || new IndexedDb.IndexedDbDataReader({});
                    // When a user adds a row offline but the default is fired online we need to reset the tsf_unique_0 because it got lost
                    if (!builder.allowCustomIdentitiesInContracts()) {
                        var fixedRow = Utils.normalizeRow(item, _this.obj.objProps.array);
                        var viewProps = _this.objView.objViewProps.array;
                        for (var i = 0; i < viewProps.length; i++) {
                            var viewProp = viewProps[i];
                            // If the prop is an identity or when its a lookup with a dataprop that is an identity --> reset the value to tsf_unique
                            if ((viewProp.objProp.identity || viewProp.hasLookup() && viewProp.lookup.dataProp.objProp.identity)
                                && (_this.currentEditor.newRow[viewProp.objPropId] + "").indexOf(IdentityReplacer.prefix) == 0) {
                                fixedRow[viewProp.objPropId] = _this.currentEditor.newRow[viewProp.objPropId];
                            }
                            else if (viewProp.objProp.isFileColumn && fixedRow[viewProp.objPropId] && _this.currentEditor.newRow[viewProp.objPropId]) {
                                // There is a FileContract present, set the File because it was removed before executing the default
                                fixedRow[viewProp.objPropId].File = _this.currentEditor.newRow[viewProp.objPropId].File;
                            }
                        }
                        fixedRow["cursor_to_col_id"] = item.getString("cursor_to_col_id");
                        item = new IndexedDb.IndexedDbDataReader(fixedRow);
                    }
                    // Copy values to the editor
                    var objProps = _this.obj.objProps.array;
                    for (var i = 0; i < objProps.length; i++) {
                        var objProp = objProps[i];
                        if (objProp.useDefaultOutput) {
                            _this.currentEditor.setValue(objProp, item.getValueForObjProp(objProp));
                        }
                    }
                    _this.updateLookupContainers();
                    var newRowReader = new IndexedDb.IndexedDbDataReader(_this.currentEditor.newRow);
                    _this.events.emitDataRowValuesChanged(new DataRowValuesEventArgs(newRowReader));
                    var cursor = item.getString("cursor_to_col_id"), cursorProp = cursor ? _this.obj.objProps.object[cursor] : null;
                    if (cursorProp) {
                        _this.currentEditor.suggestCursorIndex(cursorProp);
                    }
                    deferred.resolve();
                }
                else {
                    deferred.reject();
                }
            }).executeDefault(rowObject, layoutmode, Enum.ImportMode.Regular, source);
        }
        else {
            deferred.resolve();
        }
        return deferred.promise();
    };
    TSFController.prototype.executeContexts = function () {
        var _this = this;
        var deferred = jQuery.Deferred();
        if (this.obj.useContexts) {
            var rowObject = {};
            if (this.currentRow) {
                rowObject = Utils.normalizeRow(this.currentRow, this.obj.objProps.array);
            }
            else {
                // Add parent context to the row. Because the context might be fired on an empty set.
                this.addParentContextToRow(rowObject);
            }
            var filter = function (objProp) {
                return objProp.useContext;
            };
            Utils.sanitizeRow(rowObject, this.obj.objProps.array, filter);
            // TODO: Check if this is still the case. Comment references C# service tier and Soap client
            // Remove tsf_unique's because it will crash the C# service tier when we are using a Soap client
            var builder = this.createOfflineLogicBuilder(this.forceOfflineContexts);
            if (!builder.allowCustomIdentitiesInContracts()) {
                this.removeIdenityFromObject(rowObject);
            }
            builder.setCallbackMethod(function (reader, status) {
                if (!reader || !status.success) {
                    // Context failed, fallback to default model values
                    _this.contextState.translateContextStateFromModel();
                    _this.events.emitContextChanged(new ContextEventArgs(_this.contextState));
                    deferred.reject();
                }
                else {
                    var item = reader.item(0) || new IndexedDb.IndexedDbDataReader({});
                    _this.contextState.translateContextState(item);
                    _this.events.emitContextChanged(new ContextEventArgs(_this.contextState));
                    deferred.resolve();
                }
            }).executeContext(rowObject);
        }
        else {
            deferred.resolve();
        }
        return deferred.promise();
    };
    TSFController.prototype.executeTask = function (taskView, contextObj) {
        var _this = this;
        var deferred = jQuery.Deferred();
        var rowObject = this.currentEditor.toWebserviceObject();
        // Check if the task may be executed offline.
        if (taskView.offlineExecutable) {
            var offlineCallback = function (reader, status) {
                if (!status.success) {
                    deferred.reject();
                }
                else {
                    var syncGroupsToSync = [];
                    if (contextObj && contextObj.syncGroupId) {
                        syncGroupsToSync.push(_this.application.syncGroups.key(contextObj.syncGroupId));
                    }
                    // Synchronize after the task is added to the queue or when the JavaScript task is finished.
                    // Don't wait for the synchronization to complete.
                    _this.application.localSync.fullSynchronize(false, syncGroupsToSync);
                    deferred.resolve(true);
                }
                // Remove controller editor - so all callbacks are fired (waitForEditmodeFinished)
                _this.clearControllerEditor();
            };
            var offlineTaskBuilder = new IndexedDb.RequestBuilder(this.application, this.objView);
            // Check if there is an offline task.
            if (offlineTaskBuilder.offlineTaskAvailable()) {
                // Execute it the JavaScript task when its found.
                offlineTaskBuilder.setCallbackMethod(offlineCallback).executeOfflineTask(rowObject);
            }
            else if (AppConfig.online) {
                // Add a "regular" task call to the synchronization queue.
                offlineTaskBuilder.setCallbackMethod(offlineCallback).executeTask(rowObject);
            }
            else {
                deferred.reject();
            }
        }
        else if (AppConfig.online) {
            // Execute the task online.
            var onlineTaskBuilder = RequestBuilderFactory.createOnlineRequestBuilder(this.application, this.objView);
            onlineTaskBuilder.setCallbackMethod(function (reader, status) {
                if (!status.success) {
                    deferred.reject();
                }
                else {
                    deferred.resolve(false);
                }
            }).executeTask(rowObject);
        }
        else {
            deferred.reject();
        }
        return deferred.promise();
    };
    TSFController.prototype.getFile = function (row, prop) {
        var deferred = jQuery.Deferred();
        var fileOptionsContract = {
            IncludeHashCodes: false,
            IncludeFiles: true,
            IncludeThumbnails: false
        };
        this.getFileInternal(row, prop, fileOptionsContract, "File", false)
            .then(function (value) { return deferred.resolve(value); })
            .catch(function (err) { return deferred.reject(err); });
        return deferred.promise();
    };
    TSFController.prototype.getImage = function (row, prop, maxWidth, maxHeight, useCache) {
        var deferred = jQuery.Deferred();
        var fileOptionsContract = {
            IncludeHashCodes: false,
            IncludeFiles: false,
            IncludeThumbnails: true,
            ThumbnailMaxHeight: maxHeight,
            ThumbnailMaxWidth: maxWidth
        };
        this.getFileInternal(row, prop, fileOptionsContract, "Thumbnail", useCache)
            .then(function (val) { return deferred.resolve(val); })
            .catch(function (err) { return deferred.reject(err); });
        return deferred.promise();
    };
    TSFController.prototype.getFileInternal = function (row, prop, fileOptionsContract, type, useCache) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (row == null) {
                    row = this.currentRow;
                }
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var _this = this;
                        var currentValue;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!(row && prop && (currentValue = row.getValueForObjProp(prop)) &&
                                        currentValue.HashCode != null && currentValue.HashCode != 0)) return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.application.extendedProperties.downloadFiles()];
                                case 1:
                                    if ((_a.sent()) === true) {
                                        this.application.fileCache.getCachedFile(currentValue.HashCode).done(function (file) {
                                            if (file) {
                                                resolve(file);
                                            }
                                            else {
                                                _this.getFileWhenOnline(row, prop, fileOptionsContract, type, useCache, resolve);
                                            }
                                        });
                                    }
                                    else {
                                        this.getFileWhenOnline(row, prop, fileOptionsContract, type, useCache, resolve);
                                    }
                                    return [3 /*break*/, 3];
                                case 2:
                                    if (currentValue) {
                                        resolve(currentValue.File);
                                    }
                                    else {
                                        resolve(null);
                                    }
                                    _a.label = 3;
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    TSFController.prototype.getFileWhenOnline = function (row, prop, fileOptionsContract, type, useCache, callback) {
        if (useCache) {
            // Check if the row contains a cached file.
            var cachedFileContract = row.getValueForObjProp(prop);
            if (cachedFileContract) {
                var cachedFile = cachedFileContract[type];
                if (!cachedFile && type != "File") {
                    cachedFile = cachedFileContract["File"];
                }
                if (cachedFile != null) {
                    callback(cachedFile);
                    return;
                }
            }
        }
        if (AppConfig.online) {
            var builder = this.createFileGetBuilder(row, prop, fileOptionsContract);
            builder.setCallbackMethod(function (reader, status) {
                if (reader && reader.length == 1 && status.success) {
                    var value = reader.item(0).getValueForObjProp(prop);
                    if (value) {
                        if (useCache) {
                            // Cache the file in the reader and copy the hashcode because when downloading we don't calculate the hash
                            var oldValue = row.getValueForObjProp(prop);
                            value.HashCode = oldValue.HashCode;
                            row.setFile(prop.objPropId, value);
                        }
                        // Return the requested type(thumb or file) or otherwise the File.
                        var file = value[type];
                        if (!file && type != "File") {
                            file = value["File"];
                        }
                        callback(file);
                        return;
                    }
                }
                callback(null);
            }).get();
        }
        else {
            callback(null);
        }
    };
    TSFController.prototype.createFileGetBuilder = function (row, prop, fileOptionsContract) {
        if (!AppConfig.online) {
            return null;
        }
        var obj = this.obj, serviceId = obj.objId, filterContract = new FilterContract(serviceId);
        for (var i = 0; i < obj.pkProps.length; i++) {
            var condition = new FilterContractCondition(obj.pkProps[i], Enum.FilterCondition.EqualTo, row.getValueForObjProp(obj.pkProps[i]));
            filterContract.conditions.push(condition);
        }
        var builder = RequestBuilderFactory.createOnlineRequestBuilder(this.application, this.objView)
            .addSelectionContract([prop.objPropId])
            .addFilterContract(filterContract)
            .addFileOptionsContract(fileOptionsContract);
        return builder;
    };
    /*
     * This method is called on the context controller to let it know it successfully called the task
     */
    TSFController.prototype.taskActionPerformed = function (taskView, success) {
        var properties = new ProcessEngine.CompletedProcessActionProperties(success);
        if (this.activeProcessFlow) {
            this.activeProcessFlow.Continue(properties);
        }
        else {
            var processFlow = this.objView.getTaskProcessFlowRoot(6 /* ExcTask */, taskView.task.taskId);
            if (processFlow) {
                this.activeProcessFlow = ProcessEngine.postActionCompleted(new ProcessEngine.CompletedProcessAction(processFlow, properties), this);
            }
        }
    };
    TSFController.prototype.fireProcessActionCompleted = function (processActionType, success) {
        var _this = this;
        var properties = new ProcessEngine.CompletedProcessActionProperties(success);
        if (this.activeProcessFlow) {
            // Reset the callstack or it might overflow
            window.setTimeout(function () {
                _this.activeProcessFlow.Continue(properties);
            });
        }
        else {
            var processFlow = this.objView.getProcessFlowRoot(processActionType);
            if (processFlow) {
                this.activeProcessFlow = ProcessEngine.postActionCompleted(new ProcessEngine.CompletedProcessAction(processFlow, properties), this);
            }
        }
    };
    TSFController.prototype.performObjProcessAction = function (processAction, pendingAction) {
        var _this = this;
        switch (processAction.processActionType) {
            case 3 /* AddRow */:
                this.events.emitProcessActionCompleted(new ProcessActionCompletedArgs(processAction));
                // We return something without a completedproperty; this way the processengine keeps waiting
                // We expect that something is listening to the event and switches to addmode again - if that fails we would hang in the processflow
                // so we guard against that by checking if there is an editor.
                if (this.currentEditor) {
                    return new ProcessEngine.CompletedProcessAction(processAction, null);
                }
                break;
            case 10 /* ActivateGrid */:
            case 11 /* ActivateForm */:
                this.events.emitProcessActionCompleted(new ProcessActionCompletedArgs(processAction));
                // We return something without a completedproperty; this way the processengine keeps waiting
                return new ProcessEngine.CompletedProcessAction(processAction, null);
            case 19 /* GotoFirstRow */:
            case 17 /* GotoPreviousRow */:
                // Only allow this when the row index is larger than zero
                // Otherwise we just fail the action
                if (this.rowIndexInternal > 0) {
                    this.setRowIndex(processAction.processActionType == 19 /* GotoFirstRow */ ? 0 : this.rowIndexInternal - 1)
                        .always(function () {
                        _this.fireProcessActionCompleted(processAction.processActionType, true);
                    });
                    return new ProcessEngine.CompletedProcessAction(processAction, null);
                }
            case 18 /* GotoNextRow */:
            case 20 /* GotoLastRow */:
                var data = this.recordSet.getData();
                if (data && this.rowIndexInternal < data.length - 1) {
                    this.setRowIndex(processAction.processActionType == 20 /* GotoLastRow */ ? data.length - 1 : this.rowIndexInternal + 1)
                        .always(function () {
                        _this.fireProcessActionCompleted(processAction.processActionType, true);
                    });
                    return new ProcessEngine.CompletedProcessAction(processAction, null);
                }
        }
        // Action not implemented; process it as failed
        return new ProcessEngine.CompletedProcessAction(processAction, new ProcessEngine.CompletedProcessActionProperties(false));
    };
    TSFController.prototype.saveCurrentRow = function () {
        var _this = this;
        // Called by default editable form
        // So after saving we need to copy the changes to the reader to make sure it is uptodate
        // because when editing an online table we need to update the SoapDataReader because we don't do a refresh so the reader would contain old data
        var deferred = jQuery.Deferred();
        if (!this.currentEditor) {
            deferred.resolve();
        }
        else {
            this.currentEditor.saveRow()
                .done(function (bookmark) {
                // Copy the row to the reader, because we won't refresh the reader
                var currentRow = _this.currentRow;
                var editorRow = _this.currentEditor.newRow;
                for (var _i = 0, _a = _this.obj.objProps.array; _i < _a.length; _i++) {
                    var objProp = _a[_i];
                    if (objProp.isFileColumn && editorRow[objProp.objPropId]) {
                        currentRow.setFile(objProp.objPropId, editorRow[objProp.objPropId]);
                    }
                    else {
                        currentRow.setValue(objProp.objPropId, editorRow[objProp.objPropId]);
                    }
                }
                _this.events.emitrowSaved(new DataRowValuesEventArgs(_this.currentRow));
                _this.masterController.markDirty();
                deferred.resolve();
            })
                .fail(function () {
                deferred.reject();
            });
        }
        return deferred.promise();
    };
    TSFController.prototype.saveEditmode = function () {
        var _this = this;
        var deferred = jQuery.Deferred();
        if (!this.currentEditor) {
            deferred.resolve();
        }
        else {
            var processActionType_1 = this.currentEditor.getActionTypeForProcessAction();
            this.currentEditor.saveRow()
                .done(function (bookmark) {
                // Only leave editmode and refreshed when save succeeds.
                // The saveRow function shows an error when the save failed.
                _this.clearControllerEditor();
                _this.masterController.markDirty();
                _this.refreshData(true, false, bookmark).always(function () {
                    _this.fireProcessActionCompleted(processActionType_1, true);
                    deferred.resolve();
                });
            })
                .fail(function () {
                deferred.reject();
            });
        }
        return deferred.promise();
    };
    TSFController.prototype.cancelEditmodeWithConfirm = function () {
        var deferred = jQuery.Deferred(), that = this;
        var popup = ConfirmationPopup.CreateYesNoPopup();
        var confirmCancelTransl = this.application.language.transl(Model.TranslKeys.confirmationCancel);
        var promise = popup.initialize(this.application.language.transl(Model.TranslKeys.cancel), confirmCancelTransl);
        promise.done(function (option) {
            if (option == Enum.ConfirmationOption.Yes) {
                that.currentAction = that.cancelEditMode().always(function () {
                    deferred.resolve();
                });
            }
            else {
                deferred.reject();
            }
        });
        return deferred.promise();
    };
    TSFController.prototype.cancelEditMode = function () {
        if (this.currentEditor) {
            var processActionType = this.currentEditor.getActionTypeForProcessAction();
            // When there isn't a default editable form clear the editor and fire the process action
            if (!this.currentEditor.isDefaultEditable()) {
                this.clearControllerEditor();
                this.fireProcessActionCompleted(processActionType, false);
            }
            else if (this.currentRow) {
                // there is a default editable form, so we clear the changes and enter editmode again
                // this is required when creating a new row and canceling it
                this.currentEditor.createEditRow();
            }
            else {
                // default form editmode but no row - which means we clear editmode
                this.clearControllerEditor();
            }
            // We need to update the lookup containers, it would be nice to do this in updatestatus but they need to change
            // before the emitDataRowValuesChanged event
            this.updateLookupContainers();
            // Emit a DataRowValuesChanged event because the controller selects the currentRow again.
            // This is only needed in case of a cancel because the save call refreshes the controllers data.
            this.events.emitDataRowValuesChanged(new DataRowValuesEventArgs(this.currentRow));
            return this.updateStatus(2 /* Layouts */ | 4 /* Contexts */, null);
        }
        return jQuery.Deferred().resolve().promise();
    };
    TSFController.prototype.clearControllerEditor = function () {
        if (this.currentEditor) {
            this.currentEditor.leave();
            this.currentEditor = null;
            this.onEditmodeChanged();
            for (var container in this.lookupContainers) {
                var lookupContainer = this.lookupContainers[container];
                var changed = lookupContainer.resetPrefilterState();
                if (changed) {
                    this.events.emitLookupsetChanged(new LookupsetChangedEventArgs(lookupContainer));
                }
            }
        }
    };
    TSFController.prototype.onEditmodeChanged = function () {
        this.events.emitEditmodeChanged(null);
        if (this.editmodeLeavedCallback && !this.isInEditMode) {
            for (var i = 0; i < this.editmodeLeavedCallback.length; i++) {
                this.editmodeLeavedCallback[i]();
            }
            this.editmodeLeavedCallback = [];
        }
    };
    TSFController.prototype.deleteRowWithConfirm = function () {
        if (!this.objView.confirmDelete) {
            this.currentAction = this.deleteRow();
        }
        else {
            var that = this;
            var popup = ConfirmationPopup.CreateYesNoPopup();
            var confirmDeleteTransl = this.application.language.transl(Model.TranslKeys.confirmationDeleteRow);
            var promise = popup.initialize(this.application.language.transl(Model.TranslKeys.Delete), confirmDeleteTransl);
            promise.done(function (confirmationOption) {
                if (confirmationOption == Enum.ConfirmationOption.Yes) {
                    that.currentAction = that.deleteRow();
                }
            });
        }
    };
    TSFController.prototype.deleteRow = function () {
        var _this = this;
        var deferred = jQuery.Deferred();
        var row = this.currentRow;
        if (!row || this.objView.allowDelete == false) {
            deferred.reject();
            return;
        }
        // Wait for the layout to complete, this is important because it can affect the deleteRowAccessType.
        this.updateStatusAction.always(function () {
            if (_this.layoutState.deleteRowAccessType == Enum.AccessType.Regular) {
                var builder = RequestBuilderFactory.createRequestBuilder(_this.application, _this.objView);
                builder.setCallbackMethod(function (reader, status) {
                    if (status.success) {
                        // Mark the parents and their children dirty because a delete might have caused changes in their data.
                        _this.masterController.markDirty();
                        _this.refreshData(true).always(function () {
                            deferred.resolve();
                        });
                        if (_this.objView.offlineRefreshAfterMutation) {
                            _this.application.localSync.refreshSyncGroup(_this.objView);
                        }
                    }
                    else {
                        deferred.reject();
                    }
                }).Delete(TSFRowBookmark.fromReader(_this.obj, row));
            }
            else {
                deferred.reject();
            }
        });
        return deferred.promise();
    };
    TSFController.prototype.newEditorInternal = function (deferred, func) {
        var _this = this;
        var continueFunc = function () {
            var retFunc = func();
            if (deferred.state() == "rejected")
                return;
            retFunc.then(function () {
                var editor = _this.currentEditor;
                _this.updateStatus(editor.updateRow ? 2 /* Layouts */ : 2 /* Layouts */ | 1 /* Defaults */, null)
                    .always(function () {
                    _this.updateLookupContainers();
                    _this.onEditmodeChanged();
                    deferred.resolve(editor);
                });
            }, function () {
                deferred.reject();
            });
        };
        // Note that this code isn't used yet because we don't support add/copy in editmode yet.
        if (this.currentEditor) {
            //Task controllers get reused and shouldn't POST their content, hence we return the editor
            // Only do this with tasks started from the menu, this preserves the fix for the lookup button
            // but doesn't introduce a problem with lookup values not being set to the new row in a task in other screens.
            if (this.obj.isTask) {
                if (window.location.href.indexOf("menu.html") >= 0) {
                    deferred.resolve(this.currentEditor);
                }
                else {
                    continueFunc();
                }
                return;
            }
            var that_1 = this;
            this.currentEditor.saveRow().always(function (bookmark) {
                if (this.state() === "rejected") {
                    deferred.reject();
                }
                else {
                    that_1.refreshData(true, false, bookmark).always(function () {
                        continueFunc();
                    });
                }
            });
        }
        else {
            continueFunc();
        }
    };
    TSFController.prototype.newRow = function (editor) {
        var _this = this;
        var deferred = jQuery.Deferred();
        var func = function () {
            // Force a refresh for the lookups; for example you just entered an order - switch to order_line
            // now the context contains tsf_unique_x but after syncing it is a number
            // the lookup control (combo) is already created and still has tsf_unique in his set which can't be found anymore
            var refreshLookups = !!_this.parentController && _this.parentController.isDataDirty;
            _this.currentEditor = new ControllerEditor(_this, editor);
            return _this.validateContext()
                .then(function () { return _this.setParentContextFiltersAsync(); })
                .then(function () {
                // First create a new row and set the default values
                _this.currentEditor.createNewRow();
                if (refreshLookups) {
                    _this.invalidateLookups();
                }
                if (_this.obj.isTask) {
                    // we need to copy over the values of the context row
                    var taskContext = _this.controllerContext;
                    for (var item in taskContext.taskRow) {
                        _this.currentEditor.newRow[item] = taskContext.taskRow[item];
                    }
                }
                editor.enter();
                // Fill in the parent props.
                _this.addParentContextToRow(_this.currentEditor.newRow);
            });
        };
        this.newEditorInternal(deferred, func);
        return deferred.promise();
    };
    TSFController.prototype.addParentContextToRow = function (rowObject) {
        if (rowObject && this.parentController) {
            var linkProps = this.controllerContext.objLinkDetailView.objLink.props;
            if (this.parentController.currentRow) {
                // Use the currentRowBookmark instead of the currentRow because the currentRow of the parent might be refreshed by LocalSync.
                var parentRowBookmark = this.parentController.currentRowBookmark;
                var parentObjProps = this.parentController.obj.objProps.object;
                for (var i = 0; i < linkProps.length; i++) {
                    var linkProp = linkProps[i];
                    if (parentObjProps[linkProp.sourceProp.objPropId]) {
                        var prop = parentObjProps[linkProp.sourceProp.objPropId];
                        var condition = parentRowBookmark.conditions[prop.objPropId];
                        if (condition) {
                            rowObject[linkProp.targetProp.objPropId] = condition.value;
                        }
                    }
                }
            }
        }
    };
    TSFController.prototype.editRow = function (editor) {
        var _this = this;
        var deferred = jQuery.Deferred();
        var func = function () {
            if (!_this.currentRowBookmark)
                return deferred.reject();
            var refreshRowPromise = _this.refreshCurrentRow();
            return refreshRowPromise.then(function () {
                _this.currentEditor = new ControllerEditor(_this, editor);
                _this.currentEditor.createEditRow();
                editor.enter();
            }, function () {
                var transl = _this.application.language.transl(Model.TranslKeys.gui_nocurrentrow);
                NavigationManager.showMessageWhenReady(_this.objView.objTransl.transl, [transl]);
                _this.refreshData(true);
            });
        };
        this.newEditorInternal(deferred, func);
        return deferred.promise();
    };
    TSFController.prototype.copyToNewRow = function (editor) {
        var _this = this;
        var deferred = jQuery.Deferred();
        var func = function () {
            var currentRow = _this.currentRow; // cache currentRow to not call the getter constantly  (in a loop)
            if (!currentRow)
                return deferred.reject().promise();
            // Force a refresh for the lookups; for example you just entered an order - switch to order_line
            // now the context contains tsf_unique_x but after syncing it is a number
            // the lookup control (combo) is already created and still has tsf_unique in his set which can't be found anymore
            var refreshLookups = !!_this.parentController && _this.parentController.isDataDirty;
            _this.currentEditor = new ControllerEditor(_this, editor);
            return _this.validateContext()
                .then(function () { return _this.setParentContextFiltersAsync(); })
                .then(function () {
                _this.currentEditor.createCopyRow();
                if (refreshLookups) {
                    _this.invalidateLookups();
                }
                editor.enter();
            });
        };
        this.newEditorInternal(deferred, func);
        return deferred.promise();
    };
    TSFController.prototype.getBreadCrumb = function () {
        // This can be an option in the future. For now, only show the breadcrumb when there is a parentController.
        var includeThisController = false;
        if (includeThisController) {
            return this.getBreadCrumbInternal();
        }
        else if (this.parentController) {
            return this.parentController.getBreadCrumbInternal();
        }
        return jQuery.Deferred().resolve("").promise();
    };
    TSFController.prototype.getBreadCrumbInternal = function () {
        var _this = this;
        var breadCrumb = "";
        var promise = null;
        if (this.parentController) {
            promise = this.parentController.getBreadCrumbInternal().done(function (value) {
                breadCrumb += value;
            });
        }
        else {
            promise = jQuery.Deferred().resolve().promise();
        }
        return promise.then(function () { return _this.getDisplayString(); })
            .then(function (thisBreadCrumb) {
            if (breadCrumb !== "" && thisBreadCrumb !== "") {
                breadCrumb += " > ";
            }
            if (thisBreadCrumb !== "") {
                breadCrumb += thisBreadCrumb;
            }
            return breadCrumb;
        });
    };
    TSFController.prototype.getDisplayString = function () {
        var objView = this.objView, row = this.currentRow;
        if (!row) {
            return jQuery.Deferred().resolve("").promise();
        }
        var viewProps = [];
        var lookupDisplayPropId = objView.obj.lookupDisplay.lookUpDisplayColId;
        if (lookupDisplayPropId && objView.objViewProps.object[lookupDisplayPropId]) {
            viewProps.push(objView.objViewProps.object[lookupDisplayPropId]);
        }
        else {
            for (var i = 0; i < objView.obj.pkProps.length; i++) {
                var objProp = objView.obj.pkProps[i];
                viewProps.push(objView.objViewProps.object[objProp.objPropId]);
            }
        }
        var value = "";
        for (var i = 0; i < viewProps.length; i++) {
            var viewProp = viewProps[i];
            if (value != "")
                value += " / ";
            if (viewProp.isTranslatedLookup()) {
                var lookupContainer = this.getLookupSet(viewProp);
                value += lookupContainer.getTranslFromTranslatedReader(row.getValueForObjProp(viewProp.objProp), row);
            }
            else {
                var columnValue = row.getValueForObjProp(viewProp.objProp);
                if (viewProp.objProp.xmlDttp == "date") {
                    if (viewProp.objProp.controlId == Enum.ControlType.DATE) {
                        value += moment(columnValue).format("DD-MM-YYYY");
                    }
                    else if (viewProp.objProp.controlId == Enum.ControlType.TIME) {
                        value += moment(columnValue).format("HH:mm");
                    }
                    else {
                        // controlId is Date
                        value += moment(columnValue).format("DD-MM-YYYY HH:mm");
                    }
                }
                else {
                    value += columnValue;
                }
            }
        }
        return jQuery.Deferred().resolve(value).promise();
    };
    TSFController.prototype.currentPrefilterStates = function () {
        return this.query.whereClause.prefilterState;
    };
    /*
     * @returns true when one or more prefilterstates are changed
     */
    TSFController.prototype.setPrefilterState = function (prefilterState, selected) {
        if (prefilterState.locked)
            return false;
        var changed = false;
        if (selected) {
            var group = prefilterState.prefilter.group;
            if (group != null && group.isExcluded) {
                var currentPrefilterState = this.currentPrefilterStates();
                for (var i = 0; i < currentPrefilterState.length; i++) {
                    if (prefilterState != currentPrefilterState[i] && group == currentPrefilterState[i].prefilter.group) {
                        if (currentPrefilterState[i].selected != false) {
                            changed = true;
                        }
                        currentPrefilterState[i].selected = false;
                    }
                }
            }
        }
        if (prefilterState.selected != selected) {
            changed = true;
        }
        prefilterState.selected = selected;
        return changed;
    };
    TSFController.clearControllers = function (application) {
        if (application) {
            TSFController.masterControllers[application.guiApplId] = {};
        }
        else {
            TSFController.masterControllers = {};
        }
    };
    TSFController.getOrCreateTaskController = function (application, taskView, contextController) {
        var list = TSFController.masterControllers[application.guiApplId];
        var objView = taskView.paramObjView;
        var controllerId = objView.objId + (objView.objViewId || "");
        if (list) {
            if (list[controllerId]) {
                //Because we're reusing TaskControllers, we need to reapply the contextController to properly
                //handle switching rows.
                var context_1 = list[controllerId].controllerContext;
                if (context_1 && contextController) {
                    context_1.applyTaskContext(contextController);
                }
                return list[controllerId];
            }
        }
        else {
            list = TSFController.masterControllers[application.guiApplId] = {};
        }
        var controller = list[controllerId] = new TSFController(application, objView);
        var context = new TaskControllerContext(objView, taskView);
        controller.initializeInternal(context);
        if (contextController) {
            context.applyTaskContext(contextController);
        }
        return controller;
    };
    TSFController.getOrCreateMasterController = function (application, objId, objViewId) {
        // TODO: controllers are currently saved here, we should move this to a more global object
        var controller = null;
        var list = TSFController.masterControllers[application.guiApplId];
        var controllerId = objId + (objViewId || "");
        if (list) {
            if (list[controllerId]) {
                return list[controllerId];
            }
        }
        else {
            list = TSFController.masterControllers[application.guiApplId] = {};
        }
        var obj = application.model.getObj(objId);
        var objView = objViewId ? obj.objViews.key(objViewId) : obj.defaultObjView;
        list[controllerId] = controller = new TSFController(application, objView);
        controller.initializeInternal(new MasterControllerContext(objView));
        return controller;
    };
    TSFController.getControllerFromQueryString = function (application, objId, objViewId, raw) {
        var masterController = TSFController.getOrCreateMasterController(application, objId, objViewId);
        var controller = masterController;
        if (masterController && raw) {
            for (var i = 0; i < raw.length; i++) {
                var rawItem = raw[i];
                if (rawItem.key == "link") {
                    var objLink = controller.objView.objLinkDetailViews.object[rawItem.value];
                    if (!objLink)
                        return null;
                    controller = controller.getOrCreateChildController(objLink);
                    if (!controller)
                        return null;
                }
                else if (rawItem.key == "lookup") {
                    // The controller is prepared by the abstractscreen;
                    // because the controller should know some conditions from the control
                    controller = controller.lookupController;
                }
                else {
                    // Skip unknown items
                    continue;
                }
            }
        }
        return controller;
    };
    TSFController.prototype.getOrCreateChildController = function (objLinkDetailView) {
        var childController = this.childControllers[objLinkDetailView.objLink.refId];
        if (!childController) {
            this.childControllers[objLinkDetailView.objLink.refId] = childController = new TSFController(this.application, objLinkDetailView.objView);
            this.childControllers.push(childController);
            childController.parentController = this;
            childController.initializeInternal(new DetailControllerContext(objLinkDetailView));
        }
        return childController;
    };
    TSFController.prototype.afterPropEdited = function (prop) {
        if (!this.currentEditor)
            return;
        var lookupContainers = this.lookupContainers;
        var rowObject = this.currentEditor.toWebserviceObject();
        for (var propId in lookupContainers) {
            var filterContainer = lookupContainers[propId];
            var objViewProp = this.objView.objViewProps.object[propId], filters = (objViewProp ? objViewProp.lookup.filters : null);
            if (filters) {
                for (var i = 0; i < filters.length; i++) {
                    if (filters[i].targetProp.objPropId == prop.objPropId) {
                        this.currentEditor.newRow[objViewProp.objPropId] = null;
                        break;
                    }
                }
            }
            this.updateLookupContainer(filterContainer, rowObject);
        }
        return this.updateStatus(1 /* Defaults */ | 2 /* Layouts */, prop);
    };
    TSFController.prototype.prepareLookupControl = function (objProp, displayValue, dataValue) {
        var lookupProp = this.objView.objViewProps.object[objProp.objPropId];
        var readOnly = !this.isInEditMode;
        var viewState = new DataViewState();
        if (readOnly && dataValue != null) {
            var dataProp = lookupProp.lookup.dataProp;
            viewState.whereClause.combinedFilterConditions.push(new FilterContractCondition(dataProp.objProp, Enum.FilterCondition.EqualTo, dataValue));
        }
        else if (!readOnly && dataValue == null && displayValue != null) {
            // The user was typing; create a contains filter
            var listProp = lookupProp.lookup.getTranslListProp().objProp;
            var targetProp = lookupProp.lookup.dataProp;
            var condition = lookupProp.hasLookup() && lookupProp.lookup.hasContinuedJoining()
                ? new FilterLookupContractCondition(targetProp.objLinkLookupView.objLink.refId, listProp, targetProp.objProp, Enum.FilterCondition.Contains, displayValue)
                : new FilterContractCondition(listProp, Enum.FilterCondition.Contains, displayValue);
            viewState.whereClause.combinedFilterConditions.push(condition);
        }
        {
            // add context filters when no context add a false condition
            var currentRow = void 0;
            if (readOnly) {
                currentRow = this.currentRow ? Utils.normalizeRow(this.currentRow, this.obj.objProps.array) : {};
            }
            else {
                currentRow = this.currentEditor.newRow;
            }
            var filters = lookupProp.lookup.filters;
            for (var i = 0; i < filters.length; i++) {
                var value = currentRow[filters[i].targetProp.objPropId];
                if (!value)
                    viewState.whereClause.containsFalseCondtion = true;
                viewState.whereClause.contextFilters.push(new FilterContractCondition(filters[i].sourceProp, Enum.FilterCondition.EqualTo, value));
            }
        }
        var lookupContainer = this.lookupContainers[objProp.objPropId];
        viewState.whereClause.prefilterState = lookupContainer.getClonedPrefilterState();
        this.lookupController = new TSFController(this.application, lookupProp.objLinkLookupView.objView);
        this.lookupController.initializeInternal(new LookupControllerContext(this, lookupProp.objLinkLookupView, lookupProp, dataValue, displayValue), viewState);
    };
    TSFController.prototype.hasLookupController = function () {
        return this.lookupController != null;
    };
    TSFController.prototype.lookupDialogClosed = function () {
        this.lookupController = null;
    };
    TSFController.prototype.updateLookupContainerPrefilterState = function (lookupContainer, newState) {
        // We are in editmode, copy the prefilter state to the lookupcontainer
        var oldState = lookupContainer.getClonedPrefilterState();
        if (oldState.length == newState.length) {
            var changed = false;
            for (var i = 0; i < oldState.length; i++) {
                if (oldState[i].selected != newState[i].selected) {
                    lookupContainer.setPrefilterState(newState[i].prefilter, newState[i].selected);
                    changed = true;
                }
            }
            if (changed) {
                lookupContainer.invalidateSelectionSet();
                this.events.emitLookupsetChanged(new LookupsetChangedEventArgs(lookupContainer));
            }
        }
    };
    TSFController.prototype.updateLookupContainer = function (lookupContainer, normalizedRow) {
        var changed = lookupContainer.addFiltersForSelectionSet(normalizedRow);
        if (changed) {
            this.events.emitLookupsetChanged(new LookupsetChangedEventArgs(lookupContainer));
        }
    };
    TSFController.prototype.updateLookupContainers = function () {
        var rowObject = this.currentEditor ? this.currentEditor.toWebserviceObject() : null;
        for (var container in this.lookupContainers) {
            var lookupContainer = this.lookupContainers[container];
            this.updateLookupContainer(lookupContainer, rowObject);
        }
    };
    TSFController.prototype.hasVisibleDetails = function () {
        return this.objView.objLinkDetailViews.array.length > 0;
    };
    TSFController.prototype.hasVisibleTasks = function () {
        return this.objView.taskLinkViews.length > 0;
    };
    TSFController.prototype.hasVisiblePrefilters = function () {
        var prefilters = this.currentPrefilterStates();
        for (var i = 0; i < prefilters.length; i++) {
            if (!prefilters[i].isHidden) {
                return true;
            }
        }
        return false;
    };
    TSFController.prototype.executeActionAfterSave = function (func) {
        if (this.isInEditMode && this.currentEditor.allowActions()) {
            this.currentEditor.validateEditors().then(func);
        }
        else {
            func();
        }
    };
    TSFController.masterControllers = {};
    return TSFController;
}());
//#region Layout/default/context state
/*
 * Note that the context state is mapped on the childObjs of the Obj instead of the ObjView.
 * The ObjView might have significant less childObjs than the Obj.
 */
var ContextState = /** @class */ (function () {
    function ContextState(obj) {
        this.obj = obj;
        this.detailContextState = {};
        this.taskContextState = {};
        this.translateContextStateFromModel();
    }
    ContextState.prototype.translateContextStateFromModel = function () {
        var obj = this.obj;
        var childObjs = obj.childObjs.array;
        for (var i = 0; i < childObjs.length; i++) {
            var objLink = childObjs[i];
            this.detailContextState[objLink.refId] = objLink.isDetail ? Enum.AccessType.Regular : Enum.AccessType.Hidden;
        }
        var objTasks = obj.tasks.array;
        for (var i = 0; i < objTasks.length; i++) {
            var taskLink = objTasks[i];
            this.taskContextState[taskLink.task.taskId] = Enum.AccessType.Regular;
        }
    };
    ContextState.prototype.translateContextState = function (reader) {
        var obj = this.obj;
        var type;
        var suffix = "_type";
        var childObjs = obj.childObjs.array;
        for (var i = 0; i < childObjs.length; i++) {
            var objLink = childObjs[i];
            if (objLink.contextTypeOutput) {
                type = reader.getNumber(objLink.refId + suffix);
            }
            else {
                type = objLink.isDetail ? Enum.AccessType.Regular : Enum.AccessType.Hidden;
            }
            if (type >= 2 || !objLink.isDetail) {
                this.detailContextState[objLink.refId] = Enum.AccessType.Hidden;
            }
            else if (type == 1) {
                this.detailContextState[objLink.refId] = Enum.AccessType.ReadOnly;
            }
            else {
                this.detailContextState[objLink.refId] = Enum.AccessType.Regular;
            }
        }
        var objTasks = obj.tasks.array;
        for (var i = 0; i < objTasks.length; i++) {
            var taskLink = objTasks[i];
            if (taskLink.contextTypeOutput) {
                type = reader.getNumber(taskLink.task.taskId + suffix);
            }
            else {
                type = Enum.AccessType.Regular;
            }
            if (type >= 2) {
                this.taskContextState[taskLink.task.taskId] = Enum.AccessType.Hidden;
            }
            else if (type == 1) {
                this.taskContextState[taskLink.task.taskId] = Enum.AccessType.ReadOnly;
            }
            else {
                this.taskContextState[taskLink.task.taskId] = Enum.AccessType.Regular;
            }
        }
    };
    ContextState.prototype.anyVisible = function () {
        // Any task visible?
        for (var taskId in this.taskContextState) {
            if (this.taskContextState[taskId] != Enum.AccessType.Hidden) {
                return true;
            }
        }
        // Any detail visible?
        for (var refId in this.detailContextState) {
            if (this.detailContextState[refId] != Enum.AccessType.Hidden) {
                return true;
            }
        }
        if (this.obj.reports.length > 0) {
            return true;
        }
        return false;
    };
    return ContextState;
}());
/*
 * Note that the layout state is mapped on the ObjViewProps instead of the ObjProps.
 * This is safe to do because the ammount of ObjViewProps is always equal to the ammount of ObjProps.
 */
var LayoutState = /** @class */ (function () {
    function LayoutState(objView) {
        this.objView = objView;
        this.fieldLayoutState = {};
        this.addRowAccessType = objView.allowAdd ? Enum.AccessType.Regular : Enum.AccessType.Hidden;
        this.copyRowAccessType = objView.allowCopy ? Enum.AccessType.Regular : Enum.AccessType.Hidden;
        this.deleteRowAccessType = objView.allowDelete ? Enum.AccessType.Regular : Enum.AccessType.Hidden;
        this.editRowAccessType = objView.allowUpdate ? Enum.AccessType.Regular : Enum.AccessType.Hidden;
        this.cancelRowAccessType = objView.allowAdd || objView.allowUpdate || objView.allowCopy ? Enum.AccessType.Regular : Enum.AccessType.Hidden;
        this.saveRowAccessType = objView.allowAdd || objView.allowUpdate || objView.allowCopy ? Enum.AccessType.Regular : Enum.AccessType.Hidden;
        this.translateLayoutStateFromModel();
    }
    LayoutState.prototype.translateLayoutStateFromModel = function () {
        var viewProps = this.objView.objViewProps.array;
        for (var i = viewProps.length - 1; i >= 0; i--) {
            var objViewProp = viewProps[i], maxAccessType = objViewProp.objProp.maxAccessType;
            if (maxAccessType == Enum.AccessType.ReadOnly) {
                this.fieldLayoutState[objViewProp.objPropId] = 2 /* ReadOnly */;
            }
            else if (maxAccessType == Enum.AccessType.Hidden) {
                this.fieldLayoutState[objViewProp.objPropId] = 0 /* Hidden */;
            }
            else if (objViewProp.mandatory) {
                this.fieldLayoutState[objViewProp.objPropId] = 4 /* Mandatory */;
            }
            else {
                this.fieldLayoutState[objViewProp.objPropId] = 3 /* Regular */;
            }
        }
    };
    LayoutState.prototype.translateLayoutState = function (reader) {
        var obj = this.objView.obj;
        var enabledAccessType = Service.BasicAccessType.Enabled;
        var disabledAccessType = Service.BasicAccessType.Hidden;
        // Only use the button types when the Obj allows it.
        if (obj.useLayoutsAddButton) {
            this.addRowAccessType = this.objView.allowAdd ? reader.getNumber("add_button_type", enabledAccessType) : disabledAccessType;
            this.copyRowAccessType = this.addRowAccessType;
        }
        if (obj.useLayoutsDeleteButton) {
            this.deleteRowAccessType = this.objView.allowDelete ? reader.getNumber("delete_button_type", enabledAccessType) : disabledAccessType;
        }
        if (obj.useLayoutsUpdateButton) {
            this.editRowAccessType = this.objView.allowUpdate ? reader.getNumber("update_button_type", enabledAccessType) : disabledAccessType;
        }
        if (obj.useLayoutsCancelButton) {
            this.cancelRowAccessType = reader.getNumber("cancel_button_type", enabledAccessType);
        }
        if (obj.useLayoutsConfirmButton) {
            this.saveRowAccessType = reader.getNumber("confirm_button_type", enabledAccessType);
        }
        var defaultType = Service.FieldAccessType.Regular;
        var defaultMandatory = Service.FieldMandatory.Optional;
        var viewProps = this.objView.objViewProps.array;
        for (var i = 0; i < viewProps.length; i++) {
            var objViewProp = viewProps[i];
            var type = void 0;
            if (objViewProp.objProp.useLayoutTypeOutput) {
                type = reader.getNumber(objViewProp.objPropId + "_type", defaultType);
            }
            else {
                type = Service.FieldAccessType.Regular;
            }
            var mand = void 0;
            if (objViewProp.objProp.useLayoutMandOutput) {
                mand = reader.getNumber(objViewProp.objPropId + "_mand", defaultMandatory);
            }
            else {
                mand = Service.FieldMandatory.Mandatory;
            }
            var maxAccessType = objViewProp.objProp.maxAccessType;
            if (maxAccessType == Enum.AccessType.Hidden || type >= 3) {
                this.fieldLayoutState[objViewProp.objPropId] = 0 /* Hidden */;
            }
            else if (type == 2) {
                this.fieldLayoutState[objViewProp.objPropId] = 1 /* HiddenKeepSpace */;
            }
            else if (maxAccessType == Enum.AccessType.ReadOnly || type == 1) {
                this.fieldLayoutState[objViewProp.objPropId] = 2 /* ReadOnly */;
            }
            else if (objViewProp.mandatory || mand > 0) {
                this.fieldLayoutState[objViewProp.objPropId] = 4 /* Mandatory */;
            }
            else {
                this.fieldLayoutState[objViewProp.objPropId] = 3 /* Regular */;
            }
        }
    };
    return LayoutState;
}());
//#endregion
