var PopupManager = /** @class */ (function () {
    function PopupManager() {
    }
    PopupManager.queuePopup = function (popupPromise, msg, atStart) {
        if (atStart === void 0) { atStart = false; }
        var deferred = jQuery.Deferred();
        var randomKey = new Date().getTime() + Math.random().toString(36).substring(7);
        var resolveList = PopupManager.queue.map(function (queueItem) {
            return queueItem.promise;
        });
        var queueItem = {
            key: randomKey,
            promise: popupPromise,
            msg: msg
        };
        var popupAlreadyQueued = false;
        var lastQueuedItem = PopupManager.queue[PopupManager.queue.length - 1];
        if (atStart) {
            PopupManager.queue.splice(0, 0, queueItem);
        }
        else {
            if (msg !== null && lastQueuedItem && lastQueuedItem.msg === queueItem.msg) {
                popupAlreadyQueued = true;
            }
            else {
                PopupManager.queue.push(queueItem);
            }
        }
        //If the popup was already queued, we reject the queue request.
        if (popupAlreadyQueued) {
            deferred.reject();
        }
        else {
            jQuery.when.apply(undefined, resolveList).then(function () {
                window.setTimeout(deferred.resolve, 100);
            });
            popupPromise.always(function () {
                var index = PopupManager.findIndexByKey(randomKey);
                if (index !== null) {
                    PopupManager.queue.splice(index, 1);
                }
            });
        }
        return deferred.promise();
    };
    PopupManager.resetQueue = function () {
        PopupManager.queue = [];
    };
    PopupManager.findIndexByKey = function (key) {
        var result = PopupManager.queue.filter(function (queueItem) {
            return queueItem.key === key;
        })[0];
        if (result) {
            return PopupManager.queue.indexOf(result);
        }
        return null;
    };
    PopupManager.queue = [];
    return PopupManager;
}());
