var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var StyleSheetGenerator = /** @class */ (function () {
    function StyleSheetGenerator() {
    }
    StyleSheetGenerator.generateFullStyle = function (application) {
        return __awaiter(this, void 0, void 0, function () {
            var style, css, objs, i, obj, con, _i, _a, cubeView, _b, _c, cubeField, l, styleElement, lastAppl;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        style = application.style;
                        if (style) {
                            StyleSheetGenerator.generateStyle(style);
                        }
                        else {
                            StyleSheetGenerator.resetLayout();
                        }
                        css = "";
                        objs = application.model.objs.array;
                        for (i = 0; i < objs.length; i++) {
                            obj = objs[i];
                            for (con in obj.defaultObjView.conditionalLayouts) {
                                css += StyleSheetGenerator.generateConditionalLayoutStyle(obj.defaultObjView.conditionalLayouts[con]);
                            }
                            if (obj.cube) {
                                for (_i = 0, _a = obj.cube.allCubeViews.array; _i < _a.length; _i++) {
                                    cubeView = _a[_i];
                                    for (_b = 0, _c = cubeView.cubeViewFields.array; _b < _c.length; _b++) {
                                        cubeField = _c[_b];
                                        for (l = 0; l < cubeField.conditionalLayouts.length; l++) {
                                            css += StyleSheetGenerator.generateConditionalLayoutStyle(cubeField.conditionalLayouts[l]);
                                        }
                                    }
                                }
                            }
                        }
                        if (css !== "") {
                            styleElement = document.createElement("style");
                            styleElement.type = "text/css";
                            styleElement.innerText = css;
                            document.head.appendChild(styleElement);
                        }
                        StyleSheetGenerator.addCustomCss(application);
                        lastAppl = {
                            applId: application.guiApplId
                        };
                        return [4 /*yield*/, Utils.Preferences.setItem(StyleSheetGenerator.lastLoadedStyleKey, Utils.serializeJSON(lastAppl))];
                    case 1:
                        _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    StyleSheetGenerator.generateStyle = function (style) {
        // Previously statusbar was an iOS only plugin - it is now also available on other platforms
        // Because our color is visible in the iOS statusbar (not on Android) so we only enable this on iOS
        if (typeof StatusBar !== "undefined" && style.pageHeader.backgroundGradient.color1 && Utils.getiOSVersion() != null) {
            var brightness = Utils.Color.numberToColor(style.pageHeader.backgroundGradient.color1).getBrightness();
            if (brightness < 0.5) {
                StatusBar.styleLightContent();
            }
            else {
                StatusBar.styleDefault();
            }
        }
        var modifyVarObject = {};
        StyleSheetGenerator.insertColor(modifyVarObject, style.documentBackgroundColor, '@document-background-color');
        StyleSheetGenerator.insertGradient(modifyVarObject, style.pageHeader.backgroundGradient, '@page-header-background', '@page-header-background-start', '@page-header-background-end');
        if (style.pageHeader.font) {
            // Font size isn't implemented because it breaks the layout to much.
            // Temporary disabled because layouts get copied and this break to much.
            //StyleSheetGenerator.insertText(modifyVarObject, style.pageHeader.font.fontFace, '@page-header-text-font-family');
            StyleSheetGenerator.insertTextStyle(modifyVarObject, style.pageHeader.font, '@page-header-text-color', '@page-header-text-font-weight', '@page-header-text-font-style', '@page-header-text-decoration');
        }
        StyleSheetGenerator.insertGradient(modifyVarObject, style.pageFooter.backgroundGradient, '@page-footer-background', '@page-footer-background-start', '@page-footer-background-end');
        StyleSheetGenerator.insertColor(modifyVarObject, style.popupBackgroundColor, '@popup-background-color');
        // Quickbar
        // Quickbar headers
        StyleSheetGenerator.insertGradient(modifyVarObject, style.quickbar.headerGradient, '@menu-header-background', '@menu-header-background-start', '@menu-header-background-end');
        if (style.quickbar.headerMouseoverGradient.color1 == -1) {
            StyleSheetGenerator.insertGradient(modifyVarObject, style.quickbar.headerGradient, '@menu-header-hover-background', '@menu-header-hover-background-start', '@menu-header-hover-background-end');
        }
        else {
            StyleSheetGenerator.insertGradient(modifyVarObject, style.quickbar.headerMouseoverGradient, '@menu-header-hover-background', '@menu-header-hover-background-start', '@menu-header-hover-background-end');
        }
        if (style.quickbar.headerFont) {
            StyleSheetGenerator.insertTextStyle(modifyVarObject, style.quickbar.headerFont, '@menu-header-textcolor', '@menu-header-text-font-weight', '@menu-header-text-font-style', '@menu-header-text-decoration');
            StyleSheetGenerator.insertText(modifyVarObject, style.quickbar.headerFont.fontFace, '@menu-header-font-family');
        }
        if (style.quickbar.headerMouseoverFont) {
            StyleSheetGenerator.insertTextStyle(modifyVarObject, style.quickbar.headerMouseoverFont, '@menu-header-hover-textcolor', '@menu-header-hover-text-font-weight', '@menu-header-hover-text-font-style', '@menu-header-hover-text-decoration');
        }
        // Quickbar items
        StyleSheetGenerator.insertGradient(modifyVarObject, style.quickbar.itemGradient, '@menu-item-background', '@menu-item-background-start', '@menu-item-background-end');
        if (style.quickbar.headerMouseoverGradient.color1 == -1) {
            StyleSheetGenerator.insertGradient(modifyVarObject, style.quickbar.itemGradient, '@menu-item-hover-background', '@menu-header-item-background-start', '@menu-item-hover-background-end');
        }
        else {
            StyleSheetGenerator.insertGradient(modifyVarObject, style.quickbar.itemMouseoverGradient, '@menu-item-hover-background', '@menu-item-hover-background-start', '@menu-item-hover-background-end');
        }
        if (style.quickbar.itemFont) {
            StyleSheetGenerator.insertTextStyle(modifyVarObject, style.quickbar.itemFont, '@menu-item-textcolor', '@menu-item-text-font-weight', '@menu-item-text-font-style', '@menu-item-text-decoration');
            StyleSheetGenerator.insertText(modifyVarObject, style.quickbar.itemFont.fontFace, '@menu-item-font-family');
        }
        if (style.quickbar.itemMouseoverFont) {
            StyleSheetGenerator.insertTextStyle(modifyVarObject, style.quickbar.itemMouseoverFont, '@menu-item-hover-textcolor', '@menu-item-hover-text-font-weight', '@menu-item-hover-text-font-style', '@menu-item-hover-text-decoration');
        }
        if (style.tiles) {
            // Tile groups
            if (style.tiles.tileGroupFont) {
                StyleSheetGenerator.insertFullFontStyle(modifyVarObject, style.tiles.tileGroupFont, '@tiles-group-font');
            }
            StyleSheetGenerator.insertColor(modifyVarObject, style.tiles.tileGroupBackgroundColor, '@tiles-group-background-color');
            StyleSheetGenerator.insertColor(modifyVarObject, style.tiles.tileGroupBorderColor, '@tiles-group-border-color');
            StyleSheetGenerator.insertColor(modifyVarObject, style.tiles.tileGroupMouseOverBackgroundColor, '@tiles-group-hover-background-color');
            // Tiles
            if (style.tiles.tileFont) {
                StyleSheetGenerator.insertFullFontStyle(modifyVarObject, style.tiles.tileFont, '@tiles-font');
            }
            StyleSheetGenerator.insertColor(modifyVarObject, style.tiles.tileBorderColor, '@tiles-border-color');
            StyleSheetGenerator.insertGradient(modifyVarObject, style.tiles.tileGradient, '@tiles-background', '@tiles-background-start', '@tiles-background-end');
            if (style.tiles.tileMouseOverFont) {
                StyleSheetGenerator.insertFullFontStyle(modifyVarObject, style.tiles.tileMouseOverFont, '@tiles-hover-font');
            }
            StyleSheetGenerator.insertColor(modifyVarObject, style.tiles.tileMouseOverBorderColor, '@tiles-hover-border-color');
            StyleSheetGenerator.insertGradient(modifyVarObject, style.tiles.tileMouseOverGradient, '@tiles-hover-background', '@tiles-hover-background-start', '@tiles-hover-background-end');
        }
        // Grid
        if (typeof window["cordova"] === "undefined") {
            StyleSheetGenerator.insertGradient(modifyVarObject, style.grid.rowMouseOverGradient, "@grid-row-hover-background", '@grid-row-hover-background-start', '@grid-row-hover-background-end');
        }
        StyleSheetGenerator.insertGradient(modifyVarObject, style.grid.activeRowGradient, "@grid-row-active-background", '@grid-row-active-background-start', '@grid-row-active-background-end');
        // Form
        StyleSheetGenerator.insertGradient(modifyVarObject, style.mandatoryFieldGradient, null, '@form-mandatory-field-color', '@form-mandatory-field-color2');
        StyleSheetGenerator.insertGradient(modifyVarObject, style.readonlyFieldGradient, null, '@form-readonly-field-color', '@form-readonly-field-color2');
        StyleSheetGenerator.insertGradient(modifyVarObject, style.regularFieldGradient, null, '@form-regular-field-color', '@form-regular-field-color2');
        // Tab
        StyleSheetGenerator.insertGradient(modifyVarObject, style.tab.activeGradient, null, '@tab-active-color', '@tab-active-color2');
        StyleSheetGenerator.insertGradient(modifyVarObject, style.tab.inActiveGradient, null, '@tab-inactive-color', '@tab-inactive-color2');
        StyleSheetGenerator.insertGradient(modifyVarObject, style.tab.mouseOverGradient, null, '@tab-mouse-over-color', '@tab-mouse-over-color2');
        StyleSheetGenerator.insertColor(modifyVarObject, style.tab.lineColor, '@tab-border-color');
        // Button
        StyleSheetGenerator.insertGradient(modifyVarObject, style.button.activeGradient, null, '@button-active-color', '@button-active-color2');
        StyleSheetGenerator.insertGradient(modifyVarObject, style.button.inActiveGradient, null, '@button-inactive-color', '@button-inactive-color2');
        StyleSheetGenerator.insertGradient(modifyVarObject, style.button.mouseOverGradient, null, '@button-mouseover-color', '@button-mouseover-color');
        if (style.button.font) {
            // Font size isn't implemented because it breaks the layout to much.
            StyleSheetGenerator.insertColor(modifyVarObject, style.button.font.color, '@button-text-color');
            // Temporary disabled because layouts get copied and this break to much.
            //StyleSheetGenerator.insertText(modifyVarObject, style.button.font.fontFace, '@button-text-font-family');
            //StyleSheetGenerator.insertText(modifyVarObject, style.button.font.bold ? 'bold' : 'normal', '@button-text-font-weight');
            //StyleSheetGenerator.insertText(modifyVarObject, style.button.font.italic ? 'italic' : 'normal', '@button-text-font-style');
            //StyleSheetGenerator.insertText(modifyVarObject, style.button.font.underline ? 'underline' : 'none', '@button-text-decoration');
        }
        if (style.label.font) {
            // We don't have this defined in our tsf-theme.less - disable it for now
            //StyleSheetGenerator.insertTextStyle(modifyVarObject, style.label.font.color, '@label-textcolor');
        }
        if (style.labelActive.font) {
            StyleSheetGenerator.insertColor(modifyVarObject, style.labelActive.font.color, '@label-active-textcolor');
        }
        if (style.badgeLayout.color) {
            StyleSheetGenerator.insertColor(modifyVarObject, style.badgeLayout.color, '@menu-badge-background');
        }
        if (style.badgeLayout.labelFont) {
            StyleSheetGenerator.insertColor(modifyVarObject, style.badgeLayout.labelFont.color, '@menu-badge-text-color');
        }
        less.modifyVars(modifyVarObject);
    };
    StyleSheetGenerator.addCustomCss = function (application) {
        var codeIndex = typeof customCodeIndex !== "undefined" ? customCodeIndex : null;
        if (codeIndex && codeIndex["css"]) {
            var vrs = application.projectVersion.replace(/\./g, ""), webserviceName = application.projectName + vrs;
            var projectName = application.projectName.toLowerCase();
            var CssCode = codeIndex["css"];
            for (var i = 0; i < CssCode.length; i++) {
                var css = CssCode[i];
                if (css.project.toLowerCase() == projectName &&
                    css.version == application.projectVersion) {
                    var linkElement = document.createElement("link");
                    linkElement.href = css.file;
                    linkElement.rel = "stylesheet";
                    linkElement.className = webserviceName;
                    document.head.appendChild(linkElement);
                }
            }
        }
    };
    StyleSheetGenerator.removeCustomCSS = function (application) {
        var vrs = application.projectVersion.replace(/\./g, ""), projectName = application.projectName + vrs;
        var list = document.head.querySelectorAll("[class='" + projectName + "']");
        for (var i = list.length - 1; i >= 0; i--) {
            document.head.removeChild(list.item(i));
        }
    };
    StyleSheetGenerator.generateConditionalLayoutStyle = function (conditionalLayout) {
        var css = "." + conditionalLayout.conditionalLayoutID + " { ";
        if (conditionalLayout.backGroundColor1) {
            css += "background-color:" + conditionalLayout.backGroundColor1 + "; ";
        }
        if (conditionalLayout.font) {
            if (conditionalLayout.font.color) {
                css += "color: " + Utils.Color.hexFromArgb(conditionalLayout.font.color) + "; ";
            }
            if (conditionalLayout.font.fontFace) {
                css += "font-family: " + conditionalLayout.font.fontFace + "; ";
            }
            if (conditionalLayout.font.fontSize) {
                css += "font-size: " + conditionalLayout.font.fontSize + "; ";
            }
            if (conditionalLayout.font.bold) {
                css += "font-weight: bold; ";
            }
            if (conditionalLayout.font.italic) {
                css += "font-style: italic; ";
            }
            if (conditionalLayout.font.italic) {
                css += "text-decoration: underline; ";
            }
        }
        css += " } ";
        return css;
    };
    StyleSheetGenerator.insertFullFontStyle = function (object, font, field) {
        if (font === null || font === undefined) {
            return;
        }
        this.insertText(object, font.fontFace, field + '-family');
        this.insertTextStyle(object, font, field + '-color', field + '-weight', field + '-style', field + '-decoration', field + '-size');
    };
    StyleSheetGenerator.insertText = function (object, value, field) {
        if (value !== null) {
            object[field] = value;
        }
    };
    StyleSheetGenerator.insertTextStyle = function (object, font, fontColorField, fontWeightField, fontStyleField, fontTextDecorationField, fontSizeField) {
        if (font.color !== null) {
            object[fontColorField] = Utils.Color.hexFromArgb(font.color);
        }
        object[fontWeightField] = font.bold ? 'bold' : 'normal';
        object[fontStyleField] = font.italic ? 'italic' : 'normal';
        object[fontTextDecorationField] = font.underline ? 'underline' : 'none';
        if (fontSizeField && !Utils.isEmpty(font.fontSize)) {
            object[fontSizeField] = font.fontSize;
        }
    };
    StyleSheetGenerator.insertColor = function (object, color, field) {
        if (color !== null && color !== undefined) {
            object[field] = Utils.Color.hexFromArgb(color);
        }
    };
    StyleSheetGenerator.insertGradient = function (object, gradient, baseField, field1, field2) {
        // When color1 is null, don't insert the gradient but keep the default value.
        if (gradient.color1 != null) {
            var color1 = Utils.Color.hexFromArgb(gradient.color1), color2 = (gradient.color2 ? Utils.Color.hexFromArgb(gradient.color2) : color1);
            object[field1] = color1;
            object[field2] = color2;
            if (baseField) {
                object[baseField] = color1;
            }
        }
    };
    StyleSheetGenerator.loadLastLoadedLayout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var val, lastLoadedAppl, cache, fonts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Utils.Preferences.getItem(StyleSheetGenerator.lastLoadedStyleKey)];
                    case 1:
                        val = _a.sent();
                        lastLoadedAppl = (val ? Utils.deserializeJSON(val) : null);
                        if (!val) {
                            return [2 /*return*/, Promise.reject("")];
                        }
                        cache = new TSFCache();
                        return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                                var _this = this;
                                return __generator(this, function (_a) {
                                    cache.initializeDatabase().then(function () {
                                        return StyleSheetGenerator.loadFonts(cache, lastLoadedAppl.applId)
                                            .then(function (fontItems) {
                                            fonts = fontItems;
                                            return _this.loadGuiThemes(cache, lastLoadedAppl.applId, fonts);
                                        }).then(function (style) {
                                            if (style) {
                                                resolve(style);
                                            }
                                            else {
                                                StyleSheetGenerator.resetLayout();
                                                resolve(null);
                                            }
                                        });
                                    })
                                        .fail(function (err) {
                                        StyleSheetGenerator.resetLayout();
                                        reject(err);
                                    })
                                        .always(function () { return cache.dispose(); });
                                    return [2 /*return*/];
                                });
                            }); })];
                }
            });
        });
    };
    StyleSheetGenerator.loadFonts = function (cache, guiApplId) {
        return StyleSheetGenerator.executeRequest(cache, guiApplId, "font")
            .then(function (items) {
            var fonts = {};
            BaseModelReader.importFonts(items, fonts);
            return fonts;
        })
            .fail(function (err) { return jQuery.Deferred().reject(err).promise(); });
    };
    StyleSheetGenerator.loadGuiThemes = function (cache, guiApplId, fonts) {
        var resurrector = new Resurrect({
            resolver: new Resurrect.NamespaceResolver(Model.ConstructorMapping),
            cleanup: true
        });
        var modelCacher = new IndexedDb.IndexedDbModelCacher(cache);
        return modelCacher.getGetGuiCache("style" + guiApplId).then(function (result) {
            try {
                return resurrector.resurrect(result);
            }
            catch (_a) {
                return null;
            }
        });
    };
    StyleSheetGenerator.executeRequest = function (cache, guiApplId, getGuiName) {
        var deferred = jQuery.Deferred();
        var transaction = cache.database.transaction([TSFCache.modelCacheTable], "readonly");
        var store = transaction.objectStore(TSFCache.modelCacheTable);
        // Don't use a keyrange here, shim doesn't work (store.get with keyrange isn't implemented)
        var req = store.get(getGuiName + guiApplId);
        req.onsuccess = function () {
            if (req.result) {
                var items = IndexedDb.IndexedDbArrayReader.deserialize(req.result.response);
                deferred.resolve(items);
            }
            else {
                // No previous layout
                deferred.resolve([]);
            }
        };
        req.onerror = deferred.reject;
        return deferred.promise();
    };
    StyleSheetGenerator.resetLayout = function () {
        less.modifyVars({});
        jQuery("#login .pictureFooter").remove();
    };
    StyleSheetGenerator.lastLoadedStyleKey = "LastUsedApplication";
    return StyleSheetGenerator;
}());
