var TSFNativeScroll = /** @class */ (function () {
    function TSFNativeScroll(element, options) {
        this.element = element;
        if (typeof options.threshold === "undefined") {
            options.threshold = 100;
        }
        var that = this;
        var lastCall = 0;
        var timer;
        var timerStopped;
        var handler = function () {
            var curr = (new Date()).getTime(), diff = curr - lastCall;
            if (lastCall == 0 && options.onScrollStart) {
                options.onScrollStart.apply(that, arguments);
            }
            if (diff >= options.threshold) {
                lastCall = curr;
                if (options.onScrollMove) {
                    options.onScrollMove.apply(that, arguments);
                }
            }
            else {
                if (timer) {
                    clearTimeout(timer);
                }
                var args_1 = arguments;
                timer = window.setTimeout(function () {
                    handler.apply(that, args_1);
                }, options.threshold - diff);
            }
            if (timerStopped) {
                clearTimeout(timerStopped);
            }
            timerStopped = window.setTimeout(function () {
                if (options.onScrollEnd) {
                    options.onScrollEnd.apply(that, arguments);
                }
                lastCall = 0;
            }, options.threshold);
        };
        element.onscroll = handler;
    }
    TSFNativeScroll.prototype.refresh = function () {
        // Not needed
    };
    TSFNativeScroll.prototype.scrollTo = function (x, y, time, relative) {
        // Math.abs creates a positive integer from a negative one.
        this.element.scrollTop = Math.abs(y);
    };
    TSFNativeScroll.prototype.destroy = function () {
    };
    return TSFNativeScroll;
}());
var TSFScroll = /** @class */ (function () {
    function TSFScroll() {
    }
    TSFScroll.useNativeScroll = function () {
        //Android 4 can't use native scrolling because the scrollbar
        //doesn't update frequently, making it difficult for the user
        //to see where he/she is in the scrollable element.
        if (Utils.isAndroidVersionOrUp(4.4)) {
            return true;
        }
        if (Utils.getiOSVersion() != null) {
            return true;
        }
        if (Utils.isElectron()) {
            return true;
        }
        return false;
    };
    TSFScroll.setNativeScrollingCSS = function () {
        $("html").addClass("nativeScroll");
    };
    return TSFScroll;
}());
