// #Region Interfaces
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var FileContract = /** @class */ (function () {
    function FileContract() {
    }
    FileContract.CreateFromFileName = function (fileStorageFolder, fileName, file, thumbnail, hashCode) {
        var fileContract = new FileContract();
        //fileStorageFolder can be null for storage type "database", we'll just use the fileName as FilePath in that case
        if (!fileStorageFolder) {
            fileContract.FilePath = fileName;
            //If there's no backslash at the end of the fileStorageFolder we need to insert one.
        }
        else if (fileStorageFolder.lastIndexOf("\\") !== fileStorageFolder.length - 1) {
            fileContract.FilePath = fileStorageFolder + "\\" + fileName;
        }
        else {
            fileContract.FilePath = fileStorageFolder + fileName;
        }
        fileContract.FileName = fileName;
        fileContract.File = file;
        fileContract.Thumbnail = thumbnail;
        fileContract.HashCode = hashCode;
        return fileContract;
    };
    FileContract.CreateFromFilePath = function (filePath, file, thumbnail, hashCode) {
        var fileContract = new FileContract();
        fileContract.FilePath = filePath;
        var lastSeparator = Math.max(filePath.lastIndexOf("\\"), filePath.lastIndexOf("/"));
        fileContract.FileName = filePath.substr(lastSeparator + 1);
        fileContract.File = file;
        fileContract.Thumbnail = thumbnail;
        fileContract.HashCode = hashCode;
        return fileContract;
    };
    FileContract.CreateFilePathOnlyContract = function (filePath) {
        var fileContract = new FileContract();
        fileContract.FilePath = filePath;
        return fileContract;
    };
    return FileContract;
}());
// #EndRegion
// #Region Filters
var PrefilterContract = /** @class */ (function () {
    function PrefilterContract(name) {
        this.name = name;
    }
    return PrefilterContract;
}());
var PrefilterContracts = /** @class */ (function () {
    function PrefilterContracts(name) {
        this.name = name;
        this.subContracts = [];
    }
    return PrefilterContracts;
}());
var FilterContractCondition = /** @class */ (function () {
    function FilterContractCondition(listProp, comparision, filterValue, filterUntilValue) {
        this.listProp = listProp;
        this.comparision = comparision;
        this.filterValue = filterValue;
        this.filterUntilValue = filterUntilValue;
        // Note: IgnoreCasing is only available for Offline Functionality, since data comparison is done by the service tier.
        // Also note that IgnoreCasing can exclusively be set to true when you compare strings, its your responsibility to use it the right way.
        this.ignoreCasing = false;
        this.filterValue = Utils.convertToDataType(this.filterValue, listProp.objPropId, listProp.dttpId);
        if (typeof this.filterUntilValue !== "undefined") {
            this.filterUntilValue = Utils.convertToDataType(this.filterUntilValue, listProp.objPropId, listProp.dttpId);
        }
    }
    Object.defineProperty(FilterContractCondition.prototype, "targetPropId", {
        get: function () {
            return this.listProp.objPropId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FilterContractCondition.prototype, "oDataUrlName", {
        get: function () {
            if (this.listProp.isFileColumn) {
                return this.listProp.objPropId + "/FilePath";
            }
            return this.listProp.objPropId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FilterContractCondition.prototype, "dbFilterValue", {
        get: function () {
            if (this.listProp.isFileColumn && this.filterValue instanceof FileContract) {
                return this.filterValue.FilePath;
            }
            return this.filterValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FilterContractCondition.prototype, "dbFilterUntilValue", {
        get: function () {
            if (this.listProp.isFileColumn && this.filterUntilValue instanceof FileContract) {
                return this.filterUntilValue.FilePath;
            }
            return this.filterUntilValue;
        },
        enumerable: true,
        configurable: true
    });
    return FilterContractCondition;
}());
var FilterLookupContractCondition = /** @class */ (function (_super) {
    __extends(FilterLookupContractCondition, _super);
    function FilterLookupContractCondition(refId, listProp, targetProp, comparision, filterValue, filterUntilValue) {
        var _this = _super.call(this, listProp, comparision, filterValue, filterUntilValue) || this;
        _this.refId = refId;
        _this.targetProp = targetProp;
        return _this;
    }
    Object.defineProperty(FilterLookupContractCondition.prototype, "targetPropId", {
        get: function () {
            return this.targetProp.objPropId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FilterLookupContractCondition.prototype, "oDataUrlName", {
        get: function () {
            if (this.listProp.isFileColumn) {
                return this.refId + "/" + this.listProp.objPropId + "/FilePath";
            }
            return this.refId + "/" + this.listProp.objPropId;
        },
        enumerable: true,
        configurable: true
    });
    return FilterLookupContractCondition;
}(FilterContractCondition));
var FilterContract = /** @class */ (function () {
    function FilterContract(name) {
        this.name = name;
        this.filterContractType = Enum.FilterContractType.Values;
        this.subContracts = [];
        this.caseSensitive = false;
        this.conditions = [];
    }
    FilterContract.fromFilterConditions = function (objId, conditions) {
        var contract = new FilterContract(objId);
        contract.conditions = conditions;
        return contract;
    };
    FilterContract.fromDataRow = function (obj, row) {
        var filterContract = new FilterContract(obj.objId);
        for (var i = 0; i < obj.pkProps.length; i++) {
            var pkProp = obj.pkProps[i];
            var condition = new FilterContractCondition(pkProp, Enum.FilterCondition.EqualTo, row[pkProp.objPropId]);
            filterContract.conditions.push(condition);
        }
        return filterContract;
    };
    return FilterContract;
}());
var RequestStatus = /** @class */ (function () {
    function RequestStatus(success) {
        this.success = success;
        this.messages = [];
        this.requestSuccess = success;
    }
    RequestStatus.createFromXMLHttpRequest = function (request, reader) {
        // Instead of a status 202, it is 0 on a huawei Ascend P6 (Android 4.2.2)
        // 200 is the normal ok, 201 is Created, 202 is Accepted (what our bootstrap service does) and 204 is NoContent
        var requestSuccess = request.status >= 200 && request.status <= 204 || (request.status === 0 && reader != null);
        // reader != null check is to check if xml is invalid, but with odata we have a delete method which doesn't return anything
        var status = new RequestStatus(requestSuccess);
        status.request = request;
        status.messages = [];
        var appl = Model.TSFApplicationManager.Current.activeAppl;
        var lang = appl ? appl.language : AppConfig.language;
        var messagesHeader = request.getResponseHeader("TSFMessages");
        if (messagesHeader) {
            var base64Messages = messagesHeader.split(",");
            base64Messages.forEach(function (base64Message) {
                var decodedMessage;
                var message;
                try {
                    decodedMessage = atob(base64Message);
                    message = Utils.deserializeJSON(decodedMessage);
                }
                catch (e) {
                    return;
                }
                if (message) {
                    // Indicium 2017.1.1 uses: UnknownMessage
                    // Indicium > 2017.1.1 uses : IndiciumMessage with MessageID == unknown_error.
                    if (message.MessageType == "UnknownMessage") {
                        status.messages.push(lang.transl(Model.TranslKeys.unknownError));
                    }
                    else if (message.MessageType == "IndiciumMessage") {
                        status.messages.push(lang.transl(message.MessageID));
                    }
                    else if (message.MessageID || message.MessageType == "ApplicationMessage" || message.MessageType === "ApplicationDbMessage") {
                        status.messages.push(TSFMessage.translateTSFMessages(message, appl));
                    }
                    else if (message.RawMessage) {
                        status.messages.push(message.RawMessage);
                    }
                }
            });
            status.reason = 2 /* Server */;
        }
        if (!status.success) {
            if (request.aborted) {
                return status;
            }
            // Only push network errors when the application is online.
            if (request.status === 0 && AppConfig.online) {
                status.messages.push(lang.transl(Model.TranslKeys.networkError));
                status.reason = 3 /* Network */;
            }
            else if (request.status !== 0 && status.messages.length === 0) {
                var responseURL = request.responseURL;
                if (!this.isErrorIgnored(responseURL)) {
                    status.messages.push(lang.transl(Model.TranslKeys.unknownError));
                    status.reason = 0 /* Unknown */;
                }
            }
            // TODO fixed network errors first!
            // if(typeof Raven !== "undefined") {
            //     Raven.captureException(new Error(status.reason + " - " + status.messages));
            // }
        }
        if (status.messages.length > 0) {
            NavigationManager.showMessageWhenReady("", status.messages);
        }
        return status;
    };
    RequestStatus.isErrorIgnored = function (url) {
        var urlsToIgnoreErrorsFor = [
            "/" + OData.LOGOUT,
            "/" + OData.RESET_MODEL
        ];
        for (var _i = 0, urlsToIgnoreErrorsFor_1 = urlsToIgnoreErrorsFor; _i < urlsToIgnoreErrorsFor_1.length; _i++) {
            var ignoredError = urlsToIgnoreErrorsFor_1[_i];
            if (url.substr(url.length - ignoredError.length, ignoredError.length) === ignoredError) {
                return true;
            }
        }
        return false;
    };
    RequestStatus.TWO_FACTOR_AUTH_REQUESTED_REASON = "TWO_FACTOR_AUTH_REQUESTED";
    RequestStatus.EXPIRED_REASON = "EXPIRED";
    return RequestStatus;
}());
var IdentityReplacer = /** @class */ (function () {
    function IdentityReplacer(nr) {
        this.id = IdentityReplacer.prefix + nr.toString();
        this.databaseId = null;
    }
    IdentityReplacer.prefix = "tsf_unique_";
    return IdentityReplacer;
}());
var QueueItem = /** @class */ (function () {
    function QueueItem(actionType, pk, oldPk) {
        this.actionType = actionType;
        this.pk = pk.toObject();
        this.objId = pk.obj.objId;
        this.oldPk = (oldPk ? oldPk.toObject() : null);
        this.status = 0 /* UnSynced */;
    }
    return QueueItem;
}());
var SelectPart = /** @class */ (function () {
    function SelectPart() {
    }
    return SelectPart;
}());
var JoinCondition = /** @class */ (function () {
    function JoinCondition() {
    }
    return JoinCondition;
}());
var Enum;
(function (Enum) {
    var ConfirmationOption;
    (function (ConfirmationOption) {
        ConfirmationOption[ConfirmationOption["Ok"] = 0] = "Ok";
        ConfirmationOption[ConfirmationOption["Cancel"] = 1] = "Cancel";
        ConfirmationOption[ConfirmationOption["Yes"] = 2] = "Yes";
        ConfirmationOption[ConfirmationOption["No"] = 3] = "No";
    })(ConfirmationOption = Enum.ConfirmationOption || (Enum.ConfirmationOption = {}));
    var MenuType;
    (function (MenuType) {
        MenuType[MenuType["Listbar"] = 0] = "Listbar";
        MenuType[MenuType["Tiles"] = 1] = "Tiles";
    })(MenuType = Enum.MenuType || (Enum.MenuType = {}));
    var ControlType;
    (function (ControlType) {
        ControlType[ControlType["Default"] = 0] = "Default";
        ControlType[ControlType["CALCULATOR"] = 1] = "CALCULATOR";
        ControlType[ControlType["CHECKBOX"] = 2] = "CHECKBOX";
        ControlType[ControlType["COLOR"] = 3] = "COLOR";
        ControlType[ControlType["COMBO"] = 4] = "COMBO";
        ControlType[ControlType["CURRENCY"] = 5] = "CURRENCY";
        ControlType[ControlType["DATE"] = 6] = "DATE";
        ControlType[ControlType["DATETIME"] = 7] = "DATETIME";
        ControlType[ControlType["EMAIL"] = 8] = "EMAIL";
        ControlType[ControlType["FILE"] = 9] = "FILE";
        ControlType[ControlType["FOLDER"] = 11] = "FOLDER";
        ControlType[ControlType["GOOGLE_MAPS"] = 12] = "GOOGLE_MAPS";
        ControlType[ControlType["IMAGE_BLOB"] = 13] = "IMAGE_BLOB";
        ControlType[ControlType["IMAGE_LINK"] = 14] = "IMAGE_LINK";
        ControlType[ControlType["MULTILINE"] = 16] = "MULTILINE";
        ControlType[ControlType["NUMERIC"] = 17] = "NUMERIC";
        ControlType[ControlType["PERCENTAGE"] = 18] = "PERCENTAGE";
        ControlType[ControlType["TIME"] = 19] = "TIME";
        ControlType[ControlType["URL"] = 20] = "URL";
        ControlType[ControlType["VIDEO_LINK"] = 21] = "VIDEO_LINK";
        ControlType[ControlType["SQLEDITOR"] = 23] = "SQLEDITOR";
        ControlType[ControlType["SIGNATURE"] = 25] = "SIGNATURE";
        ControlType[ControlType["RADIO_VERTICAL"] = 26] = "RADIO_VERTICAL";
        ControlType[ControlType["RADIO_HORIZONTAL"] = 27] = "RADIO_HORIZONTAL";
        ControlType[ControlType["RADIO_BUTTON"] = 28] = "RADIO_BUTTON";
        ControlType[ControlType["HTML"] = 32] = "HTML";
        ControlType[ControlType["FILE_UPLOAD"] = 37] = "FILE_UPLOAD";
        ControlType[ControlType["IMAGE_UPLOAD"] = 38] = "IMAGE_UPLOAD";
        ControlType[ControlType["IMAGE_COMBO"] = 40] = "IMAGE_COMBO";
        ControlType[ControlType["PHONE_NUMBER"] = 41] = "PHONE_NUMBER";
        ControlType[ControlType["LABEL"] = 42] = "LABEL";
        ControlType[ControlType["GROUP_HEADER_LABEL"] = 43] = "GROUP_HEADER_LABEL";
        ControlType[ControlType["GROUP_HEADER_ICON"] = 44] = "GROUP_HEADER_ICON";
        ControlType[ControlType["BARCODE_SCANNER"] = 45] = "BARCODE_SCANNER";
    })(ControlType = Enum.ControlType || (Enum.ControlType = {}));
    /** Used in offline code - do not make it const */
    var SortDirection;
    (function (SortDirection) {
        SortDirection[SortDirection["Ascending"] = 0] = "Ascending";
        SortDirection[SortDirection["Descending"] = 1] = "Descending";
    })(SortDirection = Enum.SortDirection || (Enum.SortDirection = {}));
    var AccessType;
    (function (AccessType) {
        AccessType[AccessType["Regular"] = 0] = "Regular";
        AccessType[AccessType["ReadOnly"] = 1] = "ReadOnly";
        AccessType[AccessType["Hidden"] = 2] = "Hidden";
    })(AccessType = Enum.AccessType || (Enum.AccessType = {}));
    var FilterCondition;
    (function (FilterCondition) {
        FilterCondition[FilterCondition["EqualTo"] = 0] = "EqualTo";
        FilterCondition[FilterCondition["NotEqualTo"] = 1] = "NotEqualTo";
        FilterCondition[FilterCondition["GreaterThan"] = 2] = "GreaterThan";
        FilterCondition[FilterCondition["SmallerThan"] = 3] = "SmallerThan";
        FilterCondition[FilterCondition["GreaterThanOrEqualTo"] = 4] = "GreaterThanOrEqualTo";
        FilterCondition[FilterCondition["SmallerThanOrEqualTo"] = 5] = "SmallerThanOrEqualTo";
        FilterCondition[FilterCondition["Between"] = 6] = "Between";
        FilterCondition[FilterCondition["StartsWith"] = 7] = "StartsWith";
        FilterCondition[FilterCondition["Contains"] = 8] = "Contains";
        FilterCondition[FilterCondition["DoesNotContain"] = 9] = "DoesNotContain";
        FilterCondition[FilterCondition["IsNull"] = 10] = "IsNull";
        FilterCondition[FilterCondition["IsNotNull"] = 11] = "IsNotNull";
        FilterCondition[FilterCondition["DoesNotStartWith"] = 12] = "DoesNotStartWith";
        FilterCondition[FilterCondition["NotBetween"] = 13] = "NotBetween";
        FilterCondition[FilterCondition["True"] = 14] = "True";
        FilterCondition[FilterCondition["False"] = 15] = "False";
        FilterCondition[FilterCondition["DateEqualTo"] = 16] = "DateEqualTo";
        FilterCondition[FilterCondition["DateNotEqualTo"] = 17] = "DateNotEqualTo";
    })(FilterCondition = Enum.FilterCondition || (Enum.FilterCondition = {}));
    var FilterContractType;
    (function (FilterContractType) {
        FilterContractType[FilterContractType["Values"] = 0] = "Values";
        FilterContractType[FilterContractType["And"] = 1] = "And";
        FilterContractType[FilterContractType["Or"] = 2] = "Or";
    })(FilterContractType = Enum.FilterContractType || (Enum.FilterContractType = {}));
    /** Used in offline code - do not make it const */
    var LayoutMode;
    (function (LayoutMode) {
        LayoutMode[LayoutMode["Add"] = 0] = "Add";
        LayoutMode[LayoutMode["Update"] = 1] = "Update";
        LayoutMode[LayoutMode["Navigate"] = 2] = "Navigate";
    })(LayoutMode = Enum.LayoutMode || (Enum.LayoutMode = {}));
    var ImportMode;
    (function (ImportMode) {
        ImportMode[ImportMode["Regular"] = 0] = "Regular";
        ImportMode[ImportMode["Importing"] = 1] = "Importing";
    })(ImportMode = Enum.ImportMode || (Enum.ImportMode = {}));
    var FileError;
    (function (FileError) {
        FileError[FileError["NotFoundError"] = 1] = "NotFoundError";
        FileError[FileError["SecurityError"] = 2] = "SecurityError";
        FileError[FileError["AbortError"] = 3] = "AbortError";
        FileError[FileError["NotReadableError"] = 4] = "NotReadableError";
        FileError[FileError["EncodingError"] = 5] = "EncodingError";
        FileError[FileError["NoModificationAllowedError"] = 6] = "NoModificationAllowedError";
        FileError[FileError["InvalidStateError"] = 7] = "InvalidStateError";
        FileError[FileError["SyntaxError"] = 8] = "SyntaxError";
        FileError[FileError["InvalidModificationError"] = 9] = "InvalidModificationError";
        FileError[FileError["QuotaExceededError"] = 10] = "QuotaExceededError";
        FileError[FileError["TypeMismatchError"] = 11] = "TypeMismatchError";
        FileError[FileError["PathExistsError"] = 12] = "PathExistsError";
    })(FileError = Enum.FileError || (Enum.FileError = {}));
})(Enum || (Enum = {}));
/*
 * This modules contains code to help converting types returned by the server,
 * to types used in the controller and components.
 */
var Service;
(function (Service) {
    var FieldMandatory;
    (function (FieldMandatory) {
        FieldMandatory[FieldMandatory["Optional"] = 0] = "Optional";
        FieldMandatory[FieldMandatory["Mandatory"] = 1] = "Mandatory";
    })(FieldMandatory = Service.FieldMandatory || (Service.FieldMandatory = {}));
    var FieldAccessType;
    (function (FieldAccessType) {
        FieldAccessType[FieldAccessType["Regular"] = 0] = "Regular";
        FieldAccessType[FieldAccessType["ReadOnly"] = 1] = "ReadOnly";
        FieldAccessType[FieldAccessType["HiddenKeepSpace"] = 2] = "HiddenKeepSpace";
        FieldAccessType[FieldAccessType["Hidden"] = 3] = "Hidden";
    })(FieldAccessType = Service.FieldAccessType || (Service.FieldAccessType = {}));
    var BasicAccessType;
    (function (BasicAccessType) {
        BasicAccessType[BasicAccessType["Enabled"] = 0] = "Enabled";
        BasicAccessType[BasicAccessType["Disabled"] = 1] = "Disabled";
        BasicAccessType[BasicAccessType["Hidden"] = 2] = "Hidden";
    })(BasicAccessType = Service.BasicAccessType || (Service.BasicAccessType = {}));
})(Service || (Service = {}));
