var ApplicationMenu = /** @class */ (function () {
    function ApplicationMenu() {
        this.manager = Model.TSFApplicationManager.Current;
    }
    ApplicationMenu.prototype.initialize = function (callBack) {
        var _this = this;
        var navBar = this.element = this.createNavBar();
        this.$element = jQuery(this.element);
        navBar.className = "application-panel";
        var manager = this.manager;
        var $navBar = jQuery(navBar);
        $navBar.navbar();
        $navBar.on("click", ":not(.active)", "a", function () {
            var applIndex = jQuery(this).data('appl-index');
            var application = manager.appls[applIndex];
            if (application) {
                callBack(application);
            }
            else {
                jQuery(this).closest(":jqmData(role=popup)").popup('close');
            }
        });
        //Hide the applicationMenu if it's expanded and the user clicks on the ui-content.
        this.$overlay = jQuery(".application-menu-overlay");
        this.$overlay.off("click").on("click", function (event) {
            if (_this.$element.hasClass("expanded")) {
                _this.toggleApplicationMenu();
            }
            event.preventDefault();
            return false;
        });
        //Hide the overlay when reinitializing the ApplicationMenu
        this.$overlay.hide();
    };
    ApplicationMenu.prototype.createNavBar = function () {
        var navBar = document.createElement("div");
        navBar.setAttribute("data-role", "navbar");
        var ulList = document.createElement("ul");
        var appls = this.manager.appls;
        for (var i = 0; i < appls.length; i++) {
            var appl = appls[i];
            var appItem = this.createApplicationNavItem(appl, i);
            //Put the active appl as first menu item.
            if (this.manager.activeAppl === appl) {
                appItem.className += " ui-title";
                jQuery(ulList).prepend(appItem);
            }
            else {
                ulList.appendChild(appItem);
            }
        }
        navBar.appendChild(ulList);
        return navBar;
    };
    ApplicationMenu.prototype.createApplicationNavItem = function (application, index) {
        var _this = this;
        var listItem = document.createElement("li");
        listItem.className = "ui-li-has-icon";
        var listText = document.createElement("a");
        listText.className = "ui-btn";
        listText.setAttribute("data-appl-index", index + "");
        var span = document.createElement("span");
        span.textContent = application.transl;
        var applImage = document.createElement("img");
        if (application.icon) {
            applImage.src = Utils.createIconFromBase64(application.icon);
        }
        else {
            applImage.src = "img/application_24.png";
        }
        listText.appendChild(applImage);
        listText.appendChild(span);
        if (this.manager.activeAppl === application) {
            listItem.className += " active";
            if (this.manager.appls.length > 1) {
                var caratIcon = document.createElement("a");
                caratIcon.className = "ui-btn ui-btn-inline ui-icon-carat-d ui-btn-icon-notext ui-alt-icon";
                caratIcon.style.display = "inline-block";
                listText.appendChild(caratIcon);
                jQuery(listText).click(function () {
                    _this.toggleApplicationMenu();
                });
            }
        }
        listItem.appendChild(listText);
        return listItem;
    };
    ApplicationMenu.prototype.toggleApplicationMenu = function () {
        var $nonActiveApplications = jQuery(".ui-li-has-icon:not(.active)");
        if (this.$element.hasClass("expanded")) {
            this.$overlay.hide();
            $nonActiveApplications.hide();
            jQuery(".ui-icon-carat-u").removeClass("ui-icon-carat-u").addClass("ui-icon-carat-d");
        }
        else {
            this.$overlay.show();
            $nonActiveApplications.show();
            jQuery(".ui-icon-carat-d").removeClass("ui-icon-carat-d").addClass("ui-icon-carat-u");
        }
        this.$element.toggleClass("expanded");
    };
    return ApplicationMenu;
}());
