var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var AbstractCollapsibleDialog = /** @class */ (function (_super) {
    __extends(AbstractCollapsibleDialog, _super);
    function AbstractCollapsibleDialog() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AbstractCollapsibleDialog.prototype.createPopupBody = function () {
        var popup = this.createPopupElement();
        popup.id = "popup";
        var scrollDiv = document.createElement("div");
        scrollDiv.className = "scroll";
        popup.appendChild(scrollDiv);
        return popup;
    };
    AbstractCollapsibleDialog.prototype.createCollapsibleset = function () {
        var collapSet = document.createElement("div");
        collapSet.setAttribute("data-role", "collapsible-set");
        collapSet.setAttribute('data-theme', 'tsf');
        collapSet.setAttribute('data-content-theme', 'tsf');
        collapSet.style.margin = "0px";
        return collapSet;
    };
    AbstractCollapsibleDialog.prototype.applyStyleAndHandleEvents = function () {
        var popup = this.popupElement;
        _super.prototype.applyStyleAndHandleEvents.call(this);
        jQuery(popup).on("collapsiblecollapse collapsibleexpand", "div:jqmData(role='collapsible')", function (evt) {
            jQuery(popup).popup("reposition", {
                positionTo: "window"
            });
        });
    };
    AbstractCollapsibleDialog.prototype.createItem = function (text, icon, href) {
        var item = document.createElement('li'), anchor = document.createElement("a");
        anchor.href = href;
        anchor.innerText = text;
        item.appendChild(anchor);
        if (icon) {
            item.className = "ui-li-has-icon";
            var img = document.createElement("img");
            img.src = Utils.createIconFromBase64(icon);
            img.className = "ui-li-icon";
            anchor.appendChild(img);
        }
        return item;
    };
    AbstractCollapsibleDialog.prototype.createCollapsibleItem = function (title, collapsed, type) {
        var element = document.createElement("div");
        element.setAttribute("data-role", "collapsible");
        element.setAttribute("data-collapsed", "" + collapsed);
        if (type !== undefined) {
            element.className = type;
        }
        var name = document.createElement("h4");
        name.innerText = title;
        var listview = document.createElement("ul");
        listview.setAttribute("data-role", "listview");
        element.appendChild(name);
        element.appendChild(listview);
        return element;
    };
    return AbstractCollapsibleDialog;
}(Popup));
