var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var DetailsPopup = /** @class */ (function (_super) {
    __extends(DetailsPopup, _super);
    function DetailsPopup(controller) {
        var _this = _super.call(this, "detailsPopup") || this;
        _this.controller = controller;
        _this.visibleBadges = [];
        return _this;
    }
    DetailsPopup.prototype.initialize = function () {
        var _this = this;
        var controller = this.controller;
        var language = controller.application.language;
        var objView = controller.objView;
        var orderedChildObjs = objView.getOrderedChildObjs();
        this.onDestroy.push(function () {
            for (var _i = 0, _a = _this.visibleBadges; _i < _a.length; _i++) {
                var info = _a[_i];
                info.badge.unsubscribe(info.token);
            }
            _this.visibleBadges = [];
        });
        var tasksVisible = objView.taskLinkViews.length > 0, detailsVisible = orderedChildObjs.length > 0, anyVisible = detailsVisible || tasksVisible;
        if (anyVisible) {
            var url = jQuery.mobile.path.parseUrl(jQuery.mobile.activePage.data('url'));
            var popup_1 = this.createPopupBody();
            var collapSet = this.createCollapsibleset();
            popup_1.firstChild.appendChild(collapSet);
            if (detailsVisible) {
                var collap = this.createCollapsibleItem(language.transl(Model.TranslKeys.detailsTabPage), false, "details");
                var detailsListview = jQuery(collap).find(":jqmData(role='listview')");
                // Remove mode param, so it will switch to the grid instead of the form.
                var urlParam = url.search.replace(/&mode=./g, "");
                var fragment = document.createDocumentFragment();
                for (var i = 0; i < orderedChildObjs.length; i++) {
                    var objViewLink = orderedChildObjs[i], href = "abstractscreen.html" + urlParam + "&link=" + objViewLink.objLink.refId;
                    var refTransl = objViewLink.refAddTransl ? objViewLink.refTransl.translPlural + " (" + objViewLink.refAddTransl + ")" : objViewLink.refTransl.translPlural;
                    var item = this.createItem(refTransl, objViewLink.objView.icon, href);
                    item.setAttribute("data-itemid", objViewLink.objLink.refId);
                    if (objViewLink.objView.showBadge) {
                        var badgeInfo = controller.badgeInfo[objViewLink.objLink.refId];
                        this.createBadge(badgeInfo, item);
                    }
                    fragment.appendChild(item);
                }
                detailsListview.append(fragment);
                collapSet.appendChild(collap);
            }
            if (tasksVisible) {
                var collap = this.createCollapsibleItem(language.transl(Model.TranslKeys.taskSubmenu), detailsVisible, "tasks");
                var tasksListView = jQuery(collap).find(":jqmData(role='listview')");
                var fragment = document.createDocumentFragment();
                for (var i = 0; i < objView.taskLinkViews.length; i++) {
                    var taskViewLink = objView.taskLinkViews[i];
                    var listItem = this.createItem(taskViewLink.taskView.taskTransl.transl, taskViewLink.taskView.icon, "#");
                    listItem.setAttribute("data-itemid", taskViewLink.taskView.task.taskId);
                    jQuery(listItem).find("a").click((function (taskViewLink) {
                        return function (evt) {
                            // Wait for the popup to close or it wont show the task popup.
                            jQuery(popup_1)
                                .one("popupafterclose", function () {
                                taskHelper.showPageOrPopup(taskViewLink.taskView, _this.controller);
                            }).popup('close');
                        };
                    })(taskViewLink));
                    if (taskViewLink.taskView.paramObjView.showBadge) {
                        var badgeInfo = controller.badgeInfo[taskViewLink.taskView.task.taskId];
                        this.createBadge(badgeInfo, listItem);
                    }
                    fragment.appendChild(listItem);
                }
                tasksListView.append(fragment);
                collapSet.appendChild(collap);
            }
            this.controller.events.contextChanged(function (args) {
                _this.updateContextState(jQuery(popup_1), args.contextState);
            });
            jQuery.mobile.activePage[0].appendChild(popup_1);
            this.updateContextState(jQuery(popup_1), this.controller.contextState);
            this.applyStyleAndHandleEvents();
            if (collapSet.children.length == 1) {
                jQuery(collapSet).find(".ui-collapsible").collapsible("disable").collapsible("option", "iconpos", "none");
            }
            var header = jQuery(collapSet).find(".ui-collapsible-heading-toggle");
            var color = Utils.Color.hexToColor(header.first().css("color"));
            Utils.SetIconBlackOrWhite(header, color);
            if (Utils.isElectron() && "ontouchstart" in window) {
                jQuery(collapSet).on("click", "ul.ui-listview a", function (e) {
                    // prevent duplicate clicks - which always happens on electron when the tablet has touch.
                    // When you click with the mouse a click is dispatched by the mouse and by iScroll due to `handleClick: true` in popup.ts
                    // somehow the mouse click isn't dispatched on listview (only the one by iScroll) so this is more of a workaround
                    var ele = e.target;
                    ele.addEventListener("click", function (e) {
                        e.preventDefault();
                        return false;
                    });
                });
            }
        }
        else {
            var confirmPopup = ConfirmationPopup.CreateOkPopup();
            confirmPopup.initialize(this.controller.objView.objTransl.transl, language.transl(Model.TranslKeys.noContextItems));
        }
    };
    DetailsPopup.prototype.createBadge = function (badgeInfo, item) {
        var _this = this;
        var controller = this.controller;
        var token = badgeInfo.subscribe(function (value, error) {
            _this.updateBadge(value, item.firstElementChild);
        });
        this.visibleBadges.push({ token: token, badge: badgeInfo });
        this.updateBadge(badgeInfo.currentValue, item.firstElementChild);
    };
    DetailsPopup.prototype.updateBadge = function (value, button) {
        if (value != null) {
            var createBadgeSpan = function (root) {
                var span = document.createElement("span");
                span.className = "ui-li-count";
                root.appendChild(span);
                return span;
            };
            var span = jQuery(button).children(".ui-li-count")[0] || createBadgeSpan(button);
            span.textContent = value + "";
        }
        else {
            jQuery(button).children(".ui-li-count").remove();
        }
    };
    DetailsPopup.prototype.updateContextState = function (popup, contextState) {
        this.updateList(".details", popup, contextState.detailContextState);
        this.updateList(".tasks", popup, contextState.taskContextState);
    };
    DetailsPopup.prototype.updateList = function (listClass, popup, stateList) {
        var list = popup.find(listClass + " ul");
        var listCollapsible = popup.find(listClass + " .ui-collapsible-heading");
        var controllerInEditMode = this.controller.isInEditMode && !this.controller.currentEditor.allowActions();
        var shownItems = 0;
        for (var itemId in stateList) {
            var item = list.find("li:jqmData(itemid='" + itemId + "')");
            if (item.length > 0) {
                var accessType = stateList[itemId];
                if (accessType === Enum.AccessType.Hidden) {
                    item.addClass("ui-screen-hidden");
                }
                else if (accessType === Enum.AccessType.ReadOnly || controllerInEditMode) {
                    item.removeClass("ui-screen-hidden").addClass("ui-state-disabled");
                    shownItems++;
                }
                else {
                    item.removeClass("ui-screen-hidden").removeClass("ui-state-disabled");
                    shownItems++;
                }
            }
        }
        listCollapsible.toggleClass("ui-screen-hidden", shownItems === 0);
    };
    return DetailsPopup;
}(AbstractCollapsibleDialog));
