var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var SelectMenuOption = /** @class */ (function () {
    function SelectMenuOption(value, text, accesstype, onClickAction) {
        this.value = value;
        this.text = text;
        this.accesstype = accesstype;
        this.onClickAction = onClickAction;
    }
    return SelectMenuOption;
}());
var SelectMenuPopup = /** @class */ (function (_super) {
    __extends(SelectMenuPopup, _super);
    function SelectMenuPopup(controller) {
        var _this = _super.call(this, "selectMenuPopup") || this;
        _this.controller = controller;
        return _this;
    }
    SelectMenuPopup.prototype.initialize = function (options) {
        var controller = this.controller;
        var popup = this.createPopupElement();
        var optionsList = this.createOptionsList(options);
        jQuery(popup).append(optionsList);
        jQuery.mobile.activePage[0].appendChild(popup);
        this.applyStyleAndHandleEvents();
    };
    SelectMenuPopup.prototype.createOptionsList = function (options) {
        var selectMenuView = document.createElement("ul");
        selectMenuView.setAttribute("data-role", "listview");
        selectMenuView.setAttribute("data-icon", "false");
        var controller = this.controller;
        var language = controller.application.language;
        for (var i = 0; i < options.length; i++) {
            var option = options[i];
            if (option.accesstype != Enum.AccessType.Hidden) {
                var optionElement = document.createElement("option");
                optionElement.value = option.value + "";
                optionElement.innerText = option.text;
                var isReadOnly = option.accesstype == Enum.AccessType.ReadOnly;
                selectMenuView.appendChild(this.createItem(option, isReadOnly));
            }
        }
        return selectMenuView;
    };
    SelectMenuPopup.prototype.createItem = function (selectMenuOption, isReadOnly) {
        var that = this;
        var item = document.createElement("li");
        var $item = jQuery(item);
        var $link = jQuery("<a href='#'></a>").text(selectMenuOption.text);
        $item.append($link);
        if (!isReadOnly) {
            $item.click(function () {
                selectMenuOption.onClickAction();
                that.destroyPopup();
            });
        }
        else {
            $item.addClass("ui-li-disabled");
        }
        return item;
    };
    SelectMenuPopup.prototype.applyStyleAndHandleEvents = function () {
        var that = this;
        var popup = this.popupElement;
        var page = jQuery(popup).closest(".ui-page");
        var $popup = jQuery(popup);
        $popup.popup({ history: false }).enhanceWithin().popup("open");
        jQuery(window).bind("throttledresize.screen", function (evt) {
            // We hide the popup temporarily and after a timeout we show the popup
            // with the correct position. This is needed because when we just call
            // the reposition() this is sometimes overrided by other events.
            $popup.hide();
            setTimeout(function () {
                that.reposition();
                $popup.show();
            }, 250);
        });
        this.reposition();
    };
    SelectMenuPopup.prototype.reposition = function () {
        var headerHeight = jQuery(".ui-header.ui-header-fixed").height();
        var popupContainerTopPosition = (headerHeight - 10) + "px";
        var $popupContainer = jQuery(".selectMenuPopup").closest(".ui-popup-container");
        $popupContainer.css({ "top": popupContainerTopPosition, "left": "", "right": "10px" });
    };
    return SelectMenuPopup;
}(Popup));
