var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var CubeViewPopup = /** @class */ (function (_super) {
    __extends(CubeViewPopup, _super);
    function CubeViewPopup(controller) {
        var _this = _super.call(this, "cubeViewPopup") || this;
        _this.controller = controller;
        _this.cubeViewDeferred = jQuery.Deferred();
        return _this;
    }
    CubeViewPopup.prototype.initialize = function () {
        var _this = this;
        var popup = this.createPopupBody();
        var collapSet = this.createCollapsibleset();
        popup.firstChild.appendChild(collapSet);
        var title = this.controller.application.language.transl(Model.TranslKeys.cubeViews);
        var collap = this.createCollapsibleItem(title, false);
        var detailsListview = jQuery(collap).find(":jqmData(role='listview')");
        var fragment = document.createDocumentFragment();
        var previousGroup;
        for (var _i = 0, _a = this.controller.objView.objViewCube.cubeViews.array; _i < _a.length; _i++) {
            var cubeView = _a[_i];
            if (cubeView.group) {
                if (cubeView.group !== previousGroup) {
                    previousGroup = cubeView.group;
                    // Create group divider
                    fragment.appendChild(this.createDivider(cubeView.group.grpTransl.transl));
                }
            }
            else if (previousGroup) {
                // create new remaining group
                previousGroup = null;
                fragment.appendChild(this.createDivider("Misc"));
            }
            var item = this.createItem(cubeView.cubeViewTransl.transl, null, "#");
            item.firstChild.setAttribute("data-itemid", cubeView.cubeViewId);
            fragment.appendChild(item);
        }
        detailsListview.append(fragment);
        collapSet.appendChild(collap);
        jQuery.mobile.activePage[0].appendChild(popup);
        this.applyStyleAndHandleEvents();
        jQuery(popup).on('popupafterclose', function () {
            _this.cubeViewDeferred.resolve(_this.result);
        });
        var that = this;
        jQuery(popup).on("click", "a", function () {
            var button = jQuery(this);
            that.result = button.attr("data-itemid");
            jQuery(popup).popup('close');
        });
        return this.cubeViewDeferred.promise();
    };
    CubeViewPopup.prototype.createDivider = function (text) {
        var divider = document.createElement("li");
        divider.setAttribute("data-role", "list-divider");
        divider.innerText = text;
        return divider;
    };
    return CubeViewPopup;
}(AbstractCollapsibleDialog));
