///<reference path="grid.ts" />
///<reference path="../ConditionalLayoutConsumer.ts" />
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// http://view.jquerymobile.com/1.3.1/dist/demos/widgets/table-reflow/
var FlowTable = /** @class */ (function (_super) {
    __extends(FlowTable, _super);
    function FlowTable(application, controller, url) {
        var _this = _super.call(this, controller, url) || this;
        _this.showGoToFormButton = false;
        _this.currentlyAppendingData = false;
        // Note: .slice creates a copy because sort changes the original array.
        // Note: for now we use .call, because we also index props on id, so some function might get overwritten.
        var props = controller.objView.objViewProps.array;
        props = Array.prototype.slice.call(props, 0, props.length);
        props = Array.prototype.filter.call(props, function (value, index, array) {
            // Exclude hidden columns
            return value.gridMaxAccessType != Enum.AccessType.Hidden;
        });
        _this.sortedProps = Array.prototype.sort.call(props, function (a, b) { return a.gridOrderNo - b.gridOrderNo; });
        _this.conditionalLayoutConsumer = new ConditionalLayoutConsumer();
        return _this;
    }
    FlowTable.prototype.initialize = function (contentElement, hasForm) {
        var _this = this;
        var that = this;
        this.showGoToFormButton = hasForm;
        jQuery(contentElement).addClass('table');
        this.createColumns();
        var objProps = this.controller.objView.objViewProps.array;
        var hasCombinedFilter = this.controller.controllerContext.getScreenType().hasCombinedFilter;
        // When there aren't columns with includeInGlobalFilter; don't show it
        hasCombinedFilter = hasCombinedFilter && Array.prototype.some.call(objProps, function (value) { return value.includeInGlobalFilter; });
        var scrollElement = document.createElement("div");
        var headerWrapper = document.createElement("div");
        headerWrapper.className = "list-header-wrapper";
        contentElement.appendChild(headerWrapper);
        if (hasCombinedFilter) {
            var searchForm = this.createSearchForm();
            headerWrapper.appendChild(searchForm);
            jQuery(searchForm).find("input").textinput();
            scrollElement.className += "has-combined-filter";
        }
        scrollElement.className += " table-scroll-wrapper";
        var table = this.tableElement = document.createElement("table");
        table.setAttribute("data-role", "table");
        table.setAttribute("data-mode", "none");
        table.setAttribute("data-filter", "true");
        // JQM 1.4: Table-stroke is deprecated but there isn't an alternative yet, except for custom css.
        table.className = "ui-responsive table-stroke";
        // Create a table header with table header cells
        var tableHead = this.tableHead = table.createTHead();
        var tableRow = document.createElement("tr");
        for (var i = 0; i < this.columns.length; i++) {
            var th = document.createElement("th");
            var column = this.columns[i];
            var colViewProp = column.viewProp;
            column.alignment = (colViewProp.isTranslatedLookup() ? colViewProp.lookup.listProp.objProp.alignment : colViewProp.objProp.alignment);
            if (column.alignment === 1 /* Right */) {
                th.className = "right";
            }
            th.textContent = column.objProp.objPropTransl.translGrid;
            if (column.viewProp.gridColumnWidth !== null) {
                th.style.width = column.viewProp.gridColumnWidth + "px";
            }
            tableRow.appendChild(th);
        }
        if (this.showGoToFormButton) {
            var th = document.createElement("th");
            tableRow.appendChild(th);
        }
        tableHead.appendChild(tableRow);
        table.appendChild(tableHead);
        // Create the table body
        this.tableBody = document.createElement("tbody");
        table.appendChild(this.tableBody);
        scrollElement.appendChild(table);
        contentElement.appendChild(scrollElement);
        var controller = this.controller;
        if (TSFScroll.useNativeScroll()) {
            var tableElement_1 = this.tableElement;
            var offsetY = 0;
            var buttonsHidden = false;
            this.scrollBar = new TSFNativeScroll(this.tableElement, {
                threshold: 250,
                onScrollMove: function () {
                    if ((tableElement_1.scrollHeight - tableElement_1.clientHeight) === tableElement_1.scrollTop &&
                        controller.interfaceAvailable && !that.currentlyAppendingData) {
                        controller.currentAction = controller.nextPage();
                    }
                }
            });
        }
        else {
            this.scrollBar = new iScroll(contentElement, {
                onScrollMove: function (event) {
                    var scrollElement = jQuery(this.wrapper);
                    if (this.y < (this.maxScrollY - 5) && !scrollElement.hasClass('nextPage')) {
                        scrollElement.addClass('nextPage');
                        this.maxScrollY = this.maxScrollY;
                    }
                    else if (this.y > (this.maxScrollY + 5) && scrollElement.hasClass('nextPage')) {
                        scrollElement.removeClass('nextPage');
                    }
                },
                onRefresh: function () {
                    // Correct scroller width to be the size of the table
                    // Or else we wouldn't get a horizontal scrollbar
                    this.scrollerW = jQuery(table).outerWidth();
                    this.maxScrollX = this.wrapperW - this.scrollerW;
                },
                onScrollEnd: function (event) {
                    var scrollElement = jQuery(this.wrapper);
                    if (scrollElement.hasClass('nextPage')) {
                        if (controller.interfaceAvailable) {
                            controller.currentAction = controller.nextPage();
                        }
                        scrollElement.removeClass('nextPage');
                    }
                }
            });
            jQuery(contentElement).css('overflow', 'hidden').on("tsf-updatelayout", function () {
                _this.scrollBar.refresh();
            });
        }
        jQuery(window).on("throttledresize.flowtable", function () {
            _this.updateFormButtonHeight();
        });
        jQuery(table).table();
        if (hasCombinedFilter) {
            var $searchInput = this.getSearchInput();
        }
        if (controller.initialized) {
            this.controller.getData().done(function (reader, status) {
                that.currentlyAppendingData = true;
                // We need to clear the tablebody, when first opening a screen in online mode and after that opening the same screen in
                // offline mode, the controller is initialized but a datasetChanged event will also fire. Causing the data to show twice.
                jQuery(_this.tableBody).empty();
                _this.appendTableData(reader, _this.tableBody);
            }).fail(function (status) {
                jQuery(_this.tableBody).empty();
            });
        }
        controller.events.datasetChanged(function (args) {
            that.currentlyAppendingData = true;
            if (args.pageIndex !== -1) {
                var moreDataItem = _this.tableBody.lastChild;
                if (jQuery(moreDataItem).hasClass("moreDataAvailable")) {
                    _this.tableBody.removeChild(moreDataItem);
                }
                _this.appendTableData(args.dataset, _this.tableBody, args.pageIndex * _this.controller.pageSize);
            }
            else {
                jQuery(_this.tableBody).empty();
                _this.appendTableData(args.dataset, _this.tableBody);
            }
        });
        controller.events.rowIndexChanged(function () {
            _this.setRowActive(_this.tableBody, _this.controller.getRowIndex());
        });
        this.preventClickOnMouseMove(this.tableBody, "tr");
        jQuery(this.tableBody).on("dblclick doubletap", "tr", function (event) {
            if (that.controller.interfaceAvailable) {
                jQuery(this).find('.goToFormButton').click();
            }
        });
        jQuery(this.tableBody).on("click", "tr", function (event) {
            // Do not change the index when the click is prevented (by preventClickOnMouseMove)
            if (event.isDefaultPrevented())
                return;
            var $this = jQuery(this);
            that.flushCombinedFilter();
            if ($this.hasClass("filter-message")) {
                return;
            }
            else if ($this.hasClass("moreDataAvailable")) {
                if (controller.interfaceAvailable) {
                    that.controller.currentAction = that.controller.nextPage();
                }
                return;
            }
            else if (jQuery(event.target).is(".goToFormButton") && !that.controller.interfaceAvailable) {
                return;
            }
            // Make sure people can't click rows multiple times. When this happens the NavigationManager.Current.navigate is
            // called multiple times, causing it to not work anymore. Navigation is completely broken when that happens
            // (jqm 1.4.0 bug?).
            // Also calling the setRowIndex multiple times might confuse the controller or form due to race conditions so we want to guard against it
            var promise = that.controller.currentAction = that.controller.setRowIndex($this.index());
            if (hasForm && jQuery(event.target).is(".goToFormButton")) {
                jQuery(that.tableBody).off("click", "tr").on("click", "tr", function (e) {
                    e.preventDefault();
                });
                promise.always(function () {
                    NavigationManager.navigate(that.getEditLink(0 /* View */));
                });
            }
        });
    };
    FlowTable.prototype.getAdditionalFilterColumns = function () {
        return null;
    };
    FlowTable.prototype.getSearchInput = function () {
        return jQuery(this.tableElement).closest(".table").find("> div > form input");
    };
    FlowTable.prototype.createColumns = function () {
        var obj = this.controller.obj;
        var listFieldProp = (obj.lookupDisplay.lookUpDisplayColId ?
            this.controller.objView.objViewProps.object[obj.lookupDisplay.lookUpDisplayColId] :
            null);
        if (listFieldProp && listFieldProp.gridMaxAccessType !== Enum.AccessType.Hidden) {
            this.columns.push(this.createColumn(listFieldProp, false));
        }
        for (var i = 0; i < this.sortedProps.length; i++) {
            // Skip column, is already part of columns list
            if (this.sortedProps[i].objPropId == obj.lookupDisplay.lookUpDisplayColId)
                continue;
            this.columns.push(this.createColumn(this.sortedProps[i], false));
        }
    };
    FlowTable.prototype.invalidateData = function () {
        var $tableBody = jQuery(this.tableBody);
        $tableBody.empty();
    };
    FlowTable.prototype.appendTableData = function (reader, tableBody, clientStartIndex) {
        var _this = this;
        if (clientStartIndex === void 0) { clientStartIndex = 0; }
        var buildObject = this.rebuildObject = new Object();
        var lookupList = [];
        for (var i = 0; i < this.columns.length; i++) {
            if (this.columns[i].lookupContainer) {
                lookupList.push(this.columns[i].lookupContainer.prepare(reader));
            }
        }
        Utils.whenAll(lookupList).then(function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var table = jQuery(tableBody).closest("table");
            if (!table.data("mobile-table")) {
                // When a user presses refresh and quickly presses back, datasetchanged event might have been fired so lookups are getting loaded.
                // But the table is already destroyed
                return;
            }
            // Only execute the last rebuild.
            if (buildObject != _this.rebuildObject)
                return;
            var fragment = document.createDocumentFragment();
            for (var i = 0, length_1 = reader.length; i < length_1; i++) {
                var row = document.createElement("tr");
                var itemReader = reader.item(i);
                for (var j = 0; j < _this.columns.length; j++) {
                    var column = _this.columns[j];
                    var cell = document.createElement("td");
                    if (column.alignment === 1 /* Right */) {
                        cell.className = "right";
                    }
                    cell.appendChild(column.getElement(itemReader, clientStartIndex + i));
                    row.appendChild(cell);
                }
                if (_this.showGoToFormButton) {
                    var cell = document.createElement("td");
                    cell.className = "formbuttonCell";
                    var formContainer = document.createElement("div");
                    formContainer.className = "formButtonContainer";
                    var formButton = document.createElement("div");
                    formButton.className = "goToFormButton";
                    formButton.innerHTML = "&nbsp;";
                    cell.appendChild(formContainer);
                    formContainer.appendChild(formButton);
                    row.appendChild(cell);
                }
                fragment.appendChild(row);
            }
            if (_this.controller.hasNextPage()) {
                var moreDataRowElement = document.createElement("tr");
                moreDataRowElement.className = "moreDataAvailable";
                var moreDataTd = document.createElement("td");
                moreDataTd.colSpan = _this.columns.length;
                var moreDataText = document.createElement("p");
                var language = _this.controller.application.language;
                moreDataText.textContent = language.transl(Model.TranslKeys.moreItemsAvailable);
                moreDataTd.appendChild(moreDataText);
                moreDataRowElement.appendChild(moreDataTd);
                fragment.appendChild(moreDataRowElement);
            }
            else if (_this.controller.isStartEmptyWithFilterActive) {
                var filterMessageRow = document.createElement("tr");
                filterMessageRow.className = "filter-message";
                var filterMessageTd = document.createElement("td");
                filterMessageTd.colSpan = _this.columns.length;
                var language = _this.controller.application.language;
                var filterText = document.createElement("p");
                filterText.textContent = language.transl(Model.TranslKeys.enterSearchTerm);
                filterMessageTd.appendChild(filterText);
                filterMessageRow.appendChild(filterMessageTd);
                fragment.appendChild(filterMessageRow);
            }
            tableBody.appendChild(fragment);
            _this.loadImages(tableBody, reader, clientStartIndex);
            table.table("refresh");
            if (table.data("mobile-filterable")) {
                _this.getSearchInput().parent().removeClass("inprogress");
            }
            _this.applyConditionalLayouts(tableBody, reader, clientStartIndex);
            var rowIndex = _this.controller.getRowIndex();
            _this.setRowActive(tableBody, rowIndex);
            // Wait with scrolling until the page is shown.
            _this.pageShown.then(function () {
                _this.scrollBar.refresh();
                _this.updateFormButtonHeight();
                // Scroll to the active row.
                if (rowIndex >= 0 && rowIndex < tableBody.childNodes.length) {
                    var activeRowYPos = jQuery(tableBody.childNodes[rowIndex]).offset().top;
                    var scrollHeight = jQuery(".table").height();
                    if (activeRowYPos > scrollHeight) {
                        // Substract the ScrollHeight from the ActiveRowYPos to determine the "scroll distance".
                        // Negate it because iScroll wants it negative.
                        _this.scrollBar.scrollTo(0, -(activeRowYPos - scrollHeight), null, null);
                    }
                }
                _this.currentlyAppendingData = false;
                //Needed to trigger a repaint because else the position sticky header
                //stops working when scrolling into the appended items.
                jQuery(_this.tableHead).toggle().toggle();
            }).fail(function () {
                //Prevent being unable to fetch new page when error occurs
                _this.currentlyAppendingData = false;
            });
        }).fail(function () {
            //Prevent being unable to fetch new page when error occurs
            _this.currentlyAppendingData = false;
        });
    };
    FlowTable.prototype.updateFormButtonHeight = function () {
        if (this.showGoToFormButton) {
            for (var row = this.tableBody.firstElementChild; row != null; row = row.nextElementSibling) {
                if (row.className != "moreDataAvailable" && row.className != "filter-message") {
                    row.lastElementChild.firstElementChild.style.lineHeight = (row.clientHeight - 1) + "px";
                }
            }
        }
    };
    FlowTable.prototype.hideFormButtons = function (hide) {
        if (this.showGoToFormButton) {
            var display = hide ? "none" : "";
            for (var row = this.tableBody.firstElementChild; row != null; row = row.nextElementSibling) {
                if (row.className != "moreDataAvailable" && row.className != "filter-message") {
                    row.lastElementChild.firstElementChild.style.display = display;
                }
            }
        }
    };
    FlowTable.prototype.allowDifferentWidthImages = function () {
        return true;
    };
    FlowTable.prototype.allowStartEmptyWithFilter = function () {
        return this.getSearchInput().length > 0;
    };
    FlowTable.prototype.loadImages = function (tableBody, reader, clientStartIndex) {
        var _this = this;
        var that = this;
        // First make a list of image columns so we don't have to check every column below
        var imageColumns = [];
        for (var i = 0; i < that.columns.length; i++) {
            var col = that.columns[i];
            if (col instanceof GridImageColumn) {
                imageColumns.push(col);
            }
        }
        if (imageColumns.length == 0) {
            return;
        }
        // The reader only contains the new records when used with paging, that's why we start at clientStartIndex.
        // Also we need to load images only for the new rows
        this.cancelImageScheduler();
        var scheduler = this.imageScheduler = new Scheduler(4, function () {
            // refresh scrollbar when all images are loaded, it might change the height of the table
            _this.scrollBar.refresh();
            _this.updateFormButtonHeight();
        });
        var images = jQuery(tableBody).find("img");
        for (var i = (clientStartIndex * imageColumns.length); i < images.length; i++) {
            var element = images[i];
            var rowIndex = parseInt(jQuery(element).data('row-index'), 10);
            for (var colIndex = 0; colIndex < imageColumns.length; colIndex++) {
                var imageCol = imageColumns[colIndex];
                if (imageCol.objProp.objPropId !== element.getAttribute("data-prop")) {
                    continue;
                }
                scheduler.schedule((function (element, rowIndex, imageCol) {
                    return function () {
                        // Substract because this reader only knows the new rows
                        return that.controller.getImage(reader.item(rowIndex - clientStartIndex), imageCol.objProp, imageCol.imageWidth, imageCol.imageHeight, true).then(function (base64Icon) {
                            element.src = base64Icon ? Utils.createIconFromBase64(base64Icon) : "img/photo.png";
                        });
                    };
                })(element, rowIndex, imageCol));
            }
        }
    };
    FlowTable.prototype.applyConditionalLayouts = function (tableBody, reader, clientStartIndex) {
        var that = this;
        // No conditional layouts, so don't do anything.
        var keys = Object.keys(that.controller.objView.conditionalLayouts);
        if (keys.length == 0 || reader.length == 0) {
            return;
        }
        // reader only contains the rows for the new page. We only want to calculate conditional layouts for the new rows
        // therefore, we add the clientStartIndex to the rowIndex
        var objView = that.controller.objView;
        var rows = jQuery(tableBody).find("tr");
        for (var rowIndex = 0; rowIndex < rows.length; rowIndex++) {
            var element = rows[rowIndex + clientStartIndex];
            var row = reader.item(rowIndex);
            if (!row)
                return; // Extra check, to make sure there is a row.
            for (var i = 0; i < keys.length; i++) {
                var conditionalLayout = objView.conditionalLayouts[keys[i]];
                if (that.conditionalLayoutConsumer.evaluateConditions(conditionalLayout, row)) {
                    // Apply style to the cell
                    if (conditionalLayout.objProp) {
                        for (var g = 0; g < that.columns.length; g++) {
                            if (conditionalLayout.objProp.objPropId == that.columns[g].objProp.objPropId) {
                                jQuery(element.children[g]).addClass(conditionalLayout.conditionalLayoutID);
                                break;
                            }
                        }
                    }
                    else {
                        // Apply style to the whole row
                        jQuery(element).addClass(conditionalLayout.conditionalLayoutID);
                    }
                }
            }
        }
    };
    FlowTable.prototype.cancelImageScheduler = function () {
        if (this.imageScheduler) {
            this.imageScheduler.cancel();
        }
    };
    FlowTable.prototype.dispose = function () {
        this.cancelImageScheduler();
        if (this.scrollBar) {
            this.scrollBar.destroy();
        }
        _super.prototype.dispose.call(this);
        jQuery(window).off("throttledresize.flowtable");
    };
    return FlowTable;
}(Grid));
