var LogType;
(function (LogType) {
    LogType[LogType["SYNC"] = 0] = "SYNC";
    LogType[LogType["LOG"] = 1] = "LOG";
    LogType[LogType["ERROR"] = 2] = "ERROR";
})(LogType || (LogType = {}));
var ConsoleLogger = /** @class */ (function () {
    function ConsoleLogger() {
    }
    ConsoleLogger.prototype.log = function (message, type) {
        if (type === void 0) { type = LogType.LOG; }
        var args = [moment().toISOString(), LogType[type], message];
        if (typeof Raven !== "undefined") {
            if (type === LogType.ERROR) {
                Utils.tryRavenCaptureException(message);
            }
            else if (type === LogType.LOG) {
                if (message.indexOf("inactive applications") === -1) {
                    Raven.captureMessage(message, {
                        level: "info"
                    });
                }
            }
        }
        console.log(args.join(" "));
    };
    return ConsoleLogger;
}());
var Logger = new ConsoleLogger();
