var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var SFModelReader = /** @class */ (function (_super) {
    __extends(SFModelReader, _super);
    function SFModelReader(manager, tsfCache) {
        var _this = _super.call(this, manager, tsfCache) || this;
        _super.prototype.initialize.call(_this);
        _this.useApplCaching = false;
        return _this;
    }
    SFModelReader.prototype.Load = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var configuredProject, configuredProjectVrs, a, projectParams;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, AppConfig.getProject()];
                    case 1:
                        configuredProject = _a.sent();
                        return [4 /*yield*/, AppConfig.getProjectVrs()];
                    case 2:
                        configuredProjectVrs = _a.sent();
                        a = new Model.TSFApplication(configuredProject);
                        a.projectName = configuredProject;
                        a.projectVersion = configuredProjectVrs;
                        a.language = AppConfig.language;
                        a.loadOnStartup = true;
                        a.guid = null;
                        projectParams = this.manager.metaClient.createParameterCollection();
                        projectParams.add("project_id", a.projectName);
                        projectParams.add("project_vrs_id", a.projectVersion);
                        projectParams.add("platform", 2); // 2 stands for the mobile platform.
                        return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                                var _this = this;
                                return __generator(this, function (_a) {
                                    this.readGetGui("get_gui_project_vrs", projectParams, function (reader) {
                                        if (reader.length > 0) {
                                            var item = reader.item(0);
                                            var defaultFormProps = new Model.FormProps();
                                            defaultFormProps.defaultFieldWidth = item.getNumber("field_width");
                                            defaultFormProps.defaultLabelWidth = item.getNumber("label_width");
                                            // Give all the titles a default value, the title will otherwise contain "null" strings.
                                            var title1 = item.getString("title_1", "");
                                            var title2 = item.getString("title_2", "");
                                            var title3 = item.getString("title_3", "");
                                            a.applicationTransls[a.language.code] = title1 + " " + title2 + " " + title3;
                                            a.defaultFormProps = defaultFormProps;
                                            _this.manager.globalSettings.setCurrentSFVersion(item.getString("sf_project_vrs_id"));
                                            _this.manager.appls.push(a);
                                            _this.manager.activeAppl = a;
                                        }
                                    }).then(function () { return __awaiter(_this, void 0, void 0, function () {
                                        var _this = this;
                                        var params, _a;
                                        return __generator(this, function (_b) {
                                            switch (_b.label) {
                                                case 0:
                                                    params = this.manager.metaClient.createParameterCollection();
                                                    params.add(BaseModelReader.projectIdParam, a.projectName);
                                                    params.add(BaseModelReader.projectVrsIdParam, a.projectVersion);
                                                    _a = this;
                                                    return [4 /*yield*/, AppConfig.getConfiguration()];
                                                case 1:
                                                    _a.configuration = _b.sent();
                                                    params.add(BaseModelReader.runtimeConfigurationIdParam, this.configuration);
                                                    this.loadConnection(a, params).then(function () {
                                                        if (_this.manager.appls.length === 0) {
                                                            return reject(Model.TranslKeys.noApplications);
                                                        }
                                                        else {
                                                            a.bootstrapApplication();
                                                            _this.LoadApplication(a)
                                                                .then(resolve)
                                                                .fail(reject);
                                                        }
                                                    });
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); });
                                    return [2 /*return*/];
                                });
                            }); })];
                }
            });
        });
    };
    SFModelReader.prototype.getDefaultParameters = function (application) {
        var defaultParams = this.manager.metaClient.createParameterCollection();
        defaultParams.add("project_id", application.projectName);
        defaultParams.add("project_vrs_id", application.projectVersion);
        defaultParams.add("platform", 2); // 2 stands for the mobile platform.
        return defaultParams;
    };
    SFModelReader.prototype.getExtendedPropertiesParameters = function (application) {
        var params = this.manager.metaClient.createParameterCollection();
        params.add(BaseModelReader.projectIdParam, application.projectName);
        params.add(BaseModelReader.projectVrsIdParam, application.projectVersion);
        params.add(BaseModelReader.runtimeConfigurationIdParam, this.configuration);
        return params;
    };
    SFModelReader.prototype.loadConnection = function (application, params) {
        return __awaiter(this, void 0, void 0, function () {
            var proxyAddress, _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _b = (_a = Utils).generateSFUrl;
                        return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                    case 1:
                        _c = [_d.sent()];
                        return [4 /*yield*/, AppConfig.getProject()];
                    case 2:
                        _c = _c.concat([_d.sent()]);
                        return [4 /*yield*/, AppConfig.getProjectVrs()];
                    case 3:
                        _c = _c.concat([_d.sent()]);
                        return [4 /*yield*/, AppConfig.getConfiguration()];
                    case 4:
                        proxyAddress = _b.apply(_a, _c.concat([_d.sent()]));
                        application.oDataClient = OnlineClientFactory.createClient(this.createUrlString(proxyAddress), this.manager.user.username, this.manager.user.password);
                        return [2 /*return*/, Promise.resolve()];
                }
            });
        });
    };
    return SFModelReader;
}(BaseModelReader));
var IAMModelReader = /** @class */ (function (_super) {
    __extends(IAMModelReader, _super);
    function IAMModelReader(manager, tsfCache) {
        var _this = _super.call(this, manager, tsfCache) || this;
        _this.connections = {};
        _this.languages = [];
        _super.prototype.initialize.call(_this);
        _this.useApplCaching = true;
        return _this;
    }
    IAMModelReader.prototype.shouldCheckStaleSync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var openChanges, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _b = (_a = Utils).convertToBoolean;
                        return [4 /*yield*/, Utils.Preferences.getItem(ServerSync.OFFLINE_STORAGE_CONTAINS_CHANGES)];
                    case 1:
                        openChanges = _b.apply(_a, [_c.sent(), false]);
                        if (!openChanges) {
                            return [2 /*return*/, Promise.resolve(false)];
                        }
                        return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                                var latestSignedInUsername, language, openChangesMessage, popup;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, Utils.Preferences.getItem(BaseModelReader.latestSignedInUsernameKey)];
                                        case 1:
                                            latestSignedInUsername = _a.sent();
                                            if (!Utils.caseInsenstiveStringCompare(this.manager.user.username, latestSignedInUsername)) {
                                                language = AppConfig.language;
                                                openChangesMessage = language.transl(Model.TranslKeys.offlineChangesSwitchingUser).replace("[user]", latestSignedInUsername);
                                                popup = ConfirmationPopup.CreateYesNoPopup();
                                                Utils.hideLoader();
                                                popup.initialize(language.transl(Model.TranslKeys.login), openChangesMessage).then(function (result) {
                                                    if (result === Enum.ConfirmationOption.Yes) {
                                                        // Users want's to continue and the changes will be removed; therefore we don't do stale sync
                                                        Utils.showLoader(AppConfig.language.transl(Model.TranslKeys.loadingApplication));
                                                        resolve(false);
                                                    }
                                                    else {
                                                        // Users want's to keep the local data; so reject and don't do anything
                                                        reject(AppConfig.skip_stale_sync);
                                                    }
                                                });
                                            }
                                            else {
                                                resolve(true);
                                            }
                                            return [2 /*return*/];
                                    }
                                });
                            }); })];
                }
            });
        });
    };
    IAMModelReader.prototype.detectStaleSyncApplications = function () {
        var _this = this;
        if (!AppConfig.online) {
            return jQuery.Deferred().resolve().promise();
        }
        var oldApplCaching = this.useApplCaching;
        this.useApplCaching = false;
        var guiApplParams = this.manager.metaClient.createParameterCollection();
        guiApplParams.add(BaseModelReader.userIdParam, this.manager.user.username);
        guiApplParams.add(BaseModelReader.guiApplParam, null);
        // Platform id 2 represents mobile.
        guiApplParams.add(IAMModelReader.platformParam, 2);
        return this.readGetGui("get_gui_gui_appl", guiApplParams, function (reader) {
            var cachedModelApplIds = Object.keys(_this.cachedObjectModels);
            var applicationsFromGetGui = [];
            var applicationRequiresStaleSync = [];
            for (var i = 0; i < reader.length; i++) {
                var item = reader.item(i);
                var guiApplId = item.getString("gui_appl_id");
                var guid = item.getString("guid");
                // We can't use the globalSettings.currentSFVersion because that isn't read yet here
                // Application was still available but updated, mark as required for stale sync
                var cachedValue = _this.cachedObjectModels[guiApplId];
                if (guid !== null && cachedValue !== guid) {
                    applicationRequiresStaleSync.push(guiApplId);
                }
                // add item to a list of available applications, this way we can detect missing applications from
                // the new model
                applicationsFromGetGui.push("" + guiApplId);
            }
            // Detect missing applications so we can detect them for requiring stale sync
            for (var _i = 0, cachedModelApplIds_1 = cachedModelApplIds; _i < cachedModelApplIds_1.length; _i++) {
                var applId = cachedModelApplIds_1[_i];
                // Not in the new list, but make sure not to add them twice
                if (applicationsFromGetGui.indexOf(applId) === -1) {
                    applicationRequiresStaleSync.push(applId);
                }
            }
            _this.useApplCaching = oldApplCaching;
            return _this.removeApplicationsWithoutSyncItems(applicationRequiresStaleSync);
        });
    };
    IAMModelReader.prototype.removeApplicationsWithoutSyncItems = function (guiApplIdsToSync) {
        var deferred = jQuery.Deferred();
        var resolveList = [];
        //A copy of the array is required because we must use forEach.
        //We must use forEach is because we need the guiAppl in the callback.
        var requiringStaleSyncCopy = guiApplIdsToSync.slice(0);
        requiringStaleSyncCopy.forEach(function (guiApplRequiringStaleSync) {
            var deferred1 = jQuery.Deferred();
            //Dummy application is needed to get the serverSync queue.
            var dummyAppl = new Model.TSFApplication(guiApplRequiringStaleSync);
            //Dummy projectVersion is needed because else dispose will fail at removeOfflineCodeFiles.
            dummyAppl.projectVersion = "dummyVersion";
            dummyAppl.initializeDatabase().then(function () {
                dummyAppl.serverSync.getQueue(true).then(function (queueItems) {
                    if (queueItems.length === 0) {
                        var applicationIndex = guiApplIdsToSync.indexOf(guiApplRequiringStaleSync);
                        guiApplIdsToSync.splice(applicationIndex, 1);
                    }
                    deferred1.resolve();
                    dummyAppl.dispose();
                });
            });
            resolveList.push(deferred1.promise());
        });
        jQuery.when.apply(undefined, resolveList).then(function () {
            return deferred.resolve(guiApplIdsToSync);
        });
        return deferred.promise();
    };
    IAMModelReader.prototype.doStaleSync = function (staleSyncApplIds) {
        var _this = this;
        this.readGetGui = this.readGetGuiFromStorage;
        this.loadConnectionsAndApplications()
            .then(function () {
            // Load the applications which are required for stale sync
            var resolveList = [];
            for (var i = 0; i < _this.manager.appls.length; i++) {
                var appl = _this.manager.appls[i];
                if (staleSyncApplIds.indexOf(appl.guiApplId) >= 0) {
                    appl.bootstrapApplication();
                    resolveList.push(_this.LoadApplication(appl, false));
                }
            }
            return jQuery.when.apply(undefined, resolveList);
        }).then(function () {
            return _this.manager.appls.reduce(function (prev, next) {
                return prev.then(function () {
                    // Create a new deferred because we might want to cancel this when one syncQueueToServer is
                    // succesful but actually is canceled due to a network error
                    var deferred = jQuery.Deferred();
                    if (staleSyncApplIds.indexOf(next.guiApplId) === -1) {
                        return deferred.resolve().promise();
                    }
                    next.serverSync.isStaleSync = true;
                    next.serverSync.syncQueueToServer()
                        .then(function (error) {
                        if (error == 0 /* None */) {
                            _this.removeApplicationModelAndData(next.guiApplId).then(function () {
                                deferred.resolve();
                            });
                        }
                        else {
                            _this.manager.activeAppl = next;
                            deferred.reject(AppConfig.sync_error);
                        }
                    }).fail(function (err) {
                        _this.manager.activeAppl = next;
                        deferred.reject(err);
                    });
                    return deferred.promise();
                });
            }, jQuery.Deferred().resolve().promise());
        });
    };
    IAMModelReader.prototype.Load = function () {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.shouldCheckStaleSync().then(function (checkStaleSync) {
                    if (checkStaleSync) {
                        return _this.detectStaleSyncApplications()
                            .then(function (staleSyncApplIds) {
                            if (staleSyncApplIds && staleSyncApplIds.length > 0) {
                                return _this.doStaleSync(staleSyncApplIds);
                            }
                            return null;
                        }).then(function () {
                            // cleanup stale sync global variables
                            _this.languages = [];
                            for (var _i = 0, _a = _this.manager.appls; _i < _a.length; _i++) {
                                var appl = _a[_i];
                                appl.dispose();
                            }
                            _this.manager.activeAppl = null;
                            _this.manager.appls = [];
                            _this.readGetGui = (AppConfig.online) ? _this.readGetGuiOnline : _this.readGetGuiFromStorage;
                        });
                    }
                    return null;
                })
                    .then(function () { return _this.loadConnectionsAndApplications(); })
                    .then(function () { return _this.removeUnusedLocalApplications(); })
                    .then(function () {
                    if (_this.manager.appls.length === 0) {
                        return reject(Model.TranslKeys.noApplications);
                    }
                    var resolveList = [];
                    // This will always find an application because when all apllications have loadonstartup=false
                    // the loadApplications method will load the first application.
                    for (var i = 0; i < _this.manager.appls.length; i++) {
                        var appl = _this.manager.appls[i];
                        if (appl.loadOnStartup) {
                            appl.bootstrapApplication();
                            resolveList.push(_this.LoadApplication(appl));
                            if (!_this.manager.activeAppl) {
                                _this.manager.activeAppl = appl;
                            }
                        }
                    }
                    jQuery.when.apply(undefined, resolveList)
                        .then(resolve)
                        .fail(reject);
                });
                return [2 /*return*/];
            });
        }); });
    };
    IAMModelReader.prototype.loadConnectionsAndApplications = function () {
        var _this = this;
        // Read all connections, global up preferences and application languages before actually loading the applications and their translations.
        return this.loadGlobalSettings()
            .then(function () {
            var resolveList = [];
            resolveList.push(_this.loadApplLangs());
            return _this.executeGetGuiGroup(resolveList);
        }).then(function () {
            return _this.loadGuiAppls();
        }).then(function () {
            return _this.loadGlobalUPPreferences();
        }).then(function () {
            return _this.loadApplTransls();
        }).then(function () {
            for (var i = 0; i < _this.manager.appls.length; i++) {
                var application = _this.manager.appls[i];
                if (jQuery.inArray(application.defaultLanguage, application.supportedLanguagues) > -1) {
                    application.language = new Model.Language(application.defaultLanguage);
                }
                else {
                    application.language = new Model.Language(application.supportedLanguagues[0]);
                }
            }
        });
    };
    IAMModelReader.prototype.loadConnections = function () {
        var _this = this;
        var connParams = this.manager.metaClient.createParameterCollection();
        connParams.add(BaseModelReader.userIdParam, this.manager.user.username);
        connParams.add(BaseModelReader.guiApplParam, null);
        return this.readGetGui("get_gui_connection", connParams, function (reader) {
            for (var i = 0; i < reader.length; i++) {
                var item = reader.item(i);
                var guiApplId = item.getString("gui_appl_id");
                _this.connections[guiApplId] = true;
            }
        });
    };
    IAMModelReader.prototype.loadApplTransls = function () {
        var _this = this;
        var resolveList = [];
        // Get the application translation for every loaded application.
        for (var i = 0; i < this.manager.appls.length; i++) {
            var application = this.manager.appls[i];
            resolveList.push((function (appl) {
                var applTranslParams = _this.manager.metaClient.createParameterCollection();
                applTranslParams.add("gui_appl_id", appl.guiApplId);
                return _this.readGetGui("get_gui_appl_transl", applTranslParams, function (reader) {
                    for (var j = 0; j < reader.length; j++) {
                        var item = reader.item(j);
                        var applLangId = item.getString("appl_lang_id");
                        var transl = item.getString("transl");
                        appl.applicationTransls[applLangId] = transl;
                    }
                });
            })(application));
        }
        return jQuery.when.apply(undefined, resolveList);
    };
    IAMModelReader.prototype.loadApplLangs = function () {
        var _this = this;
        // GetGuiApplLang doesn't require any params.
        return this.readGetGui("get_gui_appl_lang", this.manager.metaClient.createParameterCollection(), function (reader) {
            for (var i = 0; i < reader.length; i++) {
                var item = reader.item(i);
                _this.languages.push(item.getString("appl_lang_id"));
            }
        });
    };
    IAMModelReader.prototype.loadGuiAppls = function () {
        var _this = this;
        var guiApplParams = this.manager.metaClient.createParameterCollection();
        guiApplParams.add(BaseModelReader.userIdParam, this.manager.user.username);
        guiApplParams.add(BaseModelReader.guiApplParam, null);
        // Platform id 2 represents mobile.
        guiApplParams.add(IAMModelReader.platformParam, 2);
        return this.readGetGui("get_gui_gui_appl", guiApplParams, function (reader) { return __awaiter(_this, void 0, void 0, function () {
            var applLoaded, i, item, guiApplId, a, defaultFormProps, guid, manager, user, url, lastSlash, appl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        applLoaded = false;
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < reader.length)) return [3 /*break*/, 4];
                        item = reader.item(i);
                        guiApplId = item.getString("gui_appl_id");
                        a = new Model.TSFApplication(guiApplId);
                        a.projectName = item.getString("project_id");
                        a.projectVersion = item.getString("project_vrs_id");
                        a.supportedLanguagues = this.languages;
                        a.loadOnStartup = item.getBool("load_on_start_up");
                        a.icon = item.getString("icon");
                        a.orderNo = item.getNumber("order_no");
                        defaultFormProps = new Model.FormProps();
                        defaultFormProps.defaultFieldWidth = item.getNumber("field_width");
                        defaultFormProps.defaultLabelWidth = item.getNumber("label_width");
                        a.defaultFormProps = defaultFormProps;
                        guid = item.getString("guid");
                        if (guid) {
                            a.guid = guid;
                        }
                        manager = this.manager;
                        user = manager.user;
                        return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                    case 2:
                        url = _a.sent();
                        lastSlash = url.lastIndexOf("/");
                        if (lastSlash === url.length - 1) {
                            url = url.substring(0, lastSlash);
                            lastSlash = url.lastIndexOf("/");
                        }
                        url = Utils.CombineUrl(url.substring(0, lastSlash), a.guiApplId);
                        a.oDataClient = OnlineClientFactory.createClient(url, user.username, user.password);
                        // Bootstrap the customer DB webservice(s) depend on loadOnStartup
                        if (a.loadOnStartup) {
                            applLoaded = true;
                        }
                        this.manager.appls.push(a);
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4:
                        this.manager.appls = Utils.orderArrayByObjectProperty(this.manager.appls, "orderNo");
                        if (!applLoaded && this.manager.appls.length > 0) {
                            appl = this.manager.appls[0];
                            appl.loadOnStartup = true;
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    };
    IAMModelReader.prototype.loadGlobalSettings = function () {
        var _this = this;
        var guiApplParams = this.manager.metaClient.createParameterCollection();
        guiApplParams.add(BaseModelReader.userIdParam, this.manager.user.username);
        // Platform id 2 represents mobile.
        guiApplParams.add(IAMModelReader.platformParam, 2);
        return this.readGetGui("get_gui_global_settings", guiApplParams, function (reader) {
            // Always one result.
            var item = reader.item(0);
            var globalSettings = _this.manager.globalSettings;
            globalSettings.title = item.getString("title");
            globalSettings.globalBackgroundColor = item.getNumber("global_background_color");
            globalSettings.menuBackgroundColor = item.getNumber("menu_background_color");
            globalSettings.menuFontId = item.getString("menu_font_id");
            globalSettings.setCurrentSFVersion(item.getString("iam_project_vrs_id"));
            var minimalGuiVersion;
            if (Model.TSFApplicationManager.Current.globalSettings.currentSFVersion >= 2 /* V2018_1 */) {
                minimalGuiVersion = item.getString("min_gui_vrs");
            }
            else {
                minimalGuiVersion = item.getString("minimal_gui_vrs");
            }
            globalSettings.minimalGuiVersion = minimalGuiVersion;
            globalSettings.urlNextVersionAppStore = item.getString("url_next_vrs_app_store");
            globalSettings.urlNextVersionGooglePlay = item.getString("url_next_vrs_google_play");
            var currentVersion = window.tsfVersionNumber;
            if (currentVersion && minimalGuiVersion && !_this.guiVersionValid(currentVersion, minimalGuiVersion)) {
                throw AppConfig.invalidGuiVersion;
            }
        });
    };
    IAMModelReader.prototype.guiVersionValid = function (currentVersion, minimalVersion) {
        var currentVersionArray = currentVersion.split(".");
        var minimalVersionArray = minimalVersion.split(".");
        var longestArray = currentVersionArray.length >= minimalVersionArray.length ? currentVersionArray.length : minimalVersionArray.length;
        for (var i = 0; i < longestArray; i++) {
            var currentVersionPartNumber = void 0, minimalVersionPartNumber = void 0;
            // Strip down to only numbers.
            if (currentVersionArray[i])
                currentVersionPartNumber = currentVersionArray[i].match(/\d/g);
            if (minimalVersionArray[i])
                minimalVersionPartNumber = minimalVersionArray[i].match(/\d/g);
            if (currentVersionPartNumber && minimalVersionPartNumber) {
                // If both are set and current version number is lower than minimal number than the gui version is not valid.
                if (currentVersionPartNumber < minimalVersionPartNumber)
                    return false;
                // If both are set and the current number is the same or higher than the minimal number, than the gui version is valid.
                continue;
            }
            // If current number is set and minimal version is not, it means the current version is more recent so it is valid.
            if (currentVersionPartNumber) {
                return true;
            }
            // If minmal number is set and current version is not, it means the current version is less recent than the minimal version so it is not valid.
            if (minimalVersionPartNumber) {
                return false;
            }
        }
        // If both versions are exactly the same the current gui version is valid.
        return true;
    };
    IAMModelReader.prototype.loadGlobalUPPreferences = function () {
        var _this = this;
        // Get the default application language for every loaded application.
        var guiApplParams = this.manager.metaClient.createParameterCollection();
        guiApplParams.add(BaseModelReader.userIdParam, this.manager.user.username);
        guiApplParams.add(IAMModelReader.guiApplParam, null);
        return this.readGetGui("get_gui_up_global", guiApplParams, function (reader) {
            if (reader.length > 0) {
                for (var i = 0; i < _this.manager.appls.length; i++) {
                    var application = _this.manager.appls[i];
                    application.defaultLanguage = reader.item(0).getString("appl_lang_id");
                }
            }
        });
    };
    IAMModelReader.prototype.getDefaultParameters = function (application) {
        var defaultParams = this.manager.metaClient.createParameterCollection();
        defaultParams.add(BaseModelReader.userIdParam, this.manager.user.username);
        defaultParams.add(BaseModelReader.guiApplParam, application.guiApplId);
        defaultParams.add(IAMModelReader.platformParam, 2);
        return defaultParams;
    };
    IAMModelReader.prototype.getExtendedPropertiesParameters = function (application) {
        var params = this.manager.metaClient.createParameterCollection();
        params.add(BaseModelReader.userIdParam, this.manager.user.username);
        params.add(BaseModelReader.guiApplParam, application.guiApplId);
        return params;
    };
    IAMModelReader.platformParam = "platform";
    return IAMModelReader;
}(BaseModelReader));
