var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var Model;
(function (Model) {
    var User = /** @class */ (function () {
        function User() {
        }
        return User;
    }());
    Model.User = User;
    var TSFApplicationManager = /** @class */ (function () {
        function TSFApplicationManager() {
            this.appls = [];
            this.globalSettings = new Model.GlobalSettings();
        }
        Object.defineProperty(TSFApplicationManager.prototype, "TSFCache", {
            get: function () {
                return this.tsfCache;
            },
            enumerable: true,
            configurable: true
        });
        TSFApplicationManager.prototype.loadApplications = function (metaClient, user, password) {
            var _this = this;
            var deferred = jQuery.Deferred();
            this.metaClient = metaClient;
            this.user = new User();
            this.user.username = user;
            this.user.password = password;
            this.tsfCache = new TSFCache();
            this.tsfCache.initializeDatabase().then(function (upgradeNeeded) { return __awaiter(_this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AppConfig.getMetaSource()];
                        case 1:
                            if ((_a.sent()) === "sf") {
                                this.reader = new SFModelReader(this, this.tsfCache);
                            }
                            else {
                                this.reader = new IAMModelReader(this, this.tsfCache);
                            }
                            this.reader.switchToOffline().then(function () {
                                _this.reader.Load().then(function () {
                                    if (AppConfig.online) {
                                        return _this.activeAppl.oDataClient.authenticate().then(function () {
                                            return jQuery.Deferred().resolve().promise();
                                        }, function (message, reason) {
                                            if (reason === RequestStatus.TWO_FACTOR_AUTH_REQUESTED_REASON) {
                                                Model.TSFApplicationManager.Current.pendingApplDeferred = deferred;
                                                jQuery.mobile.pageContainer.pagecontainer("change", "twoFactorValidation.html");
                                            }
                                            else {
                                                return jQuery.Deferred().reject(message).promise();
                                            }
                                        });
                                    }
                                }).then(function () {
                                    _this.activeAppl.addOfflineCodeFiles();
                                    if (upgradeNeeded || AppConfig.foregroundSyncByLogin) {
                                        _this.activeAppl.localSync.fullSynchronize(true).then(function () {
                                            return deferred.resolve();
                                        }).fail(function (err) {
                                            return deferred.reject(err);
                                        });
                                    }
                                    else {
                                        deferred.resolve();
                                    }
                                }).catch(function (err) {
                                    return deferred.reject(err);
                                });
                            }).fail(function (err) {
                                return deferred.reject(err);
                            });
                            return [2 /*return*/];
                    }
                });
            }); });
            return deferred.promise();
        };
        TSFApplicationManager.prototype.changeApplication = function (newApplication) {
            var _this = this;
            var deferred = jQuery.Deferred();
            if (this.activeAppl != newApplication) {
                if (!newApplication.isLoaded) {
                    return this.reader.switchToOffline().then(function () {
                        return _this.reader.LoadApplication(newApplication)
                            .then(function () {
                            newApplication.addOfflineCodeFiles();
                            _this.activeAppl = newApplication;
                            deferred.resolve();
                        })
                            .fail(function (errorMsg) { deferred.reject(errorMsg); });
                    });
                }
                else {
                    this.activeAppl = newApplication;
                    deferred.resolve();
                }
            }
            return deferred.promise();
        };
        TSFApplicationManager.prototype.setGuiStartUseLogSession = function () {
            var deferred = jQuery.Deferred(), params = this.metaClient.createParameterCollection();
            // Add set_gui parameters
            params.add("gui_type", "Mobile");
            params.add("gui_version", window.tsfVersionNumber);
            params.add("usr_id", this.user.username);
            params.add("begin_on", new Date());
            params.add("session_details", navigator.userAgent);
            this.metaClient.invoke("set_gui_start_use_log_session", "POST", params, function (reader, requestStatus) {
                if (requestStatus.success) {
                    // todo: return the session id; isn't returned by the service yet
                    deferred.resolve();
                }
                else {
                    deferred.reject(requestStatus.messages);
                }
            });
            return deferred.promise();
        };
        Object.defineProperty(TSFApplicationManager, "Current", {
            get: function () {
                if (TSFApplicationManager._applManager == null) {
                    TSFApplicationManager._applManager = new TSFApplicationManager();
                }
                return TSFApplicationManager._applManager;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TSFApplicationManager, "hasApplicationManager", {
            get: function () {
                return TSFApplicationManager._applManager !== null;
            },
            enumerable: true,
            configurable: true
        });
        TSFApplicationManager.prototype.refreshObjectModel = function () {
            Utils.showLoader(AppConfig.language.transl(Model.TranslKeys.loadingApplication));
            var that = this, deferred = jQuery.Deferred();
            try {
                that.artificiallySetGuidsChanged();
                that.dispose(false).done(function () {
                    that.loadApplications(that.metaClient, that.user.username, that.user.password)
                        .done(function () {
                        Utils.hideLoader();
                        deferred.resolve();
                    }).fail(function () {
                        Utils.hideLoader();
                        deferred.reject(AppConfig.language.transl(Model.TranslKeys.loginError));
                    });
                });
            }
            catch (error) {
                Utils.hideLoader();
                deferred.reject(error);
            }
            return deferred.promise();
        };
        TSFApplicationManager.prototype.refreshObjectModelFromAnywhere = function () {
            jQuery.mobile.pageContainer.pagecontainer("change", "maintenance.html");
            /*  Best effort to wait for the page to be ready, because if it isn't, the loader isn't shown.
                We aren't binding on the pagecontainerload event because it can't be used here. */
            NavigationManager.waitForNavigation().then(function () {
                setTimeout(function () {
                    var manager = Model.TSFApplicationManager.Current;
                    manager.refreshObjectModel().then(function () {
                        StyleSheetGenerator.generateFullStyle(manager.activeAppl);
                        manager.activeAppl.localSync.fullSynchronize(true)
                            .always(function () {
                            manager.activeAppl.localSync.startLocalSyncInterval();
                        });
                    });
                }, 500);
            });
        };
        TSFApplicationManager.prototype.artificiallySetGuidsChanged = function () {
            this.reader.artificiallySetGuidsChanged();
        };
        TSFApplicationManager.prototype.logoutServer = function () {
            var deferred = jQuery.Deferred();
            //As we use the TSFApplications oDataClient for logging out,
            //we need to make sure there's an application we can access the oDataClient from.
            if (this.appls.length === 0) {
                return deferred.resolve().promise();
            }
            this.appls[0].oDataClient.invoke(OData.LOGOUT, 'POST', null, function () {
                deferred.resolve();
            });
            return deferred.promise();
        };
        TSFApplicationManager.prototype.resetModelServer = function () {
            var _this = this;
            var deferred = jQuery.Deferred();
            //As we use the TSFApplications oDataClient for logging out,
            //we need to make sure there's an application we can access the oDataClient from.
            if (this.appls.length === 0) {
                return deferred.resolve().promise();
            }
            this.appls[0].oDataClient.invoke(OData.RESET_MODEL, 'POST', null, function (reader, status) {
                // Backward compatibility. If the $resetModel action is not available in Indicium,
                // then it's a version of Indicium that does not support 2FA and we can fall back to $logout.
                if (!status.requestSuccess) {
                    _this.appls[0].oDataClient.invoke(OData.LOGOUT, 'POST', null, function () {
                        deferred.resolve();
                    });
                }
                deferred.resolve();
            });
            return deferred.promise();
        };
        TSFApplicationManager.prototype.dispose = function (removeApplicationManager) {
            var _this = this;
            var resolveList = [];
            if (removeApplicationManager) {
                //Make sure we don't get auto logged back in
                Login.autoLoggedIn = true;
                //Logout from Indicium (which results in the entire session being cleared)
                resolveList.push(this.logoutServer());
            }
            else {
                //Reset the user's model in Indicium without logging out.
                resolveList.push(this.resetModelServer());
            }
            // Close all open databases
            for (var i = 0; i < this.appls.length; i++) {
                var appl = this.appls[i];
                resolveList.push(appl.dispose());
            }
            this.stopInactiveApplicationTimer();
            InactivityLogout.StopInactivityLogoutTimer();
            var listPromise = jQuery.when.apply(undefined, resolveList);
            return listPromise.always(function () {
                // Remove and dispose the rest after the databases are closed.
                // And after localSync is finished.
                if (_this.tsfCache) {
                    _this.tsfCache.dispose();
                    _this.tsfCache = null;
                }
                TSFController.clearControllers();
                var activeApplIndex = _this.appls.indexOf(_this.activeAppl);
                if (activeApplIndex >= 0) {
                    _this.appls.splice(activeApplIndex);
                }
                _this.activeAppl = null;
                if (removeApplicationManager) {
                    TSFApplicationManager._applManager = null;
                }
            });
        };
        TSFApplicationManager.prototype.stopInactiveApplicationTimer = function () {
            clearTimeout(this.inactiveApplTimer);
        };
        TSFApplicationManager.prototype.startInactiveApplicationTimer = function () {
            return __awaiter(this, void 0, void 0, function () {
                var that_1, oneMinute_1, startTimer_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AppConfig.getMetaSource()];
                        case 1:
                            // Start a timer which checks the get_gui_gui_appl every 5 minutes.
                            // If an application became inactive navigate to the login page.
                            if ((_a.sent()) === "iam") {
                                that_1 = this;
                                oneMinute_1 = 60000;
                                startTimer_1 = function () {
                                    console.log("checking for inactive applications");
                                    that_1.inactiveApplTimer = window.setTimeout(function () {
                                        var applManager = Model.TSFApplicationManager.Current;
                                        if (applManager.user == null) {
                                            startTimer_1();
                                            return;
                                        }
                                        // If get_gui_gui_appl does not return the same amount of appl id's as there were loaded initially,
                                        // navigate to the login page.
                                        var iamModelReader = new IAMModelReader(applManager, applManager.TSFCache);
                                        var guiApplParams = applManager.metaClient.createParameterCollection();
                                        guiApplParams.add(BaseModelReader.userIdParam, applManager.user.username);
                                        guiApplParams.add(BaseModelReader.guiApplParam, null);
                                        guiApplParams.add("platform", 2); // 2 stands for the mobile platform.
                                        iamModelReader.readGetGui("get_gui_gui_appl", guiApplParams, function (reader) {
                                            var currentApplicationIds = [];
                                            for (var i = 0; i < reader.length; i++) {
                                                var item = reader.item(i);
                                                var guiApplId = item.getString("gui_appl_id");
                                                currentApplicationIds.push(guiApplId);
                                            }
                                            var activePage = jQuery.mobile.activePage;
                                            var applicationsRemoved = false;
                                            var currentActiveAppl = applManager.activeAppl;
                                            for (var j = 0; j < applManager.appls.length; j++) {
                                                var app = applManager.appls[j];
                                                if (currentApplicationIds.indexOf(app.guiApplId) == -1) {
                                                    applManager.appls[j].dispose();
                                                    applManager.appls.splice(j, 1);
                                                    applicationsRemoved = true;
                                                }
                                            }
                                            // Current application became inactive; find a new one
                                            if (currentApplicationIds.indexOf(currentActiveAppl.guiApplId) == -1) {
                                                for (var j = 0; j < applManager.appls.length; j++) {
                                                    var app = applManager.appls[j];
                                                    if (app.isLoaded) {
                                                        applManager.activeAppl = app;
                                                        break;
                                                    }
                                                }
                                            }
                                            // Navigate to the menu without showing a message, for now - the active application became inactive
                                            if (currentActiveAppl != applManager.activeAppl) {
                                                that_1.navigateToMenu();
                                                startTimer_1();
                                            }
                                            else if (currentApplicationIds.indexOf(applManager.activeAppl.guiApplId) == -1) {
                                                // We didn't find a new application and the current applications became inactive
                                                that_1.navigateToLogin();
                                            }
                                            else if (applicationsRemoved) {
                                                // Some applications are removed; when the activePage is a menu we need to refresh it
                                                if (activePage.is("#menu")) {
                                                    that_1.navigateToMenu();
                                                }
                                                startTimer_1();
                                            }
                                            else {
                                                startTimer_1();
                                            }
                                        });
                                    }, oneMinute_1 * 5);
                                };
                                startTimer_1();
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        TSFApplicationManager.prototype.navigateToLogin = function () {
            var activePage = jQuery.mobile.activePage;
            if (!(activePage.is("#login") || activePage.is("#config"))) {
                Model.TSFApplicationManager.Current.dispose(true);
                jQuery.mobile.pageContainer.pagecontainer("change", jQuery("#login"));
            }
        };
        TSFApplicationManager.prototype.navigateToMenu = function () {
            var activePage = jQuery.mobile.activePage;
            if (!(activePage.is("#login") || activePage.is("#config"))) {
                jQuery.mobile.pageContainer.pagecontainer("change", "menu.html", { allowSamePageTransition: "true", reload: "true" });
            }
        };
        TSFApplicationManager.isDebug = false;
        TSFApplicationManager._applManager = null;
        return TSFApplicationManager;
    }());
    Model.TSFApplicationManager = TSFApplicationManager;
    var GlobalSettings = /** @class */ (function () {
        function GlobalSettings() {
        }
        GlobalSettings.prototype.setCurrentSFVersion = function (version) {
            if (Utils.isEmpty(version)) {
                this.currentSFVersion = 0 /* Unsupported */;
            }
            else {
                var re = /^G?([0-9]+)\.([0-9]+)([^0-9]|$).*/i;
                var result = re.exec(version);
                if (result === null) {
                    this.currentSFVersion = 0 /* Unsupported */;
                }
                else {
                    var supportedVersions = ["9.9", "2017.1", "2018.1", "2018.2"];
                    var mainVersion = parseInt(result[1], 10);
                    var subVersion = parseInt(result[2], 10);
                    if (supportedVersions.indexOf(mainVersion + "." + subVersion) === -1) {
                        this.currentSFVersion = 0 /* Unsupported */;
                    }
                    else if ((mainVersion === 9 && subVersion === 9) || (mainVersion === 2017 && subVersion === 1)) {
                        // 2017.1 used to be called G9.9
                        this.currentSFVersion = 1 /* V2017_1 */;
                    }
                    else if (mainVersion === 2018 && subVersion === 1) {
                        this.currentSFVersion = 2 /* V2018_1 */;
                    }
                    else if (mainVersion === 2018 && subVersion === 2) {
                        this.currentSFVersion = 3 /* V2018_2 */;
                    }
                    else {
                        this.currentSFVersion = 0 /* Unsupported */;
                    }
                }
            }
            if (this.currentSFVersion === 0 /* Unsupported */) {
                throw Model.TranslKeys.error_unsupported_meta_version;
            }
        };
        return GlobalSettings;
    }());
    Model.GlobalSettings = GlobalSettings;
    var TSFApplication = /** @class */ (function () {
        function TSFApplication(guiApplId) {
            this.guiApplId = guiApplId;
            this.isLoaded = false;
            // An object with application translations indexable on language code.
            this.applicationTransls = {};
            // A list with the msg translations.
            this.guiMsgList = [];
            // The LocalSync interval in minutes.
            this.syncInterval = 0.5;
            this.syncGroups = new Collections.List();
            // The offline code files are saved so that they can be added to and removed from the dom.
            this.codeFiles = [];
            this.extendedProperties = new ExtendedProperties();
            this.model = new Model.TSFObjectModel(this);
        }
        Object.defineProperty(TSFApplication.prototype, "transl", {
            // A getter which returns the appropriate application translation based on the current language.
            get: function () {
                var transl = this.applicationTransls[this.language.code];
                if (!transl) {
                    return this.projectName;
                }
                return transl;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TSFApplication.prototype, "serverSync", {
            get: function () {
                return this._serverSync;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TSFApplication.prototype, "localSync", {
            get: function () {
                return this._localSync;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TSFApplication.prototype, "fileCache", {
            get: function () {
                return this._fileCache;
            },
            enumerable: true,
            configurable: true
        });
        TSFApplication.prototype.getStorageContainer = function () {
            return this.db;
        };
        TSFApplication.prototype.getDatabase = function () {
            var db = this.db;
            return db ? db.getDatabase() : null;
        };
        TSFApplication.prototype.databaseIsDisposed = function () {
            return this.db ? this.db.isDisposed : true;
        };
        TSFApplication.prototype.initializeDatabase = function () {
            var _this = this;
            if (typeof indexedDB === "undefined") {
                Logger.log("IndexedDB is not supported", LogType.ERROR);
                return jQuery.Deferred().resolve().promise();
            }
            this.db = new IndexedDb.IndexedDbWrapper(this);
            return this.db.initializeDatabase().then(function () {
                _this._localSync = new LocalSync(_this, TSFApplicationManager.Current.TSFCache);
                _this._serverSync = new ServerSync(_this);
                _this._fileCache = new FileCache(_this);
                return _this._localSync.initialize();
            });
        };
        TSFApplication.prototype.waitForEditmode = function () {
            var deferred = jQuery.Deferred();
            var resolveList = [];
            for (var controllerId in TSFController.masterControllers[this.guiApplId]) {
                resolveList.push(TSFController.masterControllers[this.guiApplId][controllerId].waitForEditmodeFinished());
            }
            // A then can be applied because the promises in the resolveList only resolve and never reject.
            jQuery.when.apply(undefined, resolveList).then(function () { deferred.resolve(); });
            return deferred.promise();
        };
        TSFApplication.prototype.doOnlineSwitch = function (online) {
            var _this = this;
            var deferred = jQuery.Deferred();
            if (online) {
                var manager_1 = TSFApplicationManager.Current;
                manager_1.activeAppl.oDataClient.authenticate().then(function () {
                    _this.doOnlineSwitchMasters();
                    deferred.resolve();
                }, function (message, reason) {
                    if (reason == RequestStatus.TWO_FACTOR_AUTH_REQUESTED_REASON) {
                        var title = manager_1.activeAppl.language.transl(TranslKeys.auth_expired_title);
                        var message_1 = manager_1.activeAppl.language.transl(TranslKeys.auth_expired_message);
                        ConfirmationPopup.CreateOkPopup().initialize(title, message_1);
                    }
                    deferred.reject();
                });
            }
            else {
                this.doOnlineSwitchMasters();
                deferred.reject();
            }
            return deferred.promise();
        };
        TSFApplication.prototype.doOnlineSwitchMasters = function () {
            var list = TSFController.masterControllers[this.guiApplId];
            for (var controllerId in list) {
                list[controllerId].doOnlineSwitch();
            }
        };
        TSFApplication.prototype.removeOfflineCodeFiles = function () {
            for (var i = 0; i < this.codeFiles.length; i++) {
                var codeFile = this.codeFiles[i];
                jQuery("#" + codeFile.codeFileId).remove();
            }
            // Reset the offline code, its stored in a window object.
            var vrs = this.projectVersion.replace(/\./g, "");
            var namespace = this.projectName + vrs;
            try {
                // Sometimes we provide the code with the gui, we shouldn't remove it in that case
                // because we can't recreate them; therefore only remove this when there are codefiles (so the js comes from the sf)
                if (this.codeFiles.length > 0) {
                    window[namespace] = undefined;
                    delete window[namespace];
                }
            }
            catch (e) { }
        };
        TSFApplication.prototype.addOfflineCodeFiles = function () {
            for (var i = 0; i < this.codeFiles.length; i++) {
                var codeFile = this.codeFiles[i];
                var script = document.createElement("script");
                script.id = codeFile.codeFileId;
                script.type = "text/javascript";
                var code = "try {\r\n" +
                    codeFile.code + "\r\n" +
                    "} catch (ex) {\r\n" +
                    "    throw new Error('Error in offline code: ' + ex);\r\n" +
                    "}\r\n";
                script.text = code;
                document.body.appendChild(script);
            }
        };
        TSFApplication.prototype.bootstrapApplication = function () {
            this.oDataClient.invoke(OData.WARMUP, 'GET', null, null);
        };
        TSFApplication.prototype.dispose = function () {
            var _this = this;
            // Remove the offline code files first.
            this.removeOfflineCodeFiles();
            // Cleanup controller
            TSFController.clearControllers(this);
            // Dispose the database after the localSync is disposed.
            // The localSync dispose waits for the fullSynchronize to finish.
            // This will only finish the last subject, not the entire set.
            // LocalSync and the db might be null when a login attempt failed during executing of the GetGui's
            var dispose = jQuery.Deferred();
            dispose.always(function () {
                if (_this.db) {
                    _this.serverSync ? _this.serverSync.dispose() : jQuery.Deferred().resolve().promise();
                    _this.localSync ? _this.localSync.dispose() : jQuery.Deferred().resolve().promise();
                    _this.db.dispose();
                    dispose.resolve();
                }
                else {
                    dispose.reject();
                }
            });
            return dispose.resolve().promise();
        };
        return TSFApplication;
    }());
    Model.TSFApplication = TSFApplication;
    var Globalization = /** @class */ (function () {
        function Globalization() {
        }
        Globalization.detectGlobalization = function (languageCode) {
            // We use a custom detection logic for the viewer and the plugin for cordova but because it works async and requires the deviceready event to be fired
            // we can't actually do the right thing at the start so we return just something. A race condition is possible but not very likely
            // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/NumberFormat is a bit to heavy for our usecase
            // because we require a polyfill to use it.
            // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/toLocaleString removes trailing zero's in the decimal part
            // which isn't what we want either so we go full custom ;)
            var defaultGlobalization = {
                numberGroupSeparator: ".",
                numberDecimalSeparator: ",",
                brokenToLocaleString: true
            };
            // Cordova uses the system language because on iOS the device uses the system language to format the locale
            if (typeof window["cordova"] !== "undefined") {
                // if cordova deviceready is already fired, the custom implementation for addEventListener (provided by cordova)
                // fires immediately so this is save to do here
                document.addEventListener("deviceready", function () {
                    navigator.globalization.getNumberPattern(function (result) {
                        defaultGlobalization.numberDecimalSeparator = result.decimal;
                        defaultGlobalization.numberGroupSeparator = result.grouping;
                    }, null);
                });
            }
            else {
                var testNumber = 1000.01;
                var userLocaleString = testNumber.toLocaleString(languageCode);
                if (userLocaleString.length == 8) {
                    return {
                        numberGroupSeparator: userLocaleString.substring(1, 2),
                        numberDecimalSeparator: userLocaleString.substring(5, 6),
                        brokenToLocaleString: false
                    };
                }
            }
            return defaultGlobalization;
        };
        return Globalization;
    }());
    Model.Globalization = Globalization;
    var TSFObjectModel = /** @class */ (function () {
        function TSFObjectModel(application) {
            this.application = application;
            this.listbarMenus = new Collections.List();
            this.tileMenus = new Collections.List();
            this.defaultMenu = null;
            this.objs = new Collections.List();
            this.tasks = new Collections.List();
            this.reports = new Collections.List();
            this.domains = {};
            this.screenTypes = {};
            this.containsOfflineObjs = false;
            var cubeScreenType = new ScreenType("cube");
            var cubeScreenComponent = new ScreenComponent("Cube");
            cubeScreenComponent.screenComponentTypeId = "Cube";
            cubeScreenType.screenComponents.push(cubeScreenComponent);
            cubeScreenType.addActualScreenComponent(cubeScreenComponent);
            this.screenTypes[cubeScreenType.screenTypeId] = cubeScreenType;
        }
        TSFObjectModel.prototype.getObj = function (id) {
            return this.objs.object[id];
        };
        return TSFObjectModel;
    }());
    Model.TSFObjectModel = TSFObjectModel;
    // #Region ListBar
    var ApplicationStyle = /** @class */ (function () {
        function ApplicationStyle(id) {
            this.id = id;
            this.grid = new GridLayout();
            this.quickbar = new QuickbarLayout();
            this.tiles = new TilesLayout();
            this.tab = new TabLayout();
            this.button = new ButtonLayout();
            this.label = new LabelLayout();
            this.labelActive = new LabelLayout();
            this.badgeLayout = new BadgeLayout();
        }
        return ApplicationStyle;
    }());
    Model.ApplicationStyle = ApplicationStyle;
    var GridLayout = /** @class */ (function () {
        function GridLayout() {
        }
        return GridLayout;
    }());
    Model.GridLayout = GridLayout;
    var PageBarLayout = /** @class */ (function () {
        function PageBarLayout() {
        }
        return PageBarLayout;
    }());
    Model.PageBarLayout = PageBarLayout;
    var QuickbarLayout = /** @class */ (function () {
        function QuickbarLayout() {
        }
        return QuickbarLayout;
    }());
    Model.QuickbarLayout = QuickbarLayout;
    var TilesLayout = /** @class */ (function () {
        function TilesLayout() {
        }
        return TilesLayout;
    }());
    Model.TilesLayout = TilesLayout;
    var TabLayout = /** @class */ (function () {
        function TabLayout() {
        }
        return TabLayout;
    }());
    Model.TabLayout = TabLayout;
    var ButtonLayout = /** @class */ (function () {
        function ButtonLayout() {
        }
        return ButtonLayout;
    }());
    Model.ButtonLayout = ButtonLayout;
    var LabelLayout = /** @class */ (function () {
        function LabelLayout() {
        }
        return LabelLayout;
    }());
    Model.LabelLayout = LabelLayout;
    var BadgeLayout = /** @class */ (function () {
        function BadgeLayout() {
        }
        return BadgeLayout;
    }());
    Model.BadgeLayout = BadgeLayout;
    var ListbarMenu = /** @class */ (function () {
        function ListbarMenu(menuId) {
            this.menuId = menuId;
            this.groups = new Collections.List();
        }
        return ListbarMenu;
    }());
    Model.ListbarMenu = ListbarMenu;
    var ListbarGroup = /** @class */ (function () {
        function ListbarGroup(groupId) {
            this.groupId = groupId;
            this.items = [];
        }
        return ListbarGroup;
    }());
    Model.ListbarGroup = ListbarGroup;
    var ListbarItem = /** @class */ (function () {
        function ListbarItem(itemId) {
            this.itemId = itemId;
        }
        return ListbarItem;
    }());
    Model.ListbarItem = ListbarItem;
    var TilesMenu = /** @class */ (function () {
        function TilesMenu(menuId) {
            this.menuId = menuId;
            this.groups = new Collections.List();
        }
        return TilesMenu;
    }());
    Model.TilesMenu = TilesMenu;
    var TileGroup = /** @class */ (function () {
        function TileGroup(groupId) {
            this.groupId = groupId;
            this.items = [];
        }
        return TileGroup;
    }());
    Model.TileGroup = TileGroup;
    var Tile = /** @class */ (function () {
        function Tile(itemId) {
            this.itemId = itemId;
        }
        return Tile;
    }());
    Model.Tile = Tile;
    var OpenEntity = /** @class */ (function () {
        function OpenEntity(entityId, configurationId, entityType) {
            this.entityId = entityId;
            this.configurationId = configurationId;
            this.entityType = entityType;
            // TODO: Why is this part of the OpenEntity and not delegated to the underlying tab/task/variant; returned by get_gui_list_bar_item
            this.showBadge = false;
            /**
             * Interval for refreshing the badge in seconds, 0 = no updates
             */
            this.badgeInterval = 0;
        }
        return OpenEntity;
    }());
    Model.OpenEntity = OpenEntity;
    var ObjSorting = /** @class */ (function () {
        function ObjSorting() {
            this.sortProps = [];
        }
        ObjSorting.prototype.add = function (viewProp, direction) {
            var sortProp = new SortObjProp();
            sortProp.viewProp = viewProp;
            sortProp.direction = direction;
            this.sortProps.push(sortProp);
        };
        ObjSorting.prototype.toWebserviceContract = function (allowTranslationSort) {
            var sortContract = [];
            for (var i = 0; i < this.sortProps.length; i++) {
                var sortProp = this.sortProps[i];
                var name_1 = sortProp.viewProp.objPropId;
                if (allowTranslationSort && sortProp.viewProp.isTranslatedLookup()) {
                    name_1 = sortProp.viewProp.objLinkLookupView.objLink.refId + "/" + sortProp.viewProp.lookup.getTranslListProp().objPropId;
                }
                sortContract.push({
                    name: name_1,
                    direction: sortProp.direction,
                    sortOrder: sortProp.viewProp.sortNo
                });
            }
            return sortContract;
        };
        return ObjSorting;
    }());
    Model.ObjSorting = ObjSorting;
    var SortObjProp = /** @class */ (function () {
        function SortObjProp() {
        }
        return SortObjProp;
    }());
    Model.SortObjProp = SortObjProp;
    var CodeFile = /** @class */ (function () {
        function CodeFile(codeFileId, code) {
            this.codeFileId = codeFileId;
            this.code = code;
        }
        return CodeFile;
    }());
    Model.CodeFile = CodeFile;
    // #EndRegion
    // #Region Obj
    var Obj = /** @class */ (function () {
        function Obj(objId) {
            this.objId = objId;
            this.objProps = new Collections.List();
            this.pkProps = [];
            this.childObjs = new Collections.List();
            this.tasks = new Collections.List();
            this.reports = [];
            this.prefilters = new Collections.List();
            this.conditionalLayouts = {};
            this.sortIndexes = {};
            this.objLinkIndexes = {};
            this.lookupFilterIndexes = {};
            // TODO: this is used for hacky purposes, should be removed.
            this.isTask = false;
            this.objViews = new Collections.List();
            this.defaultObjView = new ObjView(this, null);
            this.lookupDisplay = new ObjLookupDisplayProperties(this);
        }
        return Obj;
    }());
    Model.Obj = Obj;
    var ObjView = /** @class */ (function () {
        function ObjView(obj, objViewId) {
            this.obj = obj;
            this.objViewId = objViewId;
            this.showBadge = false;
            /**
             * Interval for refreshing the badge in seconds, 0 = no updates
             */
            this.badgeInterval = 0;
            this.defaultEditableForm = false;
            this.formAutoSave = false;
            this.objViewProps = new Collections.List();
            this.conditionalLayouts = {};
            this.prefilters = new Collections.List();
            this.taskLinkViews = [];
            this.objLinkDetailViews = new Collections.List();
            this.objLinkLookupViews = new Collections.List();
            this.processFlowRoots = [];
        }
        Object.defineProperty(ObjView.prototype, "objId", {
            get: function () {
                return this.obj.objId;
            },
            enumerable: true,
            configurable: true
        });
        ObjView.prototype.getFormOrderedProps = function () {
            // Sort the props in the correct order for the form.
            // Note: .slice creates a copy because sort changes the original array.
            // Note: for now we use .call, because we also index props on id, so some function might get overwritten.
            var props = this.objViewProps;
            props = Array.prototype.slice.call(props.array, 0, props.array.length);
            return Array.prototype.sort.call(props, function (a, b) {
                return a.formOrderNo - b.formOrderNo;
            });
        };
        ObjView.prototype.getPrefilterState = function (dataContextOption) {
            var prefilterState = [];
            var prefilters = this.prefilters.array;
            for (var i = 0; i < prefilters.length; i++) {
                var viewPrefilter = prefilters[i], state = new PrefilterState(viewPrefilter.prefilter, viewPrefilter.contextDefaultState[dataContextOption]);
                prefilterState.push(state);
            }
            return prefilterState;
        };
        ObjView.prototype.getOrderedChildObjs = function () {
            // Sort the ObjLinks in the correct order.
            // Note: .slice creates a copy because sort changes the original array.
            // Note: for now we use .call, because we also index ObjLinks on id, so some function might get overwritten.
            var childObjs = this.objLinkDetailViews;
            childObjs = Array.prototype.slice.call(childObjs.array, 0, childObjs.array.length);
            return Array.prototype.sort.call(childObjs, function (a, b) {
                return a.orderNo - b.orderNo;
            });
        };
        ObjView.prototype.createDefaultSorting = function () {
            // Bugfix for VDI, because we index on objPropId it breaks when objPropId is a array function
            // We should probably create a wrapper around the indexer
            var sortingProps = Array.prototype.filter.call(this.objViewProps.array, function (value) {
                return value.sortNo != 0;
            });
            // TODO: Check relevance of this comment for Indicium.
            // Note: we don't sort on the sortNo here because we need to provide the sorting in the right order for the
            // C# service tier (the contract order).
            if (sortingProps.length != 0) {
                var sorting = new ObjSorting();
                for (var i = 0; i < sortingProps.length; i++) {
                    var viewProp = sortingProps[i];
                    sorting.add(viewProp, viewProp.sortOrder);
                }
                this.sorting = sorting;
            }
        };
        ObjView.prototype.getProcessFlowRoot = function (processType) {
            for (var _i = 0, _a = this.processFlowRoots; _i < _a.length; _i++) {
                var root = _a[_i];
                if (root.processActionType == processType) {
                    return root;
                }
            }
            return null;
        };
        ObjView.prototype.getTaskProcessFlowRoot = function (processType, taskId) {
            for (var _i = 0, _a = this.processFlowRoots; _i < _a.length; _i++) {
                var root = _a[_i];
                if (root.processActionType == processType &&
                    root.taskLink.task.taskId == taskId) {
                    return root;
                }
            }
        };
        ObjView.prototype.getTaskWithoutContextProcessFlowRoot = function (processType, taskId) {
            for (var _i = 0, _a = this.processFlowRoots; _i < _a.length; _i++) {
                var root = _a[_i];
                if (root.processActionType === processType &&
                    root.taskView.task.taskId === taskId) {
                    return root;
                }
            }
        };
        return ObjView;
    }());
    Model.ObjView = ObjView;
    var PrimaryKeyIndex = /** @class */ (function () {
        function PrimaryKeyIndex() {
            this.indexName = IndexedDb.IndexedDbWrapper.pkIndexName;
        }
        return PrimaryKeyIndex;
    }());
    Model.PrimaryKeyIndex = PrimaryKeyIndex;
    var SortIndex = /** @class */ (function () {
        function SortIndex() {
            this.indexName = IndexedDb.IndexedDbWrapper.sortIndexName;
            this.sortingProps = [];
        }
        return SortIndex;
    }());
    Model.SortIndex = SortIndex;
    var FormProps = /** @class */ (function () {
        function FormProps() {
        }
        return FormProps;
    }());
    Model.FormProps = FormProps;
    var ScreenType = /** @class */ (function () {
        function ScreenType(screenTypeId) {
            this.screenTypeId = screenTypeId;
            this.screenComponents = [];
            this.actualScreenComponents = [];
            this.hasForm = false;
            this.hasTaskBar = false;
            this.hasDetailButtons = false;
        }
        ScreenType.prototype.getScreenComponent = function (screenComponentId) {
            var screenComponent = this.screenComponents.filter(function (screenComponent) {
                return screenComponent.screenComponentId === screenComponentId;
            })[0];
            return screenComponent ? screenComponent : null;
        };
        ScreenType.prototype.addActualScreenComponent = function (screenComponent) {
            if (!this.getActualScreenComponent(screenComponent.screenComponentTypeId)) {
                this.actualScreenComponents.push(screenComponent);
            }
        };
        ScreenType.prototype.getActualScreenComponent = function (screenComponentTypeId) {
            var actualScreenComponent = this.actualScreenComponents.filter(function (screenComponent) {
                return screenComponent.screenComponentTypeId === screenComponentTypeId;
            })[0];
            return actualScreenComponent ? actualScreenComponent : null;
        };
        return ScreenType;
    }());
    Model.ScreenType = ScreenType;
    var ScreenComponent = /** @class */ (function () {
        function ScreenComponent(screenComponentId) {
            this.screenComponentId = screenComponentId;
            this.screenComponentProps = {};
        }
        return ScreenComponent;
    }());
    Model.ScreenComponent = ScreenComponent;
    // #EndRegion
    // #Region Task
    var Task = /** @class */ (function () {
        function Task(taskId) {
            this.taskId = taskId;
            this.taskViews = new Collections.List();
        }
        return Task;
    }());
    Model.Task = Task;
    var TaskView = /** @class */ (function () {
        function TaskView(task, taskViewId) {
            this.task = task;
            this.taskViewId = taskViewId;
        }
        return TaskView;
    }());
    Model.TaskView = TaskView;
    var TaskLink = /** @class */ (function () {
        function TaskLink(task, obj) {
            this.task = task;
            this.obj = obj;
            this.props = new Collections.List();
        }
        return TaskLink;
    }());
    Model.TaskLink = TaskLink;
    var TaskLinkView = /** @class */ (function () {
        function TaskLinkView(taskLink, taskView) {
            this.taskLink = taskLink;
            this.taskView = taskView;
        }
        return TaskLinkView;
    }());
    Model.TaskLinkView = TaskLinkView;
    var TaskLinkProp = /** @class */ (function () {
        function TaskLinkProp(taskParmtrId) {
            this.taskParmtrId = taskParmtrId;
        }
        return TaskLinkProp;
    }());
    Model.TaskLinkProp = TaskLinkProp;
    var TaskViewLinkProp = /** @class */ (function () {
        function TaskViewLinkProp(taskLinkProp) {
            this.taskLinkProp = taskLinkProp;
        }
        return TaskViewLinkProp;
    }());
    Model.TaskViewLinkProp = TaskViewLinkProp;
    // #EndRegion
    // #Region ObjProp
    var DttpId;
    (function (DttpId) {
        DttpId[DttpId["boolean"] = 0] = "boolean";
        DttpId[DttpId["integer"] = 1] = "integer";
        DttpId[DttpId["float"] = 2] = "float";
        DttpId[DttpId["string"] = 3] = "string";
        DttpId[DttpId["binary"] = 4] = "binary";
        DttpId[DttpId["time"] = 5] = "time";
        DttpId[DttpId["datetime"] = 6] = "datetime";
        DttpId[DttpId["guid"] = 7] = "guid";
    })(DttpId = Model.DttpId || (Model.DttpId = {}));
    var ObjProp = /** @class */ (function () {
        function ObjProp(obj, objPropId) {
            this.obj = obj;
            this.objPropId = objPropId;
        }
        ObjProp.prototype.getPrecision = function () {
            if (!Utils.isEmpty(this.precision)) {
                return this.precision;
            }
            return 2;
        };
        ObjProp.prototype.isNumeric = function () {
            var controlId = this.controlId, dttp = this.xmlDttp;
            return controlId == Enum.ControlType.CALCULATOR || controlId == Enum.ControlType.NUMERIC ||
                dttp == "double" || dttp == "int" || dttp == "decimal" || dttp == "long";
        };
        ObjProp.prototype.setDttpIdFromSqlDttp = function (sqlDttp) {
            switch (sqlDttp.toUpperCase()) {
                case "BIT":
                    this.dttpId = DttpId.boolean;
                    break;
                case "TINYINT":
                case "SMALLINT":
                case "INT":
                case "BIGINT":
                case "NUMBER":
                case "LONG":
                    this.dttpId = DttpId.integer;
                    break;
                case "FLOAT":
                case "MONEY":
                case "REAL":
                case "SMALLMONEY":
                case "NUMERIC":
                case "DECIMAL":
                    this.dttpId = DttpId.float;
                    break;
                case "CHAR":
                case "NCHAR":
                case "NTEXT":
                case "NVARCHAR":
                case "NVARCHAR_MAX":
                case "VARCHAR":
                case "VARCHAR_MAX":
                case "TEXT":
                case "XML":
                case "GRAPHIC":
                case "VARGRAPHIC":
                case "DBCLOB":
                case "VARCHAR2":
                    this.dttpId = DttpId.string;
                    if (Utils.isEmpty(this.xmlDttp)) {
                        this.xmlDttp = "string";
                    }
                    break;
                case "IMAGE":
                case "VARBINARY":
                case "VARBINARY_MAX":
                case "BINARY":
                case "BLOB":
                case "FILESTREAM":
                case "ROWVERSION":
                case "TIMESTAMP":
                case "CLOB":
                    this.dttpId = DttpId.binary;
                    if (Utils.isEmpty(this.xmlDttp)) {
                        this.xmlDttp = "base64Binary";
                    }
                    break;
                case "TIME":
                    this.dttpId = DttpId.time;
                    break;
                case "ROWGUID":
                case "UNIQUEIDENTIFIER":
                    this.dttpId = DttpId.guid;
                    if (Utils.isEmpty(this.xmlDttp)) {
                        this.xmlDttp = "string";
                    }
                    break;
                case "DATE":
                case "DATETIME":
                case "DATETIME2":
                case "DATETIMEOFFSET":
                case "SMALLDATETIME":
                    this.dttpId = DttpId.datetime;
                    break;
                default:
                    throw "Unsupported datatype " + sqlDttp;
            }
        };
        return ObjProp;
    }());
    Model.ObjProp = ObjProp;
    var ObjViewProp = /** @class */ (function () {
        function ObjViewProp(objProp) {
            this.objProp = objProp;
        }
        Object.defineProperty(ObjViewProp.prototype, "objPropId", {
            get: function () {
                return this.objProp.objPropId;
            },
            enumerable: true,
            configurable: true
        });
        ObjViewProp.prototype.isTranslatedLookup = function () {
            return this.hasLookup() && (this.lookup.isTranslated() || (this.lookup.listProp.hasLookup() && this.lookup.listProp.isTranslatedLookup()));
        };
        ObjViewProp.prototype.hasLookup = function () {
            return this.lookup != null;
        };
        return ObjViewProp;
    }());
    Model.ObjViewProp = ObjViewProp;
    var LookupFilterIndex = /** @class */ (function () {
        function LookupFilterIndex() {
            this.indexName = IndexedDb.IndexedDbWrapper.lfPrefix;
            this.lookupFilters = [];
            this.upperCase = false;
        }
        return LookupFilterIndex;
    }());
    Model.LookupFilterIndex = LookupFilterIndex;
    var LookupProps = /** @class */ (function () {
        function LookupProps() {
            this.filters = [];
        }
        LookupProps.prototype.isTranslated = function () {
            return this.dataProp.objPropId != this.listProp.objPropId;
        };
        LookupProps.prototype.hasContinuedJoining = function () {
            return this.dataProp.objPropId == this.listProp.objPropId && this.listProp.isTranslatedLookup();
        };
        LookupProps.prototype.getTranslDataProp = function () {
            if (this.hasContinuedJoining()) {
                return this.listProp.lookup.getTranslDataProp();
            }
            return this.dataProp;
        };
        LookupProps.prototype.getTranslListProp = function () {
            if (this.hasContinuedJoining()) {
                return this.listProp.lookup.getTranslListProp();
            }
            return this.listProp;
        };
        LookupProps.prototype.getTranslTargetObjView = function () {
            if (this.hasContinuedJoining()) {
                return this.listProp.lookup.getTranslTargetObjView();
            }
            return this.targetObjView;
        };
        return LookupProps;
    }());
    Model.LookupProps = LookupProps;
    var Domain = /** @class */ (function () {
        function Domain(domId) {
            this.domId = domId;
            this.elements = new Collections.List();
        }
        return Domain;
    }());
    Model.Domain = Domain;
    var DomainElement = /** @class */ (function () {
        function DomainElement(elementId) {
            this.elementId = elementId;
        }
        return DomainElement;
    }());
    Model.DomainElement = DomainElement;
    // #EndRegion
    // #Region Prefilter
    var Prefilter = /** @class */ (function () {
        function Prefilter() {
            this.prefilterProps = [];
        }
        Prefilter.prototype.isUserDefinedPrefilter = function () {
            return this.group != null && this.group.groupId == Prefilter.UserDefinedPrefilterGrp;
        };
        Prefilter.UserDefinedPrefilterGrp = "usr_defined_prefilter_grp";
        return Prefilter;
    }());
    Model.Prefilter = Prefilter;
    var ObjViewPrefilter = /** @class */ (function () {
        function ObjViewPrefilter(prefilter) {
            this.prefilter = prefilter;
            this.contextDefaultState = [];
        }
        Object.defineProperty(ObjViewPrefilter.prototype, "prefilterId", {
            get: function () {
                return this.prefilter.prefilterId;
            },
            enumerable: true,
            configurable: true
        });
        return ObjViewPrefilter;
    }());
    Model.ObjViewPrefilter = ObjViewPrefilter;
    var PrefilterProp = /** @class */ (function () {
        function PrefilterProp() {
        }
        return PrefilterProp;
    }());
    Model.PrefilterProp = PrefilterProp;
    var PrefilterState = /** @class */ (function () {
        function PrefilterState(prefilter, defaultState) {
            this.defaultState = defaultState;
            this.prefilter = prefilter;
            this.selected = (defaultState != 1 /* Off */ && defaultState != 0 /* OffHidden */);
            this.locked = (defaultState != 1 /* Off */ && defaultState != 2 /* On */);
        }
        Object.defineProperty(PrefilterState.prototype, "isHidden", {
            get: function () {
                return this.defaultState == 0 /* OffHidden */ || this.defaultState == 4 /* OnHidden */;
            },
            enumerable: true,
            configurable: true
        });
        PrefilterState.prototype.clone = function () {
            var newState = new PrefilterState(this.prefilter, this.defaultState);
            newState.selected = this.selected;
            return newState;
        };
        return PrefilterState;
    }());
    Model.PrefilterState = PrefilterState;
    // #EndRegion
    // #Region ObjLinks
    var ObjLinkIndex = /** @class */ (function () {
        function ObjLinkIndex() {
            this.indexName = IndexedDb.IndexedDbWrapper.olPrefix;
            this.objLinkProps = [];
        }
        return ObjLinkIndex;
    }());
    Model.ObjLinkIndex = ObjLinkIndex;
    var ObjLink = /** @class */ (function () {
        function ObjLink(parentObj, refId, childObj) {
            this.parentObj = parentObj;
            this.refId = refId;
            this.childObj = childObj;
            this.props = [];
            this.lookupDisplay = new ObjLookupDisplayProperties(parentObj);
        }
        ObjLink.prototype.fixSort = function () {
            this.props = this.props.sort(function (a, b) {
                return a.orderNo - b.orderNo;
            });
        };
        ObjLink.prototype.determineInheritance = function () {
            var _loop_1 = function (pkProp) {
                if (!this_1.props.some(function (x) { return x.targetProp.objPropId == pkProp.objPropId; })) {
                    this_1.inheritance = false;
                    return { value: void 0 };
                }
            };
            var this_1 = this;
            for (var _i = 0, _a = this.childObj.pkProps; _i < _a.length; _i++) {
                var pkProp = _a[_i];
                var state_1 = _loop_1(pkProp);
                if (typeof state_1 === "object")
                    return state_1.value;
            }
            this.inheritance = true;
        };
        return ObjLink;
    }());
    Model.ObjLink = ObjLink;
    var ObjLinkLookupView = /** @class */ (function () {
        function ObjLinkLookupView(objLink) {
            this.objLink = objLink;
        }
        ObjLinkLookupView.prototype.getPrefilterState = function () {
            return this.objView.getPrefilterState(2 /* Lookup */);
        };
        return ObjLinkLookupView;
    }());
    Model.ObjLinkLookupView = ObjLinkLookupView;
    var ObjLinkDetailView = /** @class */ (function () {
        function ObjLinkDetailView(objLink) {
            this.objLink = objLink;
        }
        ObjLinkDetailView.prototype.getPrefilterState = function () {
            return this.objView.getPrefilterState(1 /* Detail */);
        };
        return ObjLinkDetailView;
    }());
    Model.ObjLinkDetailView = ObjLinkDetailView;
    var ObjLookupDisplayProperties = /** @class */ (function () {
        //look_up_display_expression
        function ObjLookupDisplayProperties(obj) {
            this.obj = obj;
        }
        return ObjLookupDisplayProperties;
    }());
    Model.ObjLookupDisplayProperties = ObjLookupDisplayProperties;
    var ObjLinkProp = /** @class */ (function () {
        function ObjLinkProp(objLink, sourcePropId, targetPropId) {
            this.sourceProp = objLink.parentObj.objProps.object[sourcePropId];
            this.targetProp = objLink.childObj.objProps.object[targetPropId];
        }
        return ObjLinkProp;
    }());
    Model.ObjLinkProp = ObjLinkProp;
    // #EndRegion
    // #Region ConditionalLayouts
    var ConditionalLayout = /** @class */ (function () {
        function ConditionalLayout(conditionalLayoutID) {
            this.conditionalLayoutID = conditionalLayoutID;
            this.conditions = [];
        }
        return ConditionalLayout;
    }());
    Model.ConditionalLayout = ConditionalLayout;
    var ConditionalLayoutCondition = /** @class */ (function () {
        function ConditionalLayoutCondition() {
        }
        return ConditionalLayoutCondition;
    }());
    Model.ConditionalLayoutCondition = ConditionalLayoutCondition;
    // #EndRegion
    var ObjViewCube = /** @class */ (function () {
        function ObjViewCube(objView, cube) {
            this.objView = objView;
            this.cube = cube;
            this.cubeViews = new Collections.List();
            this.defaultCubeViewId = cube.defaultCubeViewId;
        }
        ObjViewCube.prototype.addCubeView = function (cubeView) {
            this.cubeViews.add(cubeView.cubeViewId, cubeView);
            // If there is a defaultCubeViewId set it as the defaultCubeView;
            // When there isn't a default just use the first one
            if (cubeView.cubeViewId == this.defaultCubeViewId ||
                this.defaultCubeViewId == undefined && !this.defaultCubeView) {
                this.defaultCubeView = cubeView;
            }
        };
        return ObjViewCube;
    }());
    Model.ObjViewCube = ObjViewCube;
    var Cube = /** @class */ (function () {
        function Cube(obj, defaultCubeViewId) {
            this.obj = obj;
            this.defaultCubeViewId = defaultCubeViewId;
            this.cubeFields = new Collections.List();
            this.allCubeViews = new Collections.List();
        }
        return Cube;
    }());
    Model.Cube = Cube;
    var CubeField = /** @class */ (function () {
        function CubeField(cube, cubeFieldId) {
            this.cube = cube;
            this.cubeFieldId = cubeFieldId;
        }
        return CubeField;
    }());
    Model.CubeField = CubeField;
    var CubeView = /** @class */ (function () {
        function CubeView(cube, cubeViewId) {
            this.cube = cube;
            this.cubeViewId = cubeViewId;
            this.cubeViewFields = new Collections.List();
        }
        return CubeView;
    }());
    Model.CubeView = CubeView;
    var CubeViewField = /** @class */ (function () {
        function CubeViewField(cube, cubeView, cubeField) {
            this.cube = cube;
            this.cubeView = cubeView;
            this.cubeField = cubeField;
            this.conditionalLayouts = [];
        }
        return CubeViewField;
    }());
    Model.CubeViewField = CubeViewField;
    var CubeViewFieldConditionalLayout = /** @class */ (function () {
        function CubeViewFieldConditionalLayout(conditionalLayoutID) {
            this.conditionalLayoutID = conditionalLayoutID;
        }
        return CubeViewFieldConditionalLayout;
    }());
    Model.CubeViewFieldConditionalLayout = CubeViewFieldConditionalLayout;
    var CubeFieldType;
    (function (CubeFieldType) {
        CubeFieldType[CubeFieldType["Dimension"] = 0] = "Dimension";
        CubeFieldType[CubeFieldType["Measure"] = 1] = "Measure";
    })(CubeFieldType = Model.CubeFieldType || (Model.CubeFieldType = {}));
    var CubeArea;
    (function (CubeArea) {
        CubeArea[CubeArea["Data"] = 0] = "Data";
        CubeArea[CubeArea["Row"] = 1] = "Row";
        CubeArea[CubeArea["Column"] = 2] = "Column";
        CubeArea[CubeArea["Filter"] = 3] = "Filter";
        CubeArea[CubeArea["Menu"] = 4] = "Menu";
    })(CubeArea = Model.CubeArea || (Model.CubeArea = {}));
    var ChartType;
    (function (ChartType) {
        ChartType[ChartType["Area2D"] = 0] = "Area2D";
        ChartType[ChartType["AreaStacked2D"] = 1] = "AreaStacked2D";
        ChartType[ChartType["BarSideBySide2D"] = 3] = "BarSideBySide2D";
        ChartType[ChartType["BarStacked2D"] = 4] = "BarStacked2D";
        ChartType[ChartType["Line2D"] = 6] = "Line2D";
    })(ChartType = Model.ChartType || (Model.ChartType = {}));
    // #Region Translation
    var TranslKeys = /** @class */ (function () {
        function TranslKeys() {
        }
        TranslKeys.user = "user";
        TranslKeys.password = "password";
        TranslKeys.login = "login";
        TranslKeys.logout = "logout";
        TranslKeys.noUser = "nouser";
        TranslKeys.noUpdateDateAvailable = "no_update_date";
        TranslKeys.loginFail = "login_fail";
        TranslKeys.loginFailPasswordExpired = "login_fail_password_expired";
        TranslKeys.loginError = "login_error";
        TranslKeys.DBDiskFullError = "db_disk_full_error";
        TranslKeys.serverInvalidResponse = "server_invalid_response";
        TranslKeys.staySignedIn = "stay_signed_in";
        TranslKeys.staySignedInNotAllowed = "stay_signed_in_not_allowed";
        TranslKeys.forgotPassword = "forgot_password";
        TranslKeys.resetPassword = "reset_password";
        TranslKeys.gui_already_running = "gui_already_running";
        TranslKeys.gui_version_invalid = "gui_version_invalid";
        TranslKeys.error_unsupported_meta_version = "error_unsupported_meta_version";
        TranslKeys.auth_expired_title = "auth_expired_title";
        TranslKeys.auth_expired_message = "auth_expired_message";
        TranslKeys.offlineChangesSwitchingUser = "offline_changes_switching_user";
        TranslKeys.errorOpeningDatabase = "error_opening_database";
        TranslKeys.insufficientSpaceAvailable = "insufficient_space_available";
        TranslKeys.errorDialogTitle = "error_dialog_title";
        TranslKeys.errorDialogMessage = "error_dialog_message";
        TranslKeys.errorConvertingDatatypeTitle = "error_converting_datatype_title";
        TranslKeys.errorConvertingDatatypeMessage = "error_converting_datatype_message";
        TranslKeys.applications = "applications";
        TranslKeys.loadingApplication = "loading_application";
        TranslKeys.noApplications = "no_application";
        TranslKeys.noServerConnection = "noServerConnection";
        TranslKeys.applicationNotAvailable = "application_not_available";
        TranslKeys.connection = "connection";
        TranslKeys.synchronize = "synchronize";
        TranslKeys.synclog = "synclog";
        TranslKeys.syncDirectly = "syncDirectly";
        TranslKeys.forceOfflineLogic = "forceofflinelogic";
        TranslKeys.clearCache = "clearCache";
        TranslKeys.refreshObjectModel = "refreshObjectModel";
        TranslKeys.synchronizeFailedTitle = "synchronizeFailed";
        TranslKeys.errorDuringSynchronization = "error_during_sync";
        TranslKeys.sync_finished = "sync_success";
        TranslKeys.sync_group_tables = "sync_group_tables";
        TranslKeys.sync_objects_failed = "sync_objects_failed";
        TranslKeys.saveDisabledByLayout = "save_disabled_by_layout";
        TranslKeys.deviceOffline = "device_offline";
        TranslKeys.clearQueueMessage = "clear_queue_message";
        TranslKeys.invalidParentContext = "invalid_parent_context";
        TranslKeys.maintenance = "maintenance";
        TranslKeys.settings = "settings";
        TranslKeys.offlineQueue = "offlineQueue";
        TranslKeys.forceOffline = "forceOffline";
        TranslKeys.syncData = "synchronizeData";
        TranslKeys.downloading = "downloading";
        TranslKeys.changePassword = "change_password";
        TranslKeys.changingPasswordNotPossible = "changing_password_not_possible";
        TranslKeys.currentPassword = "current_password";
        TranslKeys.newPassword = "new_password";
        TranslKeys.repeatNewPassword = "repeat_new_password";
        TranslKeys.passwordsMismatch = "passwords_mismatch";
        TranslKeys.newPasswordIsTheSame = "new_password_is_the_same";
        TranslKeys.requestPasswordReset = "request_password_reset";
        TranslKeys.passwordChanged = "password_changed";
        TranslKeys.resetToken = "reset_token";
        TranslKeys.resetTokenSent = "reset_token_sent";
        TranslKeys.resetTokenIncorrect = "reset_token_incorrect";
        TranslKeys.cantFindFile = "cant_load_file";
        TranslKeys.noResultsAvailable = "no_results_available";
        TranslKeys.networkError = "network_error";
        TranslKeys.unknownError = "unknown_error";
        TranslKeys.moreItemsAvailable = "more_items_available";
        TranslKeys.enterSearchTerm = "enter_search_term";
        TranslKeys.save = "save";
        TranslKeys.cancel = "cancel";
        TranslKeys.edit = "edit";
        TranslKeys.copy = "copy";
        TranslKeys.add = "add";
        TranslKeys.Delete = "delete";
        TranslKeys.ok = "ok";
        TranslKeys.yes = "yes";
        TranslKeys.no = "no";
        TranslKeys.clearQueue = "clearQueue";
        TranslKeys.connectionRestablished = "connectionReestablished";
        TranslKeys.download = "download";
        TranslKeys.downloadFiles = "downloadFiles";
        TranslKeys.emptyMandatoryField = "emptyMandatoryField";
        TranslKeys.emptyFileError = "emptyFileError";
        TranslKeys.execute = "execute";
        TranslKeys.metasource = "metasource";
        TranslKeys.metaserverUrl = "metaserver_url";
        TranslKeys.serverUrl = "server_url";
        TranslKeys.project = "project";
        TranslKeys.projectVrs = "projectVrs";
        TranslKeys.configuration = "configuration";
        TranslKeys.version = "version";
        TranslKeys.back = "back";
        TranslKeys.refresh = "refresh";
        TranslKeys.filters = "filters";
        TranslKeys.details = "details";
        TranslKeys.cubeViews = "cubeViews";
        TranslKeys.graph = "graph";
        TranslKeys.cube = "table";
        TranslKeys.combinedFilter = "combined_filter";
        TranslKeys.detailsTabPage = "details_tab_page";
        TranslKeys.taskSubmenu = "tasksubmenu";
        TranslKeys.reportSubmenu = "reportsubmenu";
        TranslKeys.prefilterSubmenu = "prefiltersubmenu";
        TranslKeys.noContextItems = "nocontextitems";
        TranslKeys.refreshObjectModelQuestion = "refreshObjectModelQuestion";
        TranslKeys.amountOfOfflineChangesLost = "amountOfOfflineChangesLost";
        TranslKeys.waitingForSynchronisation = "waitingForSynchronisation";
        TranslKeys.taskConfirmQuestion = "taskConfirmQuestion";
        TranslKeys.noNumericValue = "noNumericValue";
        TranslKeys.noNumericValue1 = "noNumericValue1";
        TranslKeys.rangeUnderflow = "rangeUnderflow";
        TranslKeys.rangeOverflow = "rangeOverflow";
        TranslKeys.valueTooLong = "valueTooLong";
        TranslKeys.syncErrorDuringSynchronization = "sync_error_during_synchronization";
        TranslKeys.syncErrorRowNotFound = "sync_error_row_not_found";
        TranslKeys.syncErrorDeleteRow = "sync_error_delete_row";
        TranslKeys.syncErrorSaveRow = "sync_error_save_row";
        TranslKeys.syncErrorDefault = "sync_error_default";
        TranslKeys.syncErrorLayout = "sync_error_layout";
        TranslKeys.moreInfo = "more_info";
        TranslKeys.two_factor_verify_login = "Verify login";
        TranslKeys.two_factor_setup_totp = "Setup login verification";
        TranslKeys.two_factor_validation_code = "two_factor_validationcode";
        TranslKeys.two_factor_authenticator_code = "two_factor_authenticator_code";
        TranslKeys.two_factor_validation_code_sent = "two_factor_validation_code_sent";
        TranslKeys.submit_two_factor_validation_code = "submit_two_factor_validation_code";
        TranslKeys.two_factor_totp_setup_explanation = "two_factor_totp_setup_explanation";
        TranslKeys.two_factor_totp_fallback = "two_factor_totp_fallback";
        TranslKeys.two_factor_totp_administrator = "two_factor_totp_administrator";
        TranslKeys.two_factor_email_fallback = "two_factor_email_fallback";
        TranslKeys.two_factor_email_fallback_action = "two_factor_email_fallback_action";
        TranslKeys.two_factor_email_fallback_change_device = "two_factor_email_fallback_change_device";
        // SF supported translations
        TranslKeys.confirmationCancel = "confirmation_cancel";
        TranslKeys.confirmationDeleteRow = "confirmation_delete_row";
        TranslKeys.grand_total = "grand_total";
        TranslKeys.sessionInactivityTitle = "session_inactivity_title";
        TranslKeys.sessionInactivityMessage = "session_inactivity_message";
        TranslKeys.gui_process_action_confirm_start = "gui_process_action_confirm_start";
        TranslKeys.gui_nocurrentrow = "gui_nocurrentrow";
        TranslKeys.two_factor_codeinvalid = "two_factor_codeinvalid";
        TranslKeys.select = "select";
        // Indicium messages
        TranslKeys.application_model_expired = "application_model_expired";
        return TranslKeys;
    }());
    Model.TranslKeys = TranslKeys;
    var Language = /** @class */ (function () {
        function Language(code) {
            this.code = code;
            this.translations = {};
            this.LoadDefaultTransls();
            this.globalization = Model.Globalization.detectGlobalization(code);
        }
        Language.prototype.transl = function (key) {
            var translation = this.translations[key];
            if (!translation) {
                return "[" + key + "]";
            }
            return translation;
        };
        Language.prototype.LoadDefaultTransls = function () {
            var language = this.code.toLowerCase();
            if (language == "nl") {
                this.loadDefaultNLTranslations();
            }
            else if (language == "eng" || language == "en-gb") {
                this.loadDefaultEngTranslations();
            }
        };
        Language.prototype.loadDefaultNLTranslations = function () {
            var transls = this.translations;
            transls[TranslKeys.user] = "Gebruiker";
            transls[TranslKeys.password] = "Wachtwoord";
            transls[TranslKeys.login] = "Inloggen";
            transls[TranslKeys.logout] = "Uitloggen";
            transls[TranslKeys.noUser] = "Er is geen gebruiker ingevuld.";
            transls[TranslKeys.noUpdateDateAvailable] = "geen gegevens bekend.";
            transls[TranslKeys.loginFail] = "De gebruikersnaam en wachtwoord combinatie is onjuist.";
            transls[TranslKeys.loginFailPasswordExpired] = "Uw wachtwoord is verlopen, verander uw wachtwoord om door te gaan.";
            transls[TranslKeys.loginError] = "Er is een fout opgetreden tijdens het inloggen.";
            transls[TranslKeys.DBDiskFullError] = "Het apparaat heeft te weinig ruimte, probeer wat ruimte vrij te maken.";
            transls[TranslKeys.serverInvalidResponse] = "De server gaf een onverwacht resultaat: status code [status_code]";
            transls[TranslKeys.staySignedIn] = "Ingelogd blijven";
            transls[TranslKeys.staySignedInNotAllowed] = "U mag niet ingelogd blijven omdat uw apparaat geen schermbeveiliging heeft.";
            transls[TranslKeys.forgotPassword] = "Wachtwoord vergeten?";
            transls[TranslKeys.resetPassword] = "Wachtwoord resetten";
            transls[TranslKeys.gui_already_running] = "Database kon niet geopend worden. Controleer of de applicatie niet al geopend is.";
            transls[TranslKeys.gui_version_invalid] = "Er is een nieuwe versie van de app beschikbaar.";
            transls[TranslKeys.error_unsupported_meta_version] = "Deze versie van de gebruikersinterface wordt niet ondersteund. Neem contact op met uw applicatiebeheerder.";
            transls[TranslKeys.auth_expired_title] = "Authenticatie verlopen";
            transls[TranslKeys.auth_expired_message] = "Uw authenticatie is door langdurig offline werken verlopen. U kunt offline verder werken, maar zal opnieuw in moeten loggen om uw wijzigingen te synchroniseren.";
            transls[TranslKeys.offlineChangesSwitchingUser] = "Er zijn openstaande wijzigingen voor gebruiker [user]. Deze wijzigingen raken verloren. Wilt u doorgaan?";
            transls[TranslKeys.errorOpeningDatabase] = "Fout bij het openen van de database [db_name]";
            transls[TranslKeys.insufficientSpaceAvailable] = "Onvoldoende schijfruimte beschikbaar";
            transls[TranslKeys.errorDialogTitle] = "Er is iets fout gegaan.";
            transls[TranslKeys.errorDialogMessage] = "Ons team is op de hoogte gesteld.\r\n\r\nError code: ";
            transls[TranslKeys.errorConvertingDatatypeTitle] = "Het converteren naar een datatype ging fout.";
            transls[TranslKeys.errorConvertingDatatypeMessage] = "Het lukte niet om de waarde [value] van kolom [column] om te zetten naar een [datatype].";
            transls[TranslKeys.applications] = "Applicaties";
            transls[TranslKeys.loadingApplication] = "Applicatie laden";
            transls[TranslKeys.noApplications] = "Er zijn geen applicaties beschikbaar.";
            transls[TranslKeys.noServerConnection] = "Er kan geen verbinding met de server worden gemaakt.";
            transls[TranslKeys.applicationNotAvailable] = "Deze applicatie is niet beschikbaar op dit moment";
            transls[TranslKeys.synchronize] = "Synchroniseren";
            transls[TranslKeys.synclog] = "Synchronisatie log";
            transls[TranslKeys.connection] = "Connectie";
            transls[TranslKeys.syncDirectly] = "Direct synchroniseren";
            transls[TranslKeys.forceOfflineLogic] = "Standaard offline logica";
            transls[TranslKeys.clearCache] = "Cache verwijderen";
            transls[TranslKeys.synchronizeFailedTitle] = "Synchronisatie mislukt";
            transls[TranslKeys.errorDuringSynchronization] = "Er is een fout opgetreden tijdens het synchroniseren.";
            transls[TranslKeys.sync_finished] = "Gesynchroniseerd op";
            transls[TranslKeys.sync_group_tables] = "Objecten in deze groep";
            transls[TranslKeys.sync_objects_failed] = "De volgende objecten zijn mislukt:";
            transls[TranslKeys.saveDisabledByLayout] = "Opslaan is uitgeschakeld door een layout.";
            transls[TranslKeys.deviceOffline] = "Uw apparaat is momenteel offline.";
            transls[TranslKeys.clearQueueMessage] = "Let op: hiermee verwijdert u ook de offline opgeslagen gegevens.";
            transls[TranslKeys.invalidParentContext] = "De context waarin u werkt is ongeldig geworden.";
            transls[TranslKeys.refreshObjectModel] = "Model verversen";
            transls[TranslKeys.refreshObjectModelQuestion] = "Weet u zeker dat u het model wilt verversen?";
            transls[TranslKeys.amountOfOfflineChangesLost] = "[unsyncedAmount] openstaande offline wijzigingen raken verloren.";
            transls[TranslKeys.waitingForSynchronisation] = "Wachten op synchroniseren.";
            transls[TranslKeys.settings] = "Opties";
            transls[TranslKeys.maintenance] = "Onderhoud";
            transls[TranslKeys.offlineQueue] = "Offline wijzigingen";
            transls[TranslKeys.forceOffline] = "Forceer offline modus";
            transls[TranslKeys.syncData] = "Gegevens synchroniseren";
            transls[TranslKeys.downloading] = "Downloaden";
            transls[TranslKeys.changePassword] = "Wachtwoord veranderen";
            transls[TranslKeys.changingPasswordNotPossible] = "U kunt uw wachtwoord niet veranderen.\r\nNeem contact op met uw applicatiebeheerder om uw wachtwoord te veranderen.";
            transls[TranslKeys.currentPassword] = "Huidig wachtwoord";
            transls[TranslKeys.newPassword] = "Nieuw wachtwoord";
            transls[TranslKeys.repeatNewPassword] = "Herhaal nieuw wachtwoord";
            transls[TranslKeys.passwordsMismatch] = "Het nieuwe en herhaalde wachtwoord komen niet overeen.";
            transls[TranslKeys.newPasswordIsTheSame] = "Uw nieuwe wachtwoord moet afwijken van het huidige wachtwoord.";
            transls[TranslKeys.requestPasswordReset] = "Vraag wachtwoord reset aan";
            transls[TranslKeys.passwordChanged] = "Uw wachtwoord is veranderd.";
            transls[TranslKeys.resetToken] = "Reset code";
            transls[TranslKeys.resetTokenSent] = "Een wachtwoord reset code is verstuurd naar uw email adres.";
            transls[TranslKeys.resetTokenIncorrect] = "De gegeven wachtwoord reset code is incorrect.";
            transls[TranslKeys.cantFindFile] = "Het opgegeven bestand kan niet gevonden worden.";
            transls[TranslKeys.noResultsAvailable] = "Geen resultaten beschikbaar.";
            transls[TranslKeys.unknownError] = "Er is een onbekende fout opgetreden.";
            transls[TranslKeys.networkError] = "Er is een netwerk fout opgetreden.";
            transls[TranslKeys.moreItemsAvailable] = "Meer resultaten beschikbaar...";
            transls[TranslKeys.enterSearchTerm] = "Vul uw zoekterm in";
            // TODO: returned by GetGuiTranslations
            transls[TranslKeys.save] = "Opslaan";
            transls[TranslKeys.cancel] = "Annuleren";
            transls[TranslKeys.edit] = "Wijzigen";
            transls[TranslKeys.copy] = "Kopiëren";
            transls[TranslKeys.add] = "Toevoegen";
            transls[TranslKeys.Delete] = "Verwijderen";
            transls[TranslKeys.ok] = "OK";
            transls[TranslKeys.yes] = "Ja";
            transls[TranslKeys.no] = "Nee";
            transls[TranslKeys.clearQueue] = "Verwijder wijzigingen";
            transls[TranslKeys.connectionRestablished] = "Verbinding hersteld";
            transls[TranslKeys.download] = "Download";
            transls[TranslKeys.downloadFiles] = "Bestanden downloaden";
            transls[TranslKeys.emptyMandatoryField] = "Het verplichte veld: [objProp] is niet ingevuld.";
            transls[TranslKeys.emptyFileError] = "Lege bestanden uploaden wordt niet ondersteund.";
            transls[TranslKeys.back] = "Terug";
            transls[TranslKeys.refresh] = "Verversen";
            transls[TranslKeys.filters] = "Filters";
            transls[TranslKeys.details] = "Details";
            transls[TranslKeys.cubeViews] = "Kubus weergaves";
            transls[TranslKeys.graph] = "Grafiek";
            transls[TranslKeys.cube] = "Kubus";
            transls[TranslKeys.execute] = "Uitvoeren";
            transls[TranslKeys.metasource] = "Meta-bron";
            transls[TranslKeys.metaserverUrl] = "Meta server url";
            transls[TranslKeys.serverUrl] = "Server url";
            transls[TranslKeys.project] = "Project";
            transls[TranslKeys.projectVrs] = "Project versie";
            transls[TranslKeys.configuration] = "Configuratie";
            transls[TranslKeys.version] = "Versie";
            transls[TranslKeys.combinedFilter] = "Filter";
            transls[TranslKeys.detailsTabPage] = "Details";
            transls[TranslKeys.taskSubmenu] = "Taken";
            transls[TranslKeys.reportSubmenu] = "Rapporten";
            transls[TranslKeys.prefilterSubmenu] = "Prefilters";
            transls[TranslKeys.noContextItems] = "Er zijn geen details, taken of rapporten beschikbaar.";
            transls[TranslKeys.taskConfirmQuestion] = "Wilt u de taak: [taskTransl] uitvoeren?";
            transls[TranslKeys.noNumericValue] = "De ingevulde waarde is geen valide numerieke waarde.";
            transls[TranslKeys.noNumericValue1] = "De ingevulde waarde ([value]) is geen valide numerieke waarde.";
            transls[TranslKeys.rangeOverflow] = "De ingevulde waarde is groter dan de maximum waarde: [maxValue].";
            transls[TranslKeys.rangeUnderflow] = "De ingevulde waarde is kleiner dan de minimum waarde: [minValue].";
            transls[TranslKeys.valueTooLong] = "De ingevulde waarde ([value]) is langer dan toegestaan ([length] karakters).";
            transls[TranslKeys.syncErrorDuringSynchronization] = "Er zijn fouten opgetreden bij het synchronizeren met de server. Probeer later opnieuw te synchroniseren of verwijder de rijen die conflicteren om door te gaan.";
            transls[TranslKeys.syncErrorRowNotFound] = "Rij kon niet gevonden worden op de server";
            transls[TranslKeys.syncErrorDeleteRow] = "Fout bij het verwijderen van de rij";
            transls[TranslKeys.syncErrorSaveRow] = "Fout bij het opslaan van de rij";
            transls[TranslKeys.syncErrorDefault] = "Fout bij uitvoeren 'default' logica";
            transls[TranslKeys.syncErrorLayout] = "Fout bij uitvoeren 'layout' logica";
            transls[TranslKeys.moreInfo] = "Meer informatie";
            transls[TranslKeys.sessionInactivityTitle] = "Sessie inactief";
            transls[TranslKeys.sessionInactivityMessage] = "De sessie zal verlopen door inactiviteit.\r\n\r\nDruk op \"OK\" om door te gaan.";
            transls[TranslKeys.two_factor_verify_login] = "Verifieer login";
            transls[TranslKeys.two_factor_setup_totp] = "Stel login verificatie in";
            transls[TranslKeys.two_factor_validation_code] = "Validatiecode";
            transls[TranslKeys.two_factor_authenticator_code] = "6-cijferige authenticatie code";
            transls[TranslKeys.two_factor_validation_code_sent] = "Validatiecode is verstuurd";
            transls[TranslKeys.submit_two_factor_validation_code] = "Validatiecode indienen";
            transls[TranslKeys.two_factor_totp_setup_explanation] = "Scan de onderstaande afbeelding met de authenticator app op uw apparaat om login verificatie op te zetten.\r\n" +
                "Indien u geen QR code kunt gebruiken, kunt u de tekst code kopiëren en gebruiken.";
            transls[TranslKeys.two_factor_totp_fallback] = "Is het apparaat dat u gebruikt voor authenticatie niet beschikbaar?\r\n" +
                "U kunt ook inloggen met email en login verificatie opnieuw instellen.";
            transls[TranslKeys.two_factor_totp_administrator] = "Is het apparaat dat u gebruikt voor authenticatie niet beschikbaar?\r\n" +
                "Neem contact op met uw applicatiebeheerder om login verificatie opnieuw in te stellen.";
            transls[TranslKeys.two_factor_email_fallback] = "Inloggen met email";
            transls[TranslKeys.two_factor_email_fallback_action] = "Wilt u inloggen of het login verificatie apparaat veranderen?";
            transls[TranslKeys.two_factor_email_fallback_change_device] = "Verander apparaat";
            // Tmp translation; is overwritten by the SF but it might not be available there just yet
            transls[TranslKeys.two_factor_codeinvalid] = "Het valideren van de code is mislukt. Probeer het opnieuw of ga terug naar de login pagina om een nieuwe code aan te vragen.";
            // Indicium message
            transls[TranslKeys.application_model_expired] = "Deze applicatie is op de achtergrond bijgewerkt. Log opnieuw in om een correcte werking te garanderen.";
            jQuery.mobile.flipswitch.prototype.options.onText = "Aan";
            jQuery.mobile.flipswitch.prototype.options.offText = "Uit";
        };
        Language.prototype.loadDefaultEngTranslations = function () {
            var transls = this.translations;
            transls[TranslKeys.user] = "Username";
            transls[TranslKeys.password] = "Password";
            transls[TranslKeys.login] = "Login";
            transls[TranslKeys.logout] = "Logout";
            transls[TranslKeys.noUser] = "No username has been entered.";
            transls[TranslKeys.noUpdateDateAvailable] = "no information available.";
            transls[TranslKeys.loginFail] = "The username and password combination is incorrect.";
            transls[TranslKeys.loginFailPasswordExpired] = "Your password has expired, please change your password to continue.";
            transls[TranslKeys.loginError] = "An error occured during the login.";
            transls[TranslKeys.DBDiskFullError] = "This device doesn't have enough disk space, please free up some space.";
            transls[TranslKeys.serverInvalidResponse] = "The server returned an unexpected result: status code [status_code]";
            transls[TranslKeys.staySignedIn] = "Stay signed in";
            transls[TranslKeys.staySignedInNotAllowed] = "You aren't allowed to stay signed in because your device doesn't have a screenlock.";
            transls[TranslKeys.forgotPassword] = "Forgot password?";
            transls[TranslKeys.resetPassword] = "Password reset";
            transls[TranslKeys.gui_already_running] = "Database could not be opened. Make sure the application is not already open.";
            transls[TranslKeys.gui_version_invalid] = "A new version of the app is available.";
            transls[TranslKeys.error_unsupported_meta_version] = "This version of the user interface is not supported. Please contact your system administrator.";
            transls[TranslKeys.auth_expired_title] = "Authentication expired";
            transls[TranslKeys.auth_expired_message] = "Your authentication has expired due to working offline for too long. You can continue to work offline, but you will have to sign in again to synchronise your changes.";
            transls[TranslKeys.offlineChangesSwitchingUser] = "There are offline changes available for user [user]. These changes will be removed. Do you want to continue?";
            transls[TranslKeys.errorOpeningDatabase] = "Error while opening database [db_name]";
            transls[TranslKeys.insufficientSpaceAvailable] = "Insufficient space available";
            transls[TranslKeys.errorDialogTitle] = "It looks like we're having some issues.";
            transls[TranslKeys.errorDialogMessage] = "Our team has been notified.\r\n\r\nError code: ";
            transls[TranslKeys.errorConvertingDatatypeTitle] = "Error converting to a datatype.";
            transls[TranslKeys.errorConvertingDatatypeMessage] = "An error occurred while converting [value] of column [column] to a [datatype].";
            transls[TranslKeys.applications] = "Applications";
            transls[TranslKeys.loadingApplication] = "Loading application";
            transls[TranslKeys.noApplications] = "There are no applications available.";
            transls[TranslKeys.noServerConnection] = "Unable to connect with the server.";
            transls[TranslKeys.applicationNotAvailable] = "Application not available at this time.";
            transls[TranslKeys.synchronize] = "Synchronize";
            transls[TranslKeys.synclog] = "Synchronize log";
            transls[TranslKeys.connection] = "Connection";
            transls[TranslKeys.syncDirectly] = "Synchronize Directly";
            transls[TranslKeys.forceOfflineLogic] = "Default offline logic";
            transls[TranslKeys.clearCache] = "Clear cache";
            transls[TranslKeys.synchronizeFailedTitle] = "Synchronization failed";
            transls[TranslKeys.errorDuringSynchronization] = "An error occurred during synchronization.";
            transls[TranslKeys.sync_finished] = "Synchronized on";
            transls[TranslKeys.sync_group_tables] = "Objects in this group";
            transls[TranslKeys.sync_objects_failed] = "The following objects failed:";
            transls[TranslKeys.saveDisabledByLayout] = "Save disabled by a layout.";
            transls[TranslKeys.deviceOffline] = "Your device is currently offline.";
            transls[TranslKeys.clearQueueMessage] = "Note: this will also remove the offline stored data.";
            transls[TranslKeys.invalidParentContext] = "Your current working context has become invalid.";
            transls[TranslKeys.refreshObjectModel] = "Refresh model";
            transls[TranslKeys.refreshObjectModelQuestion] = "Are you sure you want to reload the model?";
            transls[TranslKeys.amountOfOfflineChangesLost] = "[unsyncedAmount] pending offline change(s) will be lost.";
            transls[TranslKeys.waitingForSynchronisation] = "Waiting for synchronisation.";
            transls[TranslKeys.settings] = "Settings";
            transls[TranslKeys.maintenance] = "Maintenance";
            transls[TranslKeys.offlineQueue] = "Offline changes";
            transls[TranslKeys.forceOffline] = "Force offline mode";
            transls[TranslKeys.syncData] = "Synchronise data";
            transls[TranslKeys.downloading] = "Downloading";
            transls[TranslKeys.changePassword] = "Change password";
            transls[TranslKeys.changingPasswordNotPossible] = "You can't change your password.\r\nPlease contact your system administrator to change your password.";
            transls[TranslKeys.currentPassword] = "Current password";
            transls[TranslKeys.newPassword] = "New password";
            transls[TranslKeys.repeatNewPassword] = "Repeat new password";
            transls[TranslKeys.passwordsMismatch] = "The new and repeated passwords don't match.";
            transls[TranslKeys.newPasswordIsTheSame] = "Your new password must be different from your current password.";
            transls[TranslKeys.requestPasswordReset] = "Request password reset";
            transls[TranslKeys.passwordChanged] = "Your password has been changed.";
            transls[TranslKeys.resetToken] = "Reset token";
            transls[TranslKeys.resetTokenSent] = "A password reset token has been sent to your email address.";
            transls[TranslKeys.resetTokenIncorrect] = "The supplied password reset token is incorrect.";
            transls[TranslKeys.cantFindFile] = "The given file can't be found.";
            transls[TranslKeys.noResultsAvailable] = "No results available.";
            transls[TranslKeys.unknownError] = "An unknown error occured";
            transls[TranslKeys.networkError] = "A network error occured";
            transls[TranslKeys.moreItemsAvailable] = "More results available...";
            transls[TranslKeys.enterSearchTerm] = "Enter your search query";
            // TODO: returned by GetGuiTranslations
            transls[TranslKeys.save] = "Save";
            transls[TranslKeys.cancel] = "Cancel";
            transls[TranslKeys.edit] = "Edit";
            transls[TranslKeys.copy] = "Copy";
            transls[TranslKeys.add] = "Add";
            transls[TranslKeys.Delete] = "Delete";
            transls[TranslKeys.ok] = "OK";
            transls[TranslKeys.yes] = "Yes";
            transls[TranslKeys.no] = "No";
            transls[TranslKeys.clearQueue] = "Clear changes";
            transls[TranslKeys.connectionRestablished] = "Connection reestablished";
            transls[TranslKeys.download] = "Download";
            transls[TranslKeys.downloadFiles] = "Download files";
            transls[TranslKeys.emptyMandatoryField] = "The mandatory field: [objProp] is empty";
            transls[TranslKeys.emptyFileError] = "Uploading empty files is not supported.";
            transls[TranslKeys.back] = "Back";
            transls[TranslKeys.refresh] = "Refresh";
            transls[TranslKeys.filters] = "Filters";
            transls[TranslKeys.details] = "Details";
            transls[TranslKeys.cubeViews] = "Cube views";
            transls[TranslKeys.graph] = "Graph";
            transls[TranslKeys.cube] = "Cube";
            transls[TranslKeys.execute] = "Execute";
            transls[TranslKeys.metasource] = "Metasource";
            transls[TranslKeys.metaserverUrl] = "Meta server url";
            transls[TranslKeys.serverUrl] = "Server url";
            transls[TranslKeys.project] = "Project";
            transls[TranslKeys.projectVrs] = "Project version";
            transls[TranslKeys.configuration] = "Configuration";
            transls[TranslKeys.version] = "Version";
            transls[TranslKeys.combinedFilter] = "Filter";
            transls[TranslKeys.detailsTabPage] = "Details";
            transls[TranslKeys.taskSubmenu] = "Tasks";
            transls[TranslKeys.reportSubmenu] = "Reports";
            transls[TranslKeys.prefilterSubmenu] = "Prefilters";
            transls[TranslKeys.noContextItems] = "There are no details, tasks or reports available.";
            transls[TranslKeys.taskConfirmQuestion] = "Do you want to execute the task: [taskTransl]?";
            transls[TranslKeys.noNumericValue] = "The value isn't a valid numeric value.";
            transls[TranslKeys.noNumericValue1] = "The value ([value]) isn't a valid numeric value.";
            transls[TranslKeys.rangeOverflow] = "The value exceeds the maximum value: [maxValue].";
            transls[TranslKeys.rangeUnderflow] = "The value exceeds the minimum value: [minValue].";
            transls[TranslKeys.valueTooLong] = "De ingevulde waarde ([value]) is langer dan toegestaan ([length] karakters).";
            transls[TranslKeys.syncErrorDuringSynchronization] = "There where errors during the synchronization with the server. Try syncing again later in case of network errors or delete the conflicted rows to continue.";
            transls[TranslKeys.syncErrorRowNotFound] = "Row could not be found on the server";
            transls[TranslKeys.syncErrorDeleteRow] = "Error deleting row";
            transls[TranslKeys.syncErrorSaveRow] = "Error saving row";
            transls[TranslKeys.syncErrorDefault] = "Error executing 'default' logic";
            transls[TranslKeys.syncErrorLayout] = "Error executing 'layout' logic";
            transls[TranslKeys.moreInfo] = "More info";
            transls[TranslKeys.sessionInactivityTitle] = "Session inactivity";
            transls[TranslKeys.sessionInactivityMessage] = "The session will expire due to inactivity.\r\n\r\nPress \"OK\" to continue.";
            transls[TranslKeys.two_factor_verify_login] = "Verify login";
            transls[TranslKeys.two_factor_setup_totp] = "Setup login verification";
            transls[TranslKeys.two_factor_validation_code] = "Validation code";
            transls[TranslKeys.two_factor_authenticator_code] = "6-digit authentication code";
            transls[TranslKeys.two_factor_validation_code_sent] = "Validation code has been sent";
            transls[TranslKeys.submit_two_factor_validation_code] = "Submit validation code";
            transls[TranslKeys.two_factor_totp_setup_explanation] = "To setup login verification, scan the image below with the authenticator app on your device.\r\n" +
                "If you can’t use a QR code, copy and enter the text code instead.";
            transls[TranslKeys.two_factor_totp_fallback] = "Is the device you use for authenticating not available?\r\n" +
                "You can also login using email and reconfigure your login verification.";
            transls[TranslKeys.two_factor_totp_administrator] = "Is the device you use for authenticating not available?\r\n" +
                "Please contact your application administrator to reconfigure your login verification.";
            transls[TranslKeys.two_factor_email_fallback] = "Login using email";
            transls[TranslKeys.two_factor_email_fallback_action] = "Do you want to login or change the login verification device?";
            transls[TranslKeys.two_factor_email_fallback_change_device] = "Change device";
            // Tmp translation; is overwritten by the SF but it might not be available there just yet
            transls[TranslKeys.two_factor_codeinvalid] = "Validation failed. Try again or return to the login page to receive a new code.";
            // Indicium message
            transls[TranslKeys.application_model_expired] = "The application is outdated, please sign in again to avoid issues.";
        };
        Language.initializeStaticTranslations = function (language) {
            jQuery.mobile.listview.prototype.options.filterPlaceholder = language.transl(Model.TranslKeys.combinedFilter);
        };
        return Language;
    }());
    Model.Language = Language;
    // #EndRegion
    // #Region Misc
    var ActionGroup = /** @class */ (function () {
        function ActionGroup() {
        }
        return ActionGroup;
    }());
    Model.ActionGroup = ActionGroup;
    // #EndRegion
    // #Region ExtendedProperties
    var ExtendedProperties = /** @class */ (function () {
        function ExtendedProperties() {
            this.propertiesList = {};
        }
        ExtendedProperties.prototype.setExtendedProperty = function (key, value) {
            this.propertiesList[key] = value;
        };
        ExtendedProperties.prototype.downloadFiles = function () {
            return __awaiter(this, void 0, void 0, function () {
                var configuredDownloadFiles;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AppConfig.getDownloadFiles()];
                        case 1:
                            configuredDownloadFiles = _a.sent();
                            if (this.propertiesList["downloadFiles"] !== undefined) {
                                return [2 /*return*/, Promise.resolve(Utils.convertToBoolean(this.propertiesList["downloadFiles"], configuredDownloadFiles))];
                            }
                            return [2 /*return*/, configuredDownloadFiles];
                    }
                });
            });
        };
        Object.defineProperty(ExtendedProperties.prototype, "defaultAuthenticationTimeout", {
            get: function () {
                if (this.propertiesList["defaultAuthenticationTimeout"] != undefined)
                    return Number(this.propertiesList["defaultAuthenticationTimeout"]);
                return AppConfig.defaultAuthenticationTimeout;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedProperties.prototype, "defaultRequestTimeout", {
            get: function () {
                if (this.propertiesList["defaultRequestTimeout"] != undefined)
                    return Number(this.propertiesList["defaultRequestTimeout"]);
                return AppConfig.defaultRequestTimeout;
            },
            enumerable: true,
            configurable: true
        });
        ExtendedProperties.prototype.forceOfflineLogic = function () {
            return __awaiter(this, void 0, void 0, function () {
                var configuredForceOfflineLogic;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, AppConfig.getForceOfflineLogic()];
                        case 1:
                            configuredForceOfflineLogic = _a.sent();
                            if (this.propertiesList["forceOfflineLogic"] !== undefined) {
                                return [2 /*return*/, Promise.resolve(Utils.convertToBoolean(this.propertiesList["forceOfflineLogic"], configuredForceOfflineLogic))];
                            }
                            return [2 /*return*/, Promise.resolve(configuredForceOfflineLogic)];
                    }
                });
            });
        };
        Object.defineProperty(ExtendedProperties.prototype, "pageSize", {
            get: function () {
                if (this.propertiesList["pageSize"] != undefined)
                    return Number(this.propertiesList["pageSize"]);
                return AppConfig.pageSize;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExtendedProperties.prototype, "showClearbuttons", {
            get: function () {
                if (this.propertiesList["showclearbuttons"] != undefined)
                    return Utils.convertToBoolean(this.propertiesList["showclearbuttons"], AppConfig.showClearbuttons);
                return AppConfig.showClearbuttons;
            },
            enumerable: true,
            configurable: true
        });
        return ExtendedProperties;
    }());
    Model.ExtendedProperties = ExtendedProperties;
    // #EndRegion
})(Model || (Model = {}));
