var RowHelper;
(function (RowHelper) {
    function copyValue(objProp, newValue, toRow) {
        if (objProp.isFileColumn) {
            var fileContract = newValue;
            // default cleared the file or it the new row was empty during a copy
            if (Utils.isEmpty(fileContract) || Utils.isEmpty(toRow[objProp.objPropId])) {
                toRow[objProp.objPropId] = fileContract;
            }
            else if (fileContract.HashCode !== toRow[objProp.objPropId].HashCode && fileContract.File) {
                // Fill the row
                toRow[objProp.objPropId] = newValue;
            }
        }
        else {
            toRow[objProp.objPropId] = newValue;
        }
    }
    RowHelper.copyValue = copyValue;
    function convertRowToWebserviceObject(obj, row, ignoreFileData, removeIdentity) {
        var newRow = {};
        var objProps = obj.objProps.array;
        for (var i = 0; i < objProps.length; i++) {
            var objProp = objProps[i], value = row[objProp.objPropId];
            if (removeIdentity && objProp.identity && !Utils.isEmpty(value) && (value + "").indexOf(IdentityReplacer.prefix) === 0) {
                // It is an identity so we should leave it empty.
            }
            else if (!Utils.isEmpty(value)) {
                if (objProp.isFileColumn && ignoreFileData) {
                    var fileContractCopy = FileContract.CreateFromFilePath(value.FilePath, undefined, undefined, undefined);
                    if (value.HashCode !== undefined) {
                        fileContractCopy.HashCode = value.HashCode;
                    }
                    newRow[objProp.objPropId] = fileContractCopy;
                }
                else {
                    newRow[objProp.objPropId] = Utils.convertToDataType(value, objProp.objPropId, objProp.dttpId);
                }
            }
        }
        return newRow;
    }
    RowHelper.convertRowToWebserviceObject = convertRowToWebserviceObject;
})(RowHelper || (RowHelper = {}));
