var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var TwoFactorValidation = /** @class */ (function () {
    function TwoFactorValidation(username, password, responseHeaders) {
        var _this = this;
        this.username = username;
        this.password = password;
        this.deferred = jQuery.Deferred();
        this.currentManager = Model.TSFApplicationManager.Current;
        this.twoFactorType = this.convertFromString(responseHeaders.TWOFA);
        this.supportedFallbacks = JSON.parse(responseHeaders.TWOFAFallbacks);
        var that = this;
        jQuery(document).one("pagebeforeshow", "#twoFactorValidation", function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        that.page = jQuery("#twoFactorValidation");
                        return [4 /*yield*/, that.initialize()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    }
    TwoFactorValidation.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var metaServiceURL, apiIndex, baseURL, color;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, AppConfig.getMetaServiceURL()];
                    case 1:
                        metaServiceURL = _a.sent();
                        apiIndex = metaServiceURL.indexOf("/api");
                        baseURL = metaServiceURL.substring(0, apiIndex + 1);
                        this.client = new OData.ODataClient(baseURL, this.username, this.password);
                        // Make sure that the height of the main div is set. Otherwise scrolling on iOS doesn't work.
                        Utils.fixScrolling(this.page);
                        this.form = this.page.find("form");
                        color = Utils.Color.hexToColor(this.page.find("a.back-button").css("color"));
                        Utils.SetIconBlackOrWhite(this.page.find("a.back-button"), color);
                        if (this.currentManager.activeAppl !== null) {
                            this.language = this.currentManager.activeAppl.language;
                        }
                        else {
                            this.language = AppConfig.language;
                        }
                        this.title = this.page.children("div[data-role='header']").children("h1");
                        this.title.text(this.language.transl(Model.TranslKeys.two_factor_verify_login));
                        this.form.find(".code-sent").text(this.language.transl(Model.TranslKeys.two_factor_validation_code_sent));
                        this.form.find(".validation-code-label").text(this.language.transl(Model.TranslKeys.two_factor_validation_code) + ":");
                        this.form.find(".submit-code-button").text(this.language.transl(Model.TranslKeys.submit_two_factor_validation_code));
                        if (this.twoFactorType === 2 /* Email */ ||
                            this.twoFactorType === 1 /* SMS */ ||
                            this.twoFactorType === 998 /* Pending */) {
                            this.initializeEmailAndSms(this.deferred);
                            this.form.show();
                        }
                        if (this.twoFactorType === 999 /* TOTPSetup */) {
                            this.initializeTOTPSetup();
                        }
                        if (this.twoFactorType === 3 /* TOTP */) {
                            this.initializeTOTP();
                            this.form.show();
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    TwoFactorValidation.prototype.initializeEmailAndSms = function (deferred, twoFactorType) {
        var _this = this;
        if (twoFactorType === void 0) { twoFactorType = null; }
        if (this.twoFactorType === 998 /* Pending */) {
            this.initializeTokenInput(deferred);
            this.form.find(".code-sent").show();
            return;
        }
        Utils.showLoader();
        this.client.invoke(OData.REQUEST_TWO_FACTOR_TOKEN, "GET", null, function (reader, status) {
            Utils.hideLoader();
            if (status.requestSuccess) {
                _this.initializeTokenInput(deferred);
                _this.form.find(".code-sent").show();
            }
        });
    };
    TwoFactorValidation.prototype.initializeTOTPSetup = function () {
        var _this = this;
        //Fix 'code sent' being shown when setting up after fallback.
        this.form.find(".code-sent").hide();
        this.title.text(this.language.transl(Model.TranslKeys.two_factor_setup_totp));
        Utils.showLoader();
        this.client.invoke("$requestTOTPKey", "GET", null, function (reader, status) {
            if (status.requestSuccess) {
                var TOTPKey = reader.item(0).getString("TOTPKey");
                _this.form.find("#setupTOTPArea").show();
                _this.form.find("#TOTPKey").val(TOTPKey);
                var issuer = encodeURI(AppConfig.appName);
                var username = encodeURI(_this.client.username);
                var TOTPURI = "otpauth://totp/" + issuer + ":" + username + "?secret=" + TOTPKey + "&issuer=" + issuer;
                new QRCode(document.getElementById("TOTPKeyQRCode"), {
                    text: TOTPURI,
                    width: 200,
                    height: 200
                });
                Utils.hideLoader();
                _this.form.show();
            }
        });
        this.form.find("#copyTOTPKeyButton").click(function () {
            var TOTPKeyInput = document.querySelector("#TOTPKey");
            if (Utils.isCordova()) {
                window["cordova"].plugins.clipboard.copy(TOTPKeyInput.value);
            }
            else {
                TOTPKeyInput.select();
                document.execCommand("Copy");
            }
        });
        this.form.find("#TOTPSetupExplanation").text(this.language.transl(Model.TranslKeys.two_factor_totp_setup_explanation));
        this.form.find("#copyTOTPKeyButton").text(this.language.transl(Model.TranslKeys.copy));
        this.initializeTOTP();
    };
    TwoFactorValidation.prototype.initializeTOTP = function () {
        this.initializeTokenInput(this.deferred);
        this.form.find(".validation-code-label").text(this.language.transl(Model.TranslKeys.two_factor_authenticator_code) + ":");
        if (this.twoFactorType !== 999 /* TOTPSetup */) {
            this.initializeTOTPFallbacks(this.deferred);
        }
    };
    TwoFactorValidation.prototype.initializeTOTPFallbacks = function (deferred) {
        var _this = this;
        var that = this;
        this.form.find("#TOTPFallback").show();
        if (!this.supportedFallbacks.Email) {
            this.form.find("#TOTPFallbackText").text(this.language.transl(Model.TranslKeys.two_factor_totp_administrator));
            return;
        }
        var $TOTPFallbackText = this.form.find("#TOTPFallbackText");
        $TOTPFallbackText.text(this.language.transl(Model.TranslKeys.two_factor_totp_fallback));
        var $emailFallbackButton = this.form.find("#FallbackToEmailButton");
        $emailFallbackButton.click(function () {
            _this.twoFactorType = 2 /* Email */;
            handleTokenInput(_this.twoFactorType);
        });
        function handleTokenInput(twoFactorType) {
            //Remove previous submit handlers
            that.form.find("#submitCodeButton").off("click.validate");
            var fallbackAuthenticatedDeferred = jQuery.Deferred();
            //Wait until user has been authenticated with the fallback method
            fallbackAuthenticatedDeferred.always(function () {
                //Remove previous submit handlers
                that.form.find("#submitCodeButton").off("click.validate");
                Utils.hideLoader();
                var promise = ConfirmationPopup.CreateYesNoPopup().initialize(that.language.transl(Model.TranslKeys.login), that.language.transl(Model.TranslKeys.two_factor_email_fallback_action), function (option) {
                    var transl;
                    if (option === Enum.ConfirmationOption.Yes) {
                        transl = that.language.transl(Model.TranslKeys.two_factor_email_fallback_change_device);
                    }
                    else if (option === Enum.ConfirmationOption.No) {
                        transl = that.language.transl(Model.TranslKeys.login);
                    }
                    var element = document.createElement("a");
                    element.href = "#";
                    element.className = "popupBtn";
                    element.setAttribute("data-role", "button");
                    element.setAttribute("data-confirmoption", Enum.ConfirmationOption[option]);
                    element.setAttribute("data-shadow", "false");
                    element.innerText = transl;
                    return element;
                });
                //Hide the overlay that allows users to hide the popup by clicking on the rest of the screen.
                jQuery(".ui-popup-screen.ui-overlay-inherit").hide();
                promise.then(function (option) {
                    if (option === Enum.ConfirmationOption.Yes) {
                        that.twoFactorType = 999 /* TOTPSetup */;
                        setTimeout(function () {
                            that.form.find("#validationCode")[0].value = "";
                            that.initializeTOTPSetup();
                        }, 500);
                    }
                    else if (option === Enum.ConfirmationOption.No) {
                        deferred.resolve();
                    }
                });
            });
            that.initializeEmailAndSms(fallbackAuthenticatedDeferred, twoFactorType);
            $emailFallbackButton.hide();
            $TOTPFallbackText.hide();
        }
        $emailFallbackButton.text(this.language.transl(Model.TranslKeys.two_factor_email_fallback));
        $emailFallbackButton.toggle(this.supportedFallbacks.Email);
    };
    TwoFactorValidation.prototype.initializeTokenInput = function (deferred) {
        var _this = this;
        this.form.find("#submitCodeArea").show();
        this.form.find("#submitCodeButton").show();
        this.form.find("#submitCodeButton").on("click.validate", function (evt) {
            var validationCode = _this.form.find("#validationCode").val();
            if (validationCode) {
                Utils.showLoader();
                var params = _this.client.createParameterCollection();
                params.add("two_factor_token", validationCode);
                if (_this.twoFactorType === 999 /* TOTPSetup */) {
                    params.add("totp_key", _this.form.find("#TOTPKey").val());
                }
                _this.client.invoke(OData.VALIDATE_TWO_FACTOR_TOKEN, "POST", params, function (reader, status) {
                    if (status.request.status === 204) {
                        //Loader doesn't need to be hidden here because it'll be hidden after the applications have been loaded.
                        deferred.resolve();
                    }
                    else {
                        var message = null;
                        if (status.request.status === 401) {
                            message = _this.language.transl(Model.TranslKeys.two_factor_codeinvalid);
                        }
                        else {
                            message = _this.language.transl(Model.TranslKeys.unknownError);
                        }
                        Utils.hideLoader();
                        ConfirmationPopup.CreateOkPopup()
                            .initialize(_this.language.transl(Model.TranslKeys.two_factor_validation_code), message);
                    }
                });
            }
            evt.preventDefault();
            evt.stopPropagation();
        });
    };
    TwoFactorValidation.prototype.convertFromString = function (value) {
        switch (value) {
            case "SMS":
                return 1 /* SMS */;
            case "Email":
                return 2 /* Email */;
            case "TOTP":
                return 3 /* TOTP */;
            case "pending":
                return 998 /* Pending */;
            case "TOTP Setup":
                return 999 /* TOTPSetup */;
        }
        return null;
    };
    return TwoFactorValidation;
}());
